#include <bits/stdc++.h>
#define endl '\n'
#define pii pair <int, int>
using namespace std;

int n, m;
vector < vector <pii> > v;
vector <int> d;
vector <int> pred;
priority_queue <pii, vector <pii>, greater<pii>> pq;
int predtg;
vector <bool> used;

void dijkstra (int s)
{
    d.resize(n + 1);
    pred.resize(n + 1);
    used.resize(n + 1);
    d[s] = 0;
    pq.push({0, s});
    pred[s] = 0;

    while (!pq.empty())
    {
        s = pq.top().second;
        int sdist = pq.top().first;
        pq.pop();

        //cout << sdist << " " << s << endl;
        for (auto t : v[s])
        {
            int tg = t.first;
            if (pred[s] == tg) continue;
            //if (t.second == predind) continue;
            if (tg < pred[s]) continue;
            pred[t.second] = tg;
            //cout << t.first << " " << t.second << endl;
            if (1 + d[s] > d[t.second])
            {
                d[t.second] = 1 + d[s];
                pq.push({d[t.second], t.second});
                predtg = sdist;
            }
        }
    }
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    v.resize(m + 1);
    for (int i = 0; i < m; i++)
    {
        int b, e, tg;
        cin >> b >> e >> tg;
        v[b].push_back({tg, e});
        v[e].push_back({tg, b});
    }

    dijkstra(1);

    for (int i = 1; i <= n; i++)
    {
        cout << d[i] << " ";
    }
}
