#include <iostream>
#include <queue>
#include <bitset>
using namespace std;

queue<pair<bitset<26>, int>> q;

int dye[16][26];

int n;
bool solve (int l, int r) {
    l--;
    r--;
    bool ans = 0;
    bitset<26> st = 0;
    for (int i = l; i <= r; i++) {
        for (int j = 0; j < 26; j++) {
            st[dye[i][j]] = 1;
        }
    }
    q.push(make_pair(st, 0));
    while (!q.empty()) {
        pair<bitset<26>, int> f = q.front();
        bitset<26> curDye = f.first;
        int cur = f.second;
        q.pop();
        if (cur == l - 1) {
            cur = r;
        }
        if (cur >= n - 1) {
            ans = 1;
        }
//        cout << cur << "\n";
//        for (int i = 0; i < 26; i++) {
//            cout << curDye[i];
//        }
//        cout << "\n";
        for (int i = 0; i < 26; i++) {
            if (dye[cur + 1][i] != 0 && !curDye[dye[cur + 1][i]]) {
                curDye[dye[cur + 1][i]] = 1;
                q.push(make_pair(curDye, cur + 1));
                curDye[dye[cur + 1][i]] = 0;
            }
        }
    }
    return ans;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            cin >> dye[i][j];
        }
    }
    int a;
    cin >> a;
    for (int i = 0; i < a; i++) {
        int l, r;
        cin >> l >> r;
        cout << solve(l, r) << "\n";
    }
}
