#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
using namespace std;
#define c second
#define d first

vector<pair<int, int>> edge[100001];
queue<pair<pair<int, int>, int>> q;
int ans[100001];

void bfs() {
    q.push(make_pair(make_pair(0, 0), 0));
    while (!q.empty()) {
        pair<pair<int, int>, int> t = q.front();
        q.pop();
        const int cur = t.first.first;
        const int time = t.first.second;
        const int len = t.second;
        ans[cur] = max(ans[cur], len);
        for (int i = 0; i < edge[cur].size(); i++) {
            if (edge[cur][i].c > time) {
                q.push(make_pair(make_pair(edge[cur][i].d, edge[cur][i].c), len + 1));
            }
        }
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        edge[a].push_back(make_pair(b, c));
        edge[b].push_back(make_pair(a, c));
    }
    bfs();
    for (int i = 0; i < n; i++) {
        cout << ans[i] << " ";
    }
}
