#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N_max = 5e5 + 1;
const int c_max = 1e6 + 1;

int N, Q;
vector <int> graph[N_max];
int l, r;
bool visited[c_max];

bool brute(int le, int ri)
{
    if (le == 1 && ri == N)
    {
        return 1;
    }

    bool f1 = 0, f2 = 0;

    if (le > 1)
    {
        int br = 0;

        for (auto v : graph[le - 1])
        {
            if (visited[v])
            {
                br++;
            }

            visited[v] = 1;
        }

        if (br < graph[le - 1].size())
        {
            f1 = brute(le - 1, ri);

            for (auto v : graph[le - 1])
            {
                visited[v] = 0;
            }
        }
    }

    if (ri < N)
    {
        int br = 0;

        for (auto v : graph[ri + 1])
        {
            if (visited[v])
            {
                br++;
            }

            visited[v] = 1;
        }

        if (br < graph[ri + 1].size())
        {
            f2 = brute(le, ri + 1);

            for (auto v : graph[ri + 1])
            {
                visited[v] = 0;
            }
        }
    }

    if (f1 || f2)
    {
        return 1;
    }

    return 0;
}

void reset(int maxi)
{
    for (int i = 1; i <= maxi; i++)
    {
        visited[i] = 0;
    }
}

void solve()
{
    int maxi = 0;
    bool _break = 0;

    for (int i = l; i <= r; i++)
    {
        int br = 0;

        for (auto q : graph[i])
        {
            if (visited[q])
            {
                br++;
            }

            visited[q] = 1;
            maxi = max(maxi, q);
        }

        if (br == graph[i].size())
        {
            _break = 1;
        }
    }

    if (_break)
    {
        cout << 0 << endl;

        reset(maxi);

        return;
    }

    cout << brute(l, r) << endl;

    reset(maxi);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> N;

    for (int i = 1; i <= N; i++)
    {
        int k, c;

        cin >> k;

        for (int q = 1; q <= k; q++)
        {
            cin >> c;

            graph[i].push_back(c);
        }
    }

    cin >> Q;

    while (Q--)
    {
        cin >> l >> r;

        solve();
    }

    return 0;
}
