#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N_max = 1e5 + 1;
const int M_max = 1e6 + 1;

int N, M;
vector < pair <int, int> > graph[N_max];

/*struct info
{
    int prevWeight;
    int node;
    int br;
};*/

priority_queue < tuple <int, int, int> > pq;
int ans[N_max];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> N >> M;

    for (int i = 1; i <= M; i++)
    {
        int a, b, c;

        cin >> a >> b >> c;

        graph[a].push_back({b, c});
        graph[b].push_back({a, c});
    }

    pq.push({0, 1, 0});

    while (!pq.empty())
    {
        auto fr = pq.top();

        pq.pop();

        for (auto v : graph[get<1>(fr)])
        {
            if (v.second > get<0>(fr))
            {
                pq.push({v.second, v.first, get<2>(fr)+ 1});
                //cout << "push: " << v.second << " " << v.first << " " << get<2>(fr) + 1 << endl;
                ans[v.first] = max(ans[v.first], get<2>(fr) + 1);
            }
        }
    }

    for (int i = 1; i <= N; i++)
    {
        cout << ans[i] << " ";
    }

    cout << endl;

    return 0;
}
