#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN = 5e5 + 10;
const ll MAXK = 1e6 + 2e5 + 10;
const ll MAXC = 1e6 + 10;

ll n,q;
vector < ll > c[MAXN];
ll used[MAXC];
ll maxcol;
ll mincol = MAXC;

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        ll k;
        cin >> k;
        for(int j = 1; j <= k; j++)
        {
            ll col;
            cin >> col;
            c[i].push_back(col);
            maxcol = max(maxcol, col);
            mincol = min(mincol, col);
        }
        sort(c[i].begin(), c[i].end());
    }
}

bool bruteforce(ll left, ll right)
{
    if(left == 1 && right == n)
        return true;

    if(left > 1)
    {
        ll k = c[left - 1].size();
        bool lampa = false;
        for(int i = 0; i < k; i++)
        {
            ll col = c[left - 1][i];

            if(!used[col])
                lampa = true;

            used[col]++;
        }
        if(lampa)
        {
            if(bruteforce(left - 1, right))
                return true;

        }
        for(int i = 0; i < k; i++)
        {
            ll col = c[left - 1][i];
            used[col]--;
        }
    }
    if(right < n)
    {
        ll k = c[right + 1].size();
        bool lampa = false;
        for(int i = 0; i < k; i++)
        {
            ll col = c[right + 1][i];

            if(!used[col])
                lampa = true;

            used[col]++;
        }
        if(lampa)
        {
            if(bruteforce(left, right + 1))
                return true;

        }
        for(int i = 0; i < k; i++)
        {
            ll col = c[right + 1][i];
            used[col]--;
        }
    }
    return false;
}

bool query(ll left, ll right)
{
    for(int i = mincol; i <= maxcol; i++)
    {
        used[i] = 0;
    }
    for(int i = left; i <= right; i++)
    {
        ll k = c[i].size();
        for(int j = 0; j < k; j++)
        {
            ll col = c[i][j];
            used[col]++;
        }
    }
    return bruteforce(left, right);
}

void process_queries()
{
    cin >> q;
    for(int i = 1; i <= q; i++)
    {
        ll left, right;
        cin >> left >> right;
        cout << query(left, right) << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    process_queries();

    return 0;
}
