#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e4 + 1;
const int MAXM = 1e6 + 1;
int N, M;
vector<tuple<int, int, int>> Edges;
int dp[MAXN];

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < M; i++)
    {
        int U, V, W; cin >> U >> V >> W;
        Edges.push_back({W, U, V});
    }

    sort(Edges.begin(), Edges.end());
}


void Solve()
{
    dp[1] = 1;

    for(int i = 0; i < M; i++)
    {
        int U, V, W;
        tie(W, U, V) = Edges[i];
        int A = dp[U], B = dp[V];

        if(A > 0)
        {
            dp[V] = max(dp[V], A + 1);
        }

        if(B > 0)
        {
            dp[U] = max(dp[U], B + 1);
        }
    }

    for(int i = 1; i <= N; i++)
    {
        cout << dp[i] - 1 << " ";
    }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}

