#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << "; "
// #define cerr if (false) cerr

const int INF = 1e9 + 10;
const int MAX_N = 5 * 1e5 + 10;
const int MAX_COLOR = 1e6 + 10;
int n;
int a[MAX_N];
vector <int> colors[MAX_N];
bool used[MAX_COLOR];

void ta(int x) {
    for (int i = 0; i < x; i ++) cout << "\t";
}

bool solve (int l, int r, int depth) {
    if (l == 0 && r == n - 1) {
        return true;
    }
    //ta(depth);
    //cout << "In for " << out(l) << out(r) << endl;
    if (l - 1 >= 0) {
        for (int pC = 0; pC < colors[l - 1].size(); pC ++) {
            int currentColor = colors[l - 1][pC];

            //ta(depth);cout << "Index " << l - 1 << " has a color " << currentColor << endl;
            if (used[currentColor]) continue;
            //ta(depth);cout << "Trying " << out(currentColor) << "for " << out(l - 1) << endl;
            used[currentColor] = true;
            bool worked = solve (l - 1, r, depth + 1);
            if (worked) {
                //ta(depth);cout << "WORKED" << endl;
                return true;
            }
            used[currentColor] = false;
        }
    }

    if (r + 1 < n) {
        for (int pC = 0; pC < colors[r + 1].size(); pC ++) {
            int currentColor = colors[r + 1][pC];
            //ta(depth);cout << "Index " << r + 1 << " has a color " << currentColor << endl;
            if (used[currentColor]) continue;

            used[currentColor] = true;
            //ta(depth);cout << "Trying " << out(currentColor) << "for " << out(r + 1) << endl;

            bool worked = solve (l, r + 1, depth + 1);

            if (worked) {
                //ta(depth);cout << "WORKED" << endl;
                return true;
            }

            used[currentColor] = false;
        }
    }

    return false;
}

int main () {


    cin >> n;

    for (int i = 0; i < n; i ++) {
        int k; cin >> k;
        for (int j = 0; j < k; j ++) {
            int c;
            cin >> c;

            colors[i].push_back(c);
        }
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; i ++) {
        int l, r; cin >> l >> r;
        l --; r --;

        for (int j = l; j <= r; j ++) {
            for (int z = 0; z < colors[j].size(); z ++) {
                used[colors[j][z]] = true;
                //cout << "Marking " << colors[j][z] << " as used" << endl;

            }
        }

        cout << solve (l, r, 0) << endl;

        for (int j = 0; j < MAX_COLOR; j ++) {
            used[j] = false;
        }
    }

    return 0;
}

