#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX=(1e6)+5;

int n;
set<int>s[MAX],u;
vector<int>v[MAX];

void Init(int l,int r)
{
    u.clear();
    for(int i=1;i<=n;i++)
        s[i].clear();
    for(int i=1; i<l; i++)
    {
        for(int j=0; j<v[i].size(); j++)
        {
            s[i].insert(v[i][j]);
        }
    }
    for(int i=r+1; i<=n; i++)
    {
        for(int j=0; j<v[i].size(); j++)
        {
            s[i].insert(v[i][j]);
        }
    }
    for(int i=l; i<=r; i++)
    {
        for(int j=0; j<v[i].size(); j++)
        {
            u.insert(v[i][j]);
        }
    }

}

void Process(int x,int y,int z)
{
    for(auto it = s[y].begin(); it!=s[y].end(); ++it)
    {
        u.insert(*it);
    }
    if(1<=z&&z<=n)
    {
        vector<int>v;
        for(auto it = s[z].begin(); it!=s[z].end(); ++it)
        {
            if(u.find(*it)!=u.end())
                v.push_back(*it);
        }
        for(int i=0;i<v.size();i++)
        {
            s[z].erase(v[i]);
        }
    }

    if(1<=x&&x<=n)
    {
        vector<int>v;
        for(auto it = s[x].begin(); it!=s[x].end(); ++it)
        {
            if(u.find(*it)!=u.end())
                v.push_back(*it);
        }
        for(int i=0;i<v.size();i++)
        {
            s[x].erase(v[i]);
        }
    }
}

void Solve()
{
    cin>>n;
    int x,z,l,r,q;
    for(int i=1; i<=n; i++)
    {
        cin>>x;
        for(int j=0; j<x; j++)
        {
            cin>>z;
            v[i].push_back(z);
        }
    }
    cin>>q;
    bool b;
    for(int i=0; i<q; i++)
    {
        cin>>l>>r;
        Init(l,r);
        b=1;
        while(l>1||r<n)
        {
            //cout<<l<<" "<<r<<endl;
            if(l==1||s[l-1].size()>s[r+1].size())
            {
                r++;
                if(s[r].size()==0)
                {
                    b=0;
                    break;
                }
                Process(l-1,r,r+1);
            }
            else
            {
                l--;
                if(s[l].size()==0)
                {
                    b=0;
                    break;
                }
                Process(l-1,l,r+1);
            }

        }
        cout<<b<<endl;
    }
}

signed main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    Solve();
    return 0;
}

/*
4
1 1
1 2
1 1
2 3 4
5
4 4
3 4
2 2
3 3
1 3*/
