#include <iostream>
#include <set>
#include <vector>

using namespace std;

int n;
vector<set<int> > v;

bool check(set<int> remaining, int a)
{
	for (auto val : v[a])
	{
		if (remaining.find(val)!=remaining.end())
		{
			return true;
		}
	}
	return false;
}

int com(set<int> remaining, int a)
{
	int sum=0;
	for (auto val : v[a])
	{
		if (remaining.find(val)!=remaining.end())
		{
			sum++;
		}
	}
	return sum;
}

int main()
{
	cin>>n;
	v.resize(n+1);
	for (int i=1; i<=n; i++)
	{
		int a;
		cin>>a;
		for (int j=0; j<a; j++)
		{
			int c;
			cin>>c;
			v[i].insert(c);
		}
	}
	int q;
	cin>>q;
	while (q--)
	{
		int l, r;
		cin>>l>>r;
		set<int> painted;
		set<int> remaining;
		for (int j=1; j<=n; j++)
		{
			remaining.insert(j);
		}
		for (int j=l; j<=r; j++)
		{
			painted.insert(j);
			for (auto val : v[j])
				remaining.erase(val);
		}
		bool bl=true;
		while (painted.size()!=n)
		{
			int a;
			if (l==1)
			{
				r++;
				a=r;
			}
			else if (r==n)
			{
				l--;
				a=l;
			}
			else
			{
				if (com(remaining, l-1)>com(remaining, r+1))
				{
					r++;
					a=r;
				}
				else
				{
					l--;
					a=l;
				}
			}
			if (!check(remaining, a))
			{
				bl=false;
				break;
			}
			else
			{
				painted.insert(a);
				for (auto val : v[a])
				{
					if (remaining.find(val)!=remaining.end())
						remaining.erase(val);
				}
			}
		}
		if (bl==true)
			cout<<1<<endl;
		else
			cout<<0<<endl;
	}
	
	return 0;
}