#include <bits/stdc++.h>
#include "twins.h"
using namespace std;

#define ll long long
#define pb push_back
#define MP make_pair

vector <int> answer;

void solve_for_30(int L, int R, int N){
    //cout << L << ' ' << R << endl; 
    int l, r;
    vector <vector <int> > G((N + 3) / 4);
    for(int i = L; i <= R; i++){
        G[(i - L) / 4].pb(i);
    }

    string result = guess(G);

    for(int i = 0; i < result.size(); i++){
        if(result[i] == '1'){
            l = i * 4 + L;
            break;
        }
    }

    for(int i = 0; i < G.size(); i++){
        G[i].clear();
    }

    if(l + 1 > R){
        answer.pb(l); return;
    }

    G[0].pb(l); G[0].pb(l + 1);
    result = guess(G);
    if(result[0] == '1'){
        G[0].clear(); G[0].pb(l);
        result = guess(G);

        if(result[0] == '1'){
            answer.pb(l);
        }
        else{
            answer.pb(l + 1);
        }
    }
    else{
        G[0].clear(); G[0].pb(l + 2);
        result = guess(G);

        if(result[0] == '1'){
            answer.pb(l + 2);
        }
        else{
            answer.pb(l + 3);
        }
    }

}

vector <int> play (int N, int T){
    if(N <= 30){
        solve_for_30(1, N, N);
    }
    else{
        int bottom = 1, top = N, ans;
        while(bottom <= top){
            int mid  =(bottom + top) / 2;
            vector <int> g;
            for(int i = bottom; i <= mid; i++){
                g.pb(i);
            }
            vector <vector <int> > G; G.pb(g);
            if(guess(G) == "1"){
                top = mid - 1;
                ans = mid;
            }
            else{
                bottom = mid + 1;
            }
        }
        answer.pb(ans);
    }

    return answer;
}