#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(),x.end()
#define sz(x) int(x.size())
const int N = 1e5;
int n, m, dp[N], nxt[N];
vector<pair<int, int>> adj[N];
vector<array<int, 3>> eds;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        --u, --v;
        adj[u].pb({v, c});
        adj[v].pb({u, c});
        eds.pb({c, u, v});
    }
    for (int i = 1; i < n; i++) {
        dp[i] = nxt[i] = -1e9;
    }
    sort(all(eds));
    for (int i = 0; i < m; i++) {
        int cur = eds[i][0];
        int j = i;
        while (j+1 < m && eds[j+1][0] == cur)j++;
        for (int k = i; k <= j; k++) {
            int u = eds[k][1], v = eds[k][2];
            nxt[u] = max(nxt[u], dp[v]+1);
            nxt[v] = max(nxt[v], dp[u]+1);
        }
        for (int k = i; k <= j; k++) {
            int u = eds[k][1], v = eds[k][2];
            dp[u] = max(dp[u], nxt[u]);
            dp[v] = max(dp[v], nxt[v]);
        }
        i = j;
    }
    for (int i = 0; i < n; i++) {
        cout << max(0, dp[i]) << " ";
    }
}