#include <iostream>
#include <vector>
#include <set>
using namespace std;

int main () {
    int n = 0;
    cin >> n;

    vector <vector <int> > paints;
    paints.resize (n + 1);
    for (int i = 1; i <= n; i++) {
        int t = 0;
        cin >> t;

        paints[i].resize (t);

        for (int j = 0; j < t; j++)
            cin >> paints[i][j];
    }

    vector <bool> used (n);
    int l = 0, r = 0;
    cin >> l >> r;

    for (int i = l; i <= r; i++)
        for (int e : paints[i])
            used[e] = 1;
    
    while (l > 1 || r < n) {
        int nl = 0;
        if (l - 1 >= 1)
            for (int e : paints[l - 1])
                if (!used[e])
                    nl++;

        int nr = 0;
        if (r + 1 <= n)
            for (int e : paints[r + 1])
                if (!used[e])
                    nr++;
        
        //cout << nl << ' ' << nr << ' ' << l << ' ' << r << '\n';
        
        if (nr == 0 && r < n) {
            cout << 0 << '\n';
            return 0;
        }

        if (nl == 0 && l > 1) {
            cout << 0 << '\n';
            return 0;
        }

        if (l - 1 >= 1 && (nl < nr || r + 1 > n)) {
            for (int e : paints[l - 1])
                used[e] = 1;
            l--;
        } else {
            for (int e : paints[r + 1])
                used[e] = 1;
            r++;
        }
    }

    cout << 1 << '\n';
}