#include "twins.h"
#include <vector>
#include <climits>
using namespace std;

vector <int> play (int N, int T) {
    if (T == 1) {
        int bias = -1;
        {
            int bstval = INT_MAX;
            for (int i = 1; i <= N; i++) {
                if (N % i != 0)
                    continue;

                int val = N / i + i - 1;
                if (bstval > val)
                    bias = i, bstval = val;
            }
        }
        
        vector <vector <int> > v;
        for (int t = 1; t < bias; t++) {
            vector <int> a;
            for (int i = t; i <= N; i += bias)
                a.push_back (i);
            v.push_back (a);
        }

        for (int i = 1; i <= N; i += bias) {
            vector <int> a (bias);
            for (int j = 0; j < bias; j++)
                a[j] = i + j;
            v.push_back (a);
        }

        // for (vector <int> e : v) {
        //     for (int e1 : e)
        //         cout << e1 << ' ';
        //     cout << '\n';
        // }

        string str = guess (v);
        int ind1 = bias - 1;
        for (int i = 0; i < bias - 1; i++)
            if (str[i] == '1') {
                ind1 = i;
                break;
            }
        
        for (int i = bias - 1; i < str.size(); i++)
            if (str[i] == '1')
                return {v[i][ind1]};

    } else {
        return {6, 5};
    }
}