#include "twins.h"
#include <vector>
#include <climits>
#include <math.h>
#include <set>
using namespace std;

vector <long long> play (long long N, long long T) {
    if (T == 1) {
        long long bias = -1;
        {
            long long bstval = INT_MAX;
            for (long long i = 1; i <= N; i++) {
                long long val = ceil (N * 1.0f / i) + i;
                if (bstval > val)
                    bias = i, bstval = val;
            }
        }
        
        vector <vector <long long> > v;
        for (long long t = 1; t < bias; t++) {
            vector <long long> a;
            a.reserve (N / t + 1);
            for (long long i = t; i <= N; i += bias)
                a.push_back (i);
            v.push_back (a);
        }

        for (long long i = 1; i <= N; i += bias) {
            vector <long long> a;
            a.reserve (bias);
            for (long long j = 0; j < bias && i + j <= N; j++)
                a.push_back (i + j);
            v.push_back (a);
        }

        // for (vector <long long> e : v) {
        //     for (long long e1 : e)
        //         cout << e1 << ' ';
        //     cout << '\n';
        // }

        string str = guess (v);
        long long ind1 = bias - 1;
        for (long long i = 0; i < bias - 1; i++)
            if (str[i] == '1') {
                ind1 = i;
                break;
            }
        
        for (long long i = bias - 1; i < str.size(); i++)
            if (str[i] == '1')
                return {v[i][ind1]};
    } else {
        long long bias = -1;
        {
            long long bstval = INT_MAX;
            for (long long i = 1; i <= N; i++) {
                long long val = 2 * ceil (N * 1.0f / i) + i;
                if (bstval > val)
                    bias = i, bstval = val;
            }
        }
        
        vector <vector <long long> > v;
        for (long long t = 1; t <= bias; t++) {
            vector <long long> a;
            a.reserve (N / t + 1);
            for (long long i = t; i <= N; i += bias)
                a.push_back (i);
            v.push_back (a);
        }

        for (long long i = 1; i <= N; i += bias) {
            vector <long long> a;
            a.reserve (bias);
            for (long long j = 0; j < bias && i + j <= N; j++)
                a.push_back (i + j);
            v.push_back (a);
        }

        v.push_back ({3});
        v.push_back ({2, 6});

        for (long long i = 1; i <= N; i += bias) {
            vector <long long> a;
            a.reserve (bias);
            for (long long j = 0; j < bias && i + j * bias + j <= N; j++)
                a.push_back (i + j * bias + j);
            v.push_back (a);
        }

        // for (vector <long long> e : v) {
        //     for (long long e1 : e)
        //         cout << e1 << ' ';
        //     cout << '\n';
        // }

        string str = guess (v);
        long long ind1 = -1, ind2 = -1;
        for (long long i = 0; i < bias; i++)
            if (str[i] == '1') {
                if (ind1 == -1)
                    ind1 = i;
                else
                    ind2 = i;
                
                if (ind1 != -1 && ind2 != -1)
                    break;
            }

        set <long long> pos;
        for (long long i = bias; i < bias + ceil(N * 1.0f / bias); i++)
            if (str[i] == '1') {
                pos.insert(v[i][ind1]);
                if (ind2 != -1)
                    pos.insert(v[i][ind2]);
            }
        
        if (pos.size() == 2)
            return {*pos.begin(), *(--pos.end())};
        
        // cout << '\t';
        // for (long long e : pos)
        //     cout << e << ' ';
        // cout << '\n';
        
        for (long long i = bias + ceil(N * 1.0f / bias); i < str.size(); i++)
            if (str[i] != '1') {
            
                for (long long e : v[i])
                    pos.erase (e);

                if (pos.size() == 2)
                    return {*pos.begin(), *(--pos.end())};
            }
    }
}