#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
vector<vector<int>> gr;
vector<char> used;
bool dfs(int u) {
    used[u] = 1;
    for (int v : gr[u]) {
        if (used[v] == 1) {
            return true;
        }
        if (used[v] == 0 && dfs(v)) {
            return true;
        }
    }
    used[u] = 2;
    return false;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> cols;
    for (int i = 0; i < n; ++i) {
        int ki;
        cin >> ki;
        a[i].resize(ki);
        for (int j = 0; j < ki; ++j) {
            cin >> a[i][j];
            cols.push_back(a[i][j]);
        }
    }
    // For each color save positions (in sorted order) where is this color.
    vector<vector<int>> pos(1000010);
    for (int i = 0; i < n; ++i) {
        for (int j : a[i]) {
            pos[j].push_back(i);
        }
    }
    // For each i save minimal j, when i can be added after a segment [i+1, j]
    vector<int> bR(n), bL(n);
    for (int i = 0; i < n; ++i) {
        bR[i] = i;
        bL[i] = i;
        for (int j : a[i]) {
            auto it = lower_bound(pos[j].begin(), pos[j].end(), i);
            if (it + 1 != pos[j].end()) {
                bR[i] = max(bR[i], *(it + 1) - 1);
            } else {
                bR[i] = n - 1;
            }
            if (it != pos[j].begin()) {
                bL[i] = min(bL[i], *(it - 1) + 1);
            } else {
                bL[i] = 0;
            }
        }
    }
    int q;
    cin >> q;
    for (int t = 0; t < q; ++t) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        bool ok = true;
        for (int i = 0; i < l; ++i) {
            if (bR[i] < r) {
                ok = false;
                break;
            }
        }
        for (int i = r + 1; i < n; ++i) {
            if (bL[i] > l) {
                ok = false;
                break;
            }
        }
        gr.assign(n, vector<int>());
        used.assign(n, 0);
        for (int i = 0; i < l; ++i) {
            if (i != l - 1) {
                gr[i + 1].push_back(i);
            }
            if (bR[i] < n - 1) {
                gr[i].push_back(bR[i] + 1);
            }
        }
        for (int i = r + 1; i < n; ++i) {
            if (i != r + 1) {
                gr[i - 1].push_back(i);
            }
            if (bL[i] > 0) {
                gr[i].push_back(bL[i] - 1);
            }
        }
        for (int i = 0; i < n; ++i) {
            if (!used[i] && dfs(i)) {
                ok = false;
                break;
            }
        }
        cout << ok << "\n";
    }
}
