#include <bits/stdc++.h>
using namespace std;

vector<vector<pair<int, int>>> gr;
vector<int> ans;

void dfs(int u, int p, int d, int t) {
    ans[u] = d;
    for (auto [v, c] : gr[u]) {
        if (v != p && c > t) {
            dfs(v, u, d + 1, c);
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    ans.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        gr[u].emplace_back(v, c);
        gr[v].emplace_back(u, c);
    }
    dfs(0, -1, 0, -1);
    for (int el : ans) {
        cout << el << " ";
    }
    cout << "\n";
}