#include <bits/stdc++.h>

using namespace std;

int cur_used = 1;
vector<vector<int>> gr_l;
vector<int> match, used;
vector<bool> used_right;

bool dfs(int i) {
    if (used[i] == cur_used) {
        return false;
    }
    //cout << i << endl;
    for (auto j : gr_l[i]) {
        if (used_right[j]) {
            continue;
        }
        if (match[j] == -1 || dfs(match[j])) {
            match[j] = i;
            return true;
        }
    }
    return false;
}

int main() {
    int n;
    cin >> n;
    gr_l.resize(n);
    used.resize(n, 0);
    int ma = 0;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        gr_l[i].resize(k);
        for (auto &j : gr_l[i]) {
            cin >> j;
            ma = max(ma, j);
            j--;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        match.assign(ma, -1);
        used_right.assign(ma, false);
        int l, r;
        cin >> l >> r;
        l--;
        for (int i = l; i < r; i++) {
            for (auto j : gr_l[i]) {
                //cout << j << endl;
                used_right[j] = true;
            }
        }
        //cout << __LINE__ << endl;
        int ans = 1;
        for (int i = 0; i < l; i++) {
            if (!dfs(i)) {
                ans = 0;
                break;
            }
            cur_used++;
        }
        for (int i = r; i < n; i++) {
            if (ans == 0 || !dfs(i)) {
                ans = 0;
                break;
            }
            cur_used++;
        }
        cout << ans << endl;
    }
}