#include<bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = (1e5)+31;

int dist[MAXN];
int save[MAXN];

map<int, vector<pair<int, int>>> edges;

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++) dist[i] = -1;
    dist[0] = 0;
    set<int> cs;
    for(int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        //edges.push_back(make_pair(c, make_pair(a, b)));
        cs.insert(c);
        edges[c].push_back({a, b});
    }
    for(auto c : cs){
        for(auto [a, b] : edges[c]){
            save[a] = dist[a];
            save[b] = dist[b];
        }
        for(auto [a, b] : edges[c]){
            if(save[a] != -1){
                dist[b] = max(dist[b], save[a]+1);
            }
            if(save[b] != -1){
                dist[a] = max(dist[a], save[b]+1);
            }
        }
    }
    for(int i = 0; i < n; i++){
        cout << max(0ll, dist[i]) << " ";
    }
}
