#include <bits/stdc++.h>

using namespace std;

#define all(x) X.begin(), x.end();

#define debug(x)
#ifdef LOC
#define debug(x) cout << #x << " = " << x << '\n';
#endif

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;

        for (int j = 0; j < m; ++j) {
            int x;
            cin >> x;
            v[i].push_back(x - 1);
        }
    }

    int q;
    cin >> q;

    

    for (int i = 0; i < q; ++i) {
        set<int> clrs;

        for (int i = 0; i < n; ++i) {
            clrs.insert(i);
        }

        int l, r;
        cin >> l >> r;
        l--;

        for (int j = l; j < r; ++j) {
            for (int c : v[j]){
                debug(c);
                clrs.erase(c);
            }
        }
        bool f = 1;

        while (l > 0 || r < n) {
            int lsm = 0;
            if (l == 0) lsm = INF;
            else for (int c : v[l - 1]) {
                    lsm += clrs.count(c);
                }
            int rsm = 0;
            if (r == n) rsm = INF;
            else for (int c : v[r]) {
                    rsm += clrs.count(c);
                }
            debug(l << " " << r);
            debug(lsm << " " << rsm);
            // for (int i : clrs)
            //     cout << i << " ";
            // cout << '\n';

            int mn = min(lsm, rsm);
            if (mn == 0) {
                f = 0;
                break;
            }



            if (lsm < rsm) {
                l--;
                for (int c : v[l]) {
                    clrs.erase(c);
                }
            } else {
                for (int c : v[r]) {
                    clrs.erase(c);
                }
                r++;
            }
        }

        cout << int(f) << '\n';
    }
}

int main() {
    int q = 1;
#ifdef LOC
    cin >> q;
#endif

    for (int i = 0; i < q; ++i) solve(); 
}