#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
#include "twins.h"
//int ans1 = 2, ans2 = 10;
//
//string guess(vector<vector<int>>& q) {
//    string s = "";
//    for (auto i : q) {
//        bool f = false;
//        for (auto j : i) {
//            if (j == ans1 || j == ans2) {
//                s += '1';
//                f = true;
//                break;
//            }
//        }
//        if (!f) s += '0';
//    }
//    return s;
//}
string guess(vector<vector<int>>& q);

vector<int> play(int n, int t) {
    if (t == 1) {
        vector<vector<int>> q;
        for (int l = 0; (1 << l) < n; ++l) {
            int len = 1 << l;
            q.push_back({});
            for (int i = len; i < n; i += len * 2) {
                for (int j = i; j < i + len && j < n; ++j) {
                    q.back().push_back(j + 1);
                }
            }
        }
        string s = guess(q);
        int ind = 0;
        for (int i = 0; i < s.size(); ++i) {
            if (s[i] == '1') ind |= (1 << i);
        }
        return { ind + 1 };
    }
    else {
        vector<vector<int>> q;
        int lg = log2(n * 2 - 1);
        for (int l = 0; (1 << l) < n; ++l) {
            int len = 1 << l;
            q.push_back({});
            for (int i = 0; i < n; i += len * 2) {
                for (int j = i; j < i + len && j < n; ++j) {
                    q.back().push_back(j + 1);
                }
            }
            q.push_back({});
            for (int i = len; i < n; i += len * 2) {
                for (int j = i; j < i + len && j < n; ++j) {
                    q.back().push_back(j + 1);
                }
            }
            for (int last = l + 1; last < lg; ++last) {
                q.push_back({});
                for (int i = len; i < n; i += len * 2) {
                    if ((i / (1 << last)) % 2 == 0) continue;
                    for (int j = i; j < i + len && j < n; ++j) {
                        q.back().push_back(j + 1);
                    }
                }
                q.push_back({});
                for (int i = len; i < n; i += len * 2) {
                    if ((i / (1 << last)) % 2 == 1) continue;
                    for (int j = i; j < i + len && j < n; ++j) {
                        q.back().push_back(j + 1);
                    }
                }
            }
        }
        string s = guess(q);
        vector<vector<bool>> a;
        int curlen = 2;
        for (int i = s.size() - 1; i >= 0; ) {
            a.push_back({});
            int c = curlen;
            for (; c--; i--) {
                a.back().push_back(s[i] == '1');
            }
            reverse(a.back().begin(), a.back().end());
            curlen += 2;
        }
        reverse(a.begin(), a.end());
        vector<int> ans;
        int ind = 0;
        for (int b = lg - 1; b >= 0; --b) {
            if (a[b][0] && a[b][1]) {
                int ind1 = ind, ind2 = ind | (1 << b);
                for (int i = b - 1; i >= 0; --i) {
                    if (a[i][(b - i) * 2]) {
                        ind1 |= (1 << i);
                    }
                }
                for (int i = b - 1; i >= 0; --i) {
                    if (a[i][(b - i) * 2 + 1]) {
                        ind2 |= (1 << i);
                    }
                }
                ans = { ind1 + 1, ind2 + 1 };
                break;
            }
            else if (a[b][1]) {
                ind |= (1 << b);
            }
        }
        return ans;
    }
}



void solve() {
    int n, t;
    cin >> n >> t;
    auto a = play(n, t);
    cout << a[0] << ' ' << a[1];
}



//signed main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
//    //freopen("coloring.in", "r", stdin);
//    //freopen("coloring.out", "w", stdout);
//
//    //ld time1 = clock();
//
//    int tt = 1;
//    //cin >> tt;
//    while (tt--) {
//        solve();
//        cout << '\n';
//        cout.flush();
//    }
//
//    //ld time2 = clock();
//    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
//    return 0;
//}
