#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
struct edge {
    int to, w, ind;
};
struct edge2 {
    int x, y, w;
};
bool cmp2(edge2 a, edge2 b) {
    return a.w < b.w;
}

const int N = 100000, M = 1000000;
int n, m;
edge2 edges[M];
int dp[N];

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w;
        --x, --y;
        edges[i] = { x, y, w };
    }
    sort(edges, edges + m, cmp2);
    fill(dp, dp + n, -1);
    dp[0] = 0;
    for (int i = 0; i < m; ++i) {
        int l = i;
        vector<pair<int, int>> vals;
        vals.push_back({ edges[i].x, dp[edges[i].x] });
        vals.push_back({ edges[i].y, dp[edges[i].y] });
        while (i + 1 < m && edges[i + 1].w == edges[l].w) {
            ++i;
            vals.push_back({ edges[i].x, dp[edges[i].x] });
            vals.push_back({ edges[i].y, dp[edges[i].y] });
        }
        for (int j = 0; j < vals.size(); j += 2) {
            if (vals[j].second != -1) dp[vals[j + 1].first] = max(dp[vals[j + 1].first], vals[j].second + 1);
            if (vals[j + 1].second != -1) dp[vals[j].first] = max(dp[vals[j].first], vals[j + 1].second + 1);
        }
    }
    for (int v = 0; v < n; ++v) {
        if (dp[v] == -1) cout << 0 << ' ';
        else cout << dp[v] << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("coloring.in", "r", stdin);
    //freopen("coloring.out", "w", stdout);

    //ld time1 = clock();

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
        cout.flush();
    }

    //ld time2 = clock();
    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
    return 0;
}
