#include<iostream>
#include<vector>
#include<set>

using namespace std;

int n;
vector<int> used(1e6);
vector<vector<int>> a;
vector<vector<bool>> is_good;

void rec(int l, int r) {
	is_good[l][r] = true;
	if (l == r) {
		return;
	}
	bool good = false;
	for (auto &i : a[l]) {
		used[i]--;
		if (used[i] == 0) {
			good = true;
		}
	}
	if (good) {
		rec(l + 1, r);
	}
	for (auto &i : a[l]) {
		used[i]++;
	}
	good = false;
	for (auto &i : a[r]) {
		used[i]--;
		if (used[i] == 0) {
			good = true;
		}
	}
	if (good) {
		rec(l, r - 1);
	}
	for (auto &i : a[r]) {
		used[i]++;
	}
}

int main() {
	cin >> n;
	a.resize(n);
	is_good.resize(n);
	for (auto &i : is_good) {
		i.resize(n);
	}
	for (auto &i : a) {
		int k;
		cin >> k;
		i.resize(k);
		for (auto &j : i) {
			cin >> j;
			used[j]++;
		}
	}
	rec(0, n - 1);
	int q;
	cin >> q;
	while (q--) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		cout << is_good[l][r] << endl;
	}
}