#include<iostream>
#include<vector>
#include<set>

using namespace std;

int n;
int used[1000000];
vector<vector<int>> a;
map<pair<long long, long long>, bool> is_good;
vector<pair<long long, long long>> all_q;

void rec(int l, int r) {
	bool need = false;
	for (auto &i : all_q) {
		if (l <= i.first || i.second < r) {
			need = true;
		}
		if (l < i.first || i.second <= r) {
			need = true;
		}
	}
	if (!need) {
		return;
	}
	is_good[l][r] = true;
	if (l == r) {
		return;
	}
	bool good = false;
	for (auto &i : a[l]) {
		used[i]--;
		if (used[i] == 0) {
			good = true;
		}
	}
	if (good) {
		if (!is_good[l + 1][r]) {
			rec(l + 1, r);
		}
	}
	for (auto &i : a[l]) {
		used[i]++;
	}
	good = false;
	for (auto &i : a[r]) {
		used[i]--;
		if (used[i] == 0) {
			good = true;
		}
	}
	if (good) {
		if (!is_good[l][r - 1]) {
			rec(l, r - 1);
		}
	}
	for (auto &i : a[r]) {
		used[i]++;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	a.resize(n);
	is_good.resize(n);
	for (auto &i : is_good) {
		i.resize(n);
	}
	for (auto &i : used) {
		i = 0;
	}
	for (auto &i : a) {
		int k;
		cin >> k;
		i.resize(k);
		for (auto &j : i) {
			cin >> j;
			used[j]++;
		}
	}
	int q;
	cin >> q;
	while (q--) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		all_q.push_back({l, r});
	}
	rec(0, n - 1);
	for (auto &i : all_q) {
		cout << is_good[i.first][i.second] << endl;
	}
}