#include<iostream>
#include<vector>
#include<string>
#include "twins.h"

using namespace std;

vector<int> play(int N,int T){
    if (T == 1) {
        vector<vector<int>> only_question = {};
        for (int i = 0; i < 16; i++) {
            only_question.push_back({});
            for (int j = 1; j <= N; j++) {
                if (j & (1 << i)) {
                    only_question[i].push_back(j);
                }
            }
        }
        string all = guess(only_question);
        int ans = 0;
        for (int i = 0; i < 16; i++) {
            if (all[i] == '1') {
                ans += (1 << i);
            }
        }
        return {ans};
    }
    int SZ = 354;
    vector<vector<int>> first_question = {};
    for (int i = 0; i < N; i += SZ) {
        first_question.push_back({});
        for (int j = i; j < min(i + SZ, N); j++) {
            first_question.back().push_back(j + 1);
        }
    }
    string all = guess(first_question);
    int ind = 0;
    vector<vector<int>> second_question = {};
    for (int i = 0; i < N; i += SZ) {
        if (all[ind] == '1') {
            for (auto &j : first_question[ind]) {
                second_question.push_back({j});
            }
        }
        ind++;
    }
    all = guess(first_question);
    vector<int> ans;
    for (int i = 0; i < second_question.size(); i++) {
        if (all[i] == '1') {
            ans.push_back(second_question[i][0]);
        }
    }
    return ans;
}
