#include <bits/stdc++.h>

using namespace std;

int result = 0;

struct node {
	node(int a, int b) {
		to = a;
		c = b;
	}

	int to;
	int c;
};

void dfs(const vector<vector<node>>& graph, int point, int v = 1, int value = 0, int length = 0) {
	if (point == v)
		result = max(result, length);

	for (const node& u : graph[v]) {
		if (u.c > value)
			dfs(graph, point, u.to, u.c, length + 1);
	}
}

int main()
{
	int n, m;
	cin >> n >> m;
    vector<vector<node>> graph(n + 1);

    for (int i = 0; i < m; ++i) {
		int a, b, c;
		cin >> a >> b >> c;

		graph[a].push_back(node(b, c));
		graph[b].push_back(node(a, c));
    }

    for (int i = 1; i <= n; ++i) {
		result = 0;
		dfs(graph, i);
		cout << result << " ";
    }
}
