#include <bits/stdc++.h>
#define int int64_t

using namespace std;

bool ans;

void solve(int l, int r, unordered_map<int, bool> used, vector<vector<int>> v, int n) {
    if(l == 0 && r == n - 1) {
        ans = 1;
    }

    if(r != n - 1) {
        bool flag = false;
        unordered_map<int, bool> copy_used = used;

        for(int x : v[r + 1]) {
            if(!copy_used[x]) {
                flag = true;
                copy_used[x] = true;
            }
        }

        if(flag) {
            solve(l, r + 1, copy_used, v, n);
        }
    }

    if(l != 0) {
        bool flag = false;
        for(int x : v[l - 1]) {
            if(!used[x]) {
                flag = true;
                used[x] = true;
            }
        }

        if(flag) {
            solve(l - 1, r, used, v, n);
        }
    }
}

int32_t main() {
    int n;
    cin >> n;

    vector<vector<int>> v(n);
    for(int i = 0; i < n; i++) {
        int k;
        cin >> k;

        vector<int> vec(k);
        for(int j = 0; j < k; j++) {
            cin >> vec[j];
        }

        v[i] = vec;
    }

    int q;
    cin >> q;

    while(q--) {
        int l, r;
        cin >> l >> r;
        l--, r--;

        unordered_map<int, bool> used;
        for(int i = l; i <= r; i++) {
            for(int j = 0; j < v[i].size(); j++) {
                used[v[i][j]] = true;
            }
        }

        ans = 0;
        solve(l, r, used, v, n);

        cout << ans << "\n";
    }
}