#include "twins.h"
#include <bits/stdc++.h>

using namespace std;

vector<int> play(int N, int T) {
    vector<int> v(N);
    for(int i = 1; i <= N; i++) {
        v[i - 1] = i;
    }

    queue<vector<int>> q;
    q.push(v);

    vector<int> ans = {};

    while(!q.empty()) {
        vector<int> cur = q.front();
        q.pop();

        if(cur.size() == 1) {
            ans.push_back(cur[0]);
            continue;
        }

        int c = sqrt(cur.size());

        int sz = cur.size() / c;
        if(cur.size() % c != 0) {
            sz++;
        }

        vector<vector<int>> que(sz);
        for(int i = 0; i < cur.size(); i++) {
            que[i / c].push_back(cur[i]);
        }

        string s = guess(que);
        for(int i = 0; i < s.size(); i++) {
            if(s[i] == '1') {
                q.push(que[i]);
            }
        }
    }

    return ans;
}