#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 228;

using ll = long long;
using ld = long double;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> k (n + 1);
    vector<vector<int>> a (n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> k[i];
        a[i].resize(k[i]);
        for (int j = 0; j < k[i]; ++j) cin >> a[i][j];
    }
    vector<vector<bool>> dp (n + 1, vector<bool> (n + 1));
    dp[1][n] = true;
    for (int l = 1; l <= n; ++l){
        vector<int> vis (1e6 + 1,  false);
        for (int j = l; j <= n; ++j){
            for (auto it : a[j]) vis[it]++;
        }
        for (int r = n; r >= l; --r) {
            if (r < n) {
                bool can = false;
                for (auto it : a[r + 1]) if (!vis[it]) can = 1;
                if (can) dp[l][r] = max (dp[l][r], dp[l][r + 1]);
            }
            if (l > 1) {
                bool can = false;
                for (auto it : a[l - 1]) if (!vis[it]) can = 1;
                if (can) dp[l][r] = max (dp[l][r], dp[l - 1][r]);
            }
            for (auto it : a[r]) vis[it]--;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        cout << dp[l][r] << "\n";
    }
    return 0;
}
