#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 228;

using ll = long long;
using ld = long double;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> k (n + 1);
    vector<vector<int>> a (n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> k[i];
        a[i].resize(k[i]);
        for (int j = 0; j < k[i]; ++j) cin >> a[i][j];
    }
    vector<int> r(n + 1);
    vector<int> l(n + 1);
    for (int i = 1; i <= n; ++i) {
        vector<int> vis (1e6 + 1, 0);
        r[i] = n + 1;
        for (int j = i + 1; j <= n; ++j) {
            for (auto it : a[j]) ++vis[it];
            bool good = 0;
            for (auto it : a[i]) if (!vis[it]) good = true;
            if (!good) {
                r[i] = j;
                break;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        vector<int> vis (1e6 + 1, 0);
        l[i] = 0;
        for (int j = i - 1; j >= 1; --j) {
            for (auto it : a[j]) ++vis[it];
            bool good = 0;
            for (auto it : a[i]) if (!vis[it]) good = true;
            if (!good) {
                l[i] = j;
                break;
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int L, R;
        cin >> L >> R;
        bool w = 0;
        while (L > 1 || R < n) {
            int mnR = n + 1, mxL = 0;
            for (int i = 1; i < L; ++i) mnR = min (mnR, r[i]);
            for (int i = R + 1; i <= n; ++i) mxL = max (mxL, l[i]);
            if ((mxL >= L && mxL <= R) || (mnR >= L && mnR <= R)) {
                cout << "0\n";
                w = 1;
                break;
            }
            if (L == mxL + 1 && R == mnR - 1) {
                cout << "0\n";
                w = 1;
                break;
            }
            L = mxL + 1;
            R = mnR - 1;

        }
        if (!w) {
            cout << "1\n";
            continue;
        }
    }
    return 0;
}
