#include <bits/stdc++.h>

using namespace std;

const int N = 5e5 + 1;

using ll = long long;
using ld = long double;

vector<int> pos[(int)1e6 + 1];
int l[N], r[N];
int prefmn[N], suffmx[N + 1];
int id[(int)1e6 + 1];
vector<int> a[N];
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;

    for (int i = 1; i <= n; ++i) {
        int x;
        cin >> x;
        a[i].resize(x);
        for (int j = 0; j < x; ++j) {
            cin >> a[i][j];
            pos[a[i][j]].push_back (i);
        }
    }

    for (int i = 1; i <= n; ++i) {
        int mx = 0;
        for (auto it : a[i]) {
            ++id[it];
            if (id[it] >= (int)pos[it].size()) mx = n + 1;
            else mx = max (mx, pos[it][id[it]]);
        }
        r[i] = mx;
    }
    for (int i = n; i >= 1; --i) {
        int mn = n + 1;
        for (auto it : a[i]) {
           if (id[it] == (int)pos[it].size()) --id[it];
           --id[it];
           if (id[it] < 0) mn = 0;
           else mn = min (mn, pos[it][id[it]]);
        }
        l[i] = mn;
    }
    prefmn[0] = n + 1;
    suffmx[n + 1] = 0;
    for (int i = 1; i <= n; ++i) prefmn[i] = min(r[i], prefmn[i - 1]);
    for (int i = n; i >= 1; --i) suffmx[i] = max(l[i], suffmx[i + 1]);
    int q;
    cin >> q;
    while (q--) {
        int L, R;
        cin >> L >> R;
        bool w = 0;
        while (L > 1 || R < n) {
            int mnR = prefmn[L - 1], mxL = suffmx[R + 1];
            if (L > 1 && mxL + 1 < L) --L;
            else if (R < n && mnR - 1 > R) ++R;
            else break;
        }
        if (L != 1 || R != n) cout << "0\n";
        else cout << "1\n";
    }
    return 0;
}
