#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
int main() {
    int n;
    cin >> n;
    vector<vector<int>> color(n + 1);
    for (int i = 1; i <= n; ++i) {
        int len;
        cin >> len;
        color[i].resize(len);
        for (int j = 0; j < len; ++j) {
            cin >> color[i][j];
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        vector<vector<bool>> dp(n + 1, vector<bool> (n + 1, false));
        dp[l][r] = true;
        int slen = r - l + 1;
        for (int len = slen; len <= n; ++len) {
            cc_hash_table<int, int> mp;
            for (int j = 1; j <= len; ++j) {
                for (auto it : color[j]) mp[it]++;
            }
            for (int l = 1; l <= n - len + 1; ++l) {
                if (dp[l][l + len - 1] == true) {
                    if (l - 1 > 0) {
                        bool flag = false;
                        for (auto it : color[l - 1]) {
                            if (mp.find(it) == mp.end() || mp[it] == 0) {
                                flag = true;
                                break;
                            }
                        }
                        if (flag) dp[l - 1][l + len - 1] = true;
                    }
                    if (l + len <= n) {
                        int flag = false;
                        for (auto it : color[l + len]) {
                            if (mp.find(it) == mp.end() || mp[it] == 0) {
                                flag = true;
                                break;
                            }
                        }
                        if (flag) dp[l][l + len] = true;
                    }
                }
                for (auto it : color[l]) {
                    mp[it]--;
                }
                if (l + len <= n) {
                    for (auto it : color[l + len]) {
                        mp[it]++;
                    }
                }
            }
        }
        cout << dp[1][n] << '\n';
    }
}
