#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
int main() {
    int n;
    cin >> n;
    vector<vector<int>> color(n + 1);
    for (int i = 1; i <= n; ++i) {
        int len;
        cin >> len;
        color[i].resize(len);
        for (int j = 0; j < len; ++j) {
            cin >> color[i][j];
        }
    }
    int q;
    cin >> q;
    vector<vector<bool>> dp(n + 1, vector<bool> (n + 1, false));
    vector<vector<int>> tree(4 * n + 4);
    function<void(int, int, int)> build = [&](int v, int tl, int tr) {
        if (tl == tr) {
            tree[v] = color[tl];
            sort(tree[v].begin(), tree[v].end());
            return;
        }
        int tm = (tl + tr) >> 1;
        build(v * 2, tl, tm);
        build(v * 2 + 1,tm + 1, tr);
        for (auto i : tree[v * 2]) tree[v].push_back(i);
        for (auto i : tree[v * 2 + 1]) tree[v].push_back(i);
        sort(tree[v].begin(), tree[v].end());
        return;
    };
    build(1, 1, n);
    bool fnd = false;
    function<void(int, int, int, int, int, int)> get = [&](int v, int tl, int tr, int l, int r, int val) {
        if (fnd == true) return;
        if (l > r) return;
        if (tl == l && tr == r) {
            auto it = lower_bound(tree[v].begin(), tree[v].end(), val);
            if (it != tree[v].end() && *it == val) {
                fnd = true;
            }
            return;
        }
        int tm = (tl+ tr) >> 1;
        get(v * 2, tl,  tm, l, min(r, tm), val); get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, val);
        return;
    };
    while (q--) {
        int l, r;
        cin >> l >> r;
        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= n; ++j) {
                dp[i][j] = false;
            }
        }
        dp[l][r] = true;
        int slen = r - l + 1;
        for (int len = slen; len <= n; ++len) {
            cc_hash_table<int, int> mp;
            for (int j = 1; j <= len; ++j) {
                for (auto it : color[j]) mp[it]++;
            }
            for (int l = 1; l <= n - len + 1; ++l) {
                if (dp[l][l + len - 1] == true) {
                    if (l - 1 > 0) {
                        for (auto it : color[l - 1]) {
                        fnd = false;
                        get(1, 1, n, l, l + len - 1, it);
                         if (fnd == false) {
                               // cout << it << ' ' << l << ' ' << l + len - 1 << endl;
                            dp[l - 1][l + len - 1] = true;
                            break;
                         }
                        }
                    }
                    if (l + len <= n) {
                        for (auto it : color[l + len]) {
                            fnd = false;
                        get(1, 1, n, l, l+ len - 1, it);
                         if (fnd == false) {

                            dp[l][l + len] = true;
                            break;
                         }
                        }
                    }
                    /*if (l - 1 > 0) {
                        bool flag = false;
                        for (auto it : color[l - 1]) {
                            if (mp.find(it) == mp.end() || mp[it] == 0) {
                                flag = true;
                                break;
                            }
                        }
                        if (flag) dp[l - 1][l + len - 1] = true;
                    }
                    if (l + len <= n) {
                        int flag = false;
                        for (auto it : color[l + len]) {
                            if (mp.find(it) == mp.end() || mp[it] == 0) {
                                flag = true;
                                break;
                            }
                        }
                        if (flag) dp[l][l + len] = true;
                    }
                }
                for (auto it : color[l]) {
                    mp[it]--;
                }
                if (l + len <= n) {
                    for (auto it : color[l + len]) {
                        mp[it]++;
                    */
                }
            }
        }
        cout << dp[1][n] << '\n';
    }
}
