#include <bits/stdc++.h>

using namespace std;
int main() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> g[n + 1];
    vector<int> times;
    times.push_back(-1);
    for (int i = 1; i <= m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        g[u].push_back({v, t});
        g[v].push_back({u, t});
        times.push_back(t);
    }
    sort(times.begin(), times.end());
    times.erase(unique(times.begin(), times.end()), times.end());
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int t = lower_bound(times.begin(), times.end(), g[i][j].second) - times.begin();
            g[i][j].second = t;
        }
    }
    if (m == n - 1) {
        vector<int> ans(n + 1, 0);
        vector<bool> used(n + 1, false);
        function<void(int, int, int)> dfs = [&](int v, int timer, int deep) {
            ans[v] = deep;
            used[v] = true;
            for (auto [to, time] : g[v]) {
                if (used[to] == false && timer < time) {
                    dfs(to, time, deep + 1);
                }
            }
            return;
        };
        dfs(1, 0, 0);
        for (int i = 1; i <= n; ++i) cout << ans[i] << ' ';
        return 0;
    }
    vector<vector<int>> dp(m + 5, vector<int>(n + 5, -10000000));
    dp[0][1] = 0;
    int N = times.size();
    vector<int> ans(n + 1);
    for (int last = 0; last <= N; ++last) {
        for (int v = 1; v <= n; v++) {
            ans[v] = max(ans[v], dp[last][v]);
            for (auto [to, time] : g[v]) {
                if (time > last) {
                    dp[time][to] = max(dp[time][to], dp[last][v] + 1);
                }
            }
        }
    }
    for (int i = 1; i <= n; ++i) cout << ans[i] << ' ';
}
