#pragma GCC optmize("avx2,bmi,bmi2,lzcnt,popcnt")
#pragma GCC optmize("unroll-loops")
#pragma GCC optmize("O3")
#include <bits/stdc++.h>

using namespace std;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> g[n + 1];
    vector<int> times;
    struct node {
        int u, v, t;
    };
    vector<node> edges;
    edges.push_back({0, 1, -1});
    for (int i = 1; i <= m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        edges.push_back({u, v, t});
    }
    sort(edges.begin(), edges.end(), [&](node a, node b) {
         return a.t < b.t;
    });
    for (int i = 1; i < edges.size(); ++i) {
        auto [u, v, t] = edges[i];
        g[u].push_back({v, t, i});
        g[v].push_back({u, t, i});
    }
    for (int i = 1; i <= n; ++i) {
        sort(g[i].begin(), g[i].end(), [&](tuple<int, int, int> a, tuple<int, int, int> b) {
             auto [to, time1, idx] = a;
             auto [to1, time2, idx1] = b;
             return time1 < time2;
        });
    }
    int inf = -1e9;
    vector<int> ans(n + 1);
    vector<vector<int>> dp(m + 5, vector<int> (3, inf));
    dp[0][1] = 0;
    for (int i = 0; i <= m; ++i) {
        for (int type = 0; type < 2; ++type) {
            auto [u, v, t] = edges[i];
            int cur;
            if (type == 0) cur = u;
            else cur = v;
            ans[cur] = max(ans[cur], dp[i][type]);
            for (int j = g[cur].size() - 1; j >= 0; --j) {
                auto [to, time, idx] = g[cur][j];
                if (time > t) {
                    int flag;
                    auto [uu, vv, tt] = edges[idx];
                    if (to == uu) flag = 0;
                    else flag = 1;
                    dp[idx][flag] = max(dp[idx][flag], dp[i][type] + 1);
                } else break;
            }
        }
    }
    for (int i = 1; i <= n; ++i) cout << ans[i] << ' ';
}
