#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> a;

bool rec(int l, int r) {
    if (l == 0 && r + 1 == a.size()) return true;

    set<int> s, s1, s2;

    for (int i = l; i <= r; ++i) {
        for (auto el: a[i]) s.insert(el);
    }

    s1.clear(), s2.clear();

    if (l > 0) {
        bool flag = true;

        for (auto el: a[l - 1]) {
            if (s.find(el) == s.end()) flag = false;
            s1.insert(el);
        }

        if (flag) {
            return false;
        }
    }
    if (r + 1 < a.size()) {
        bool flag = true;

        for (auto el: a[r + 1]) {
            if (s.find(el) == s.end()) flag = false;
            s2.insert(el);
        }

        if (flag) {
            return false;
        }
    }

    if (s1 == s2) {
        return false;
    }

    bool flag = true;
    for (auto el : s1) {
        if (s2.find(el) == s2.end()) flag = false;
    }

    bool ans1 = false, ans2 = false;
    if ((flag || r + 1 == a.size()) && l > 0) return rec(l - 1, r);

    flag = true;
    for (auto el : s2) {
        if (s1.find(el) == s1.end()) flag = false;
    }

    if ((flag || l == 0) && r + 1 < a.size()) return rec(l, r + 1);

    if (l > 0) ans1 = rec(l - 1, r);
    if (r + 1 < a.size()) ans2 = rec(l, r + 1);

    if (ans1 || ans2) return true;
    return false;
}

void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, x, q;
    cin >> n;

    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> x;

        a[i].resize(x);
        for (int j = 0; j < x; ++j) {
            cin >> a[i][j];
        }
    }

    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;

        if (rec(l - 1, r - 1)) {
            cout << "1\n";
        } else {
            cout << "0\n";
        }
    }
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}