#include <bits/stdc++.h>

using namespace std;

struct zxc{
    int a, b, c;
};

const int inf = 2e9;
void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<zxc> edges(m);
    for (int i = 0; i < m; ++i) {
        cin >> edges[i].a >> edges[i].b >> edges[i].c;
    }

    vector<vector<int>> d(m + 1, vector<int>(n + 1, inf));
    d[0][1] = 0;

    for (int i = 1; i <= m; ++i) {
        for (auto [a, b, c] : edges) {
            if (d[i - 1][a] != inf && c > d[i - 1][a]) {
                d[i][b] = min(c, d[i][b]);
            }

            if (d[i - 1][b] != inf && c > d[i - 1][b]) {
                d[i][a] = min(c, d[i][a]);
            }
        }
    }

    for (int i = 1; i <= n; ++i) {
        int mx = 0;

        for (int j = 1; j <= m; ++j) {
            if (d[j][i] != inf) mx = j;
        }

        cout << mx << ' ';
    }
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}