#include <bits/stdc++.h>

using namespace std;

struct zxc{
    int a, b, c;
};

const int inf = 2e9;
void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m, a, b, c;
    cin >> n >> m;

    vector<vector<pair<int, int>>> vert(n);
    for (int i = 0; i < m; ++i) {
        cin >> a >> b >> c;

        vert[a - 1].emplace_back(b - 1, c);
        vert[b - 1].emplace_back(a - 1, c);
    }

    vector<int> d(n, 0);
    d[0] = 0;

    queue<pair<int, int>> q; q.emplace(0, 0);
    while (!q.empty()) {
        auto [idx, wt] = q.front();
        q.pop();

        for (auto [to, w] : vert[idx]) {
            if (w > wt && d[to] < d[idx] + 1) {
                d[to] = d[idx] + 1;

                q.emplace(to, w);
            }
        }
    }

    for (auto el : d) {
        cout << el << ' ';
    }
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}