#include <bits/stdc++.h>

using namespace std;

void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m, a, b, c;
    cin >> n >> m;

    vector<vector<pair<int, int>>> vert(n);
    vector<pair<int, pair<int, int>>> edges(m);

    for (int i = 0; i < m; ++i) {
        cin >> a >> b >> c;
        edges[i] = {c, {a - 1, b - 1}};
    }

    sort(edges.begin(), edges.end());
    for (auto el : edges) {
        vert[el.second.first].emplace_back(el.second.second, el.first);
        vert[el.second.second].emplace_back(el.second.first, el.first);
    }

    vector<int> d(n, 0), col(n, 0);
    queue<int> q; q.push(0);

    while (!q.empty()) {
        int idx = q.front();
        q.pop();

        for (auto [to, w] : vert[idx]) {
            if (w > col[idx] && (d[idx] + 1 > d[to] || (d[idx] + 1 == d[to] && col[to] > w))) {
                d[to] = d[idx] + 1;
                col[to] = w;

                q.push(to);
            }
        }
    }

    for (auto el : d) {
        cout << el << ' ';
    }
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}