#include <bits/stdc++.h>

using namespace std;

bool flag;
vector<int> d, color, ans;
vector<vector<pair<int, int>>> vert;

void dfs(int idx) {
    for (auto [to, w] : vert[idx]) {
        if (w > color[idx]) {
            if (ans[to] < d[idx] + 1) flag = true;

            ans[to] = max(ans[to], d[idx] + 1);

            d[to] = d[idx] + 1;
            color[to] = w;
            dfs(to);
        }
    }
}

void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m, a, b, c;
    cin >> n >> m;

    vert.resize(n);
    vector<pair<int, pair<int, int>>> edges(m);

    for (int i = 0; i < m; ++i) {
        cin >> a >> b >> c;
        edges[i] = {c, {a - 1, b - 1}};
    }

    sort(edges.begin(), edges.end());
    for (auto el : edges) {
        vert[el.second.first].emplace_back(el.second.second, el.first);
        vert[el.second.second].emplace_back(el.second.first, el.first);
    }

    d.resize(n, 0), color.resize(n, 0), ans.resize(n, 0);

    flag = true;
    while (flag) {
        flag = false;

        dfs(0);
    }

    for (auto el : ans) cout << el << ' ';
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}