#include <bits/stdc++.h>

using namespace std;

const int MK = 12e5;

struct edge {
    int to, w;
};
vector<vector<edge>> gr;
vector<int> ans;

void dfs(int v, int p) {
    for (auto u: gr[v]) {
        if (u.to == p) continue;
        dfs(u.to, v);
        ans[u.to] = u.w;
    }
}

int32_t main() {
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    ans.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        gr[v].push_back({u, w});
        gr[u].push_back({v, w});
    }
    dfs(0, 0);
    for (int i: ans) {
        cout << i << ' ';
    }
}
