#include <bits/stdc++.h>

#define int long long
using namespace std;
const int INF = 2e9;

struct node {
    int to, c;
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<node>> z(n);
    for (int i = 0; i < m; i++) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        z[x].push_back({y, c});
        z[y].push_back({x, c});
    }
    vector<vector<int>> dp(m, vector<int> (n, INF));
    dp[0][0] = 0;
    for (int i = 0; i < m - 1; i++) {
        for (int j = 0;j < n; j++) {
            if (dp[i][j] != INF) {
                for (auto to: z[j]) {
                    int y = to.to, c = to.c;
                    if (c > dp[i][j]) {
                        dp[i + 1][y] = min(dp[i + 1][y], c);
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        int mx = 0;
        for (int j = 0; j < m; j++) {
            if (dp[j][i] != INF) {
                mx = j;
            }
        }
        cout << mx << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int e = 1;
    while (e--) {
        solve();
        cout << "\n";
    }
}

