#include <bits/stdc++.h>

#define int long long
using namespace std;
const int INF = 2e9;
struct node {
    int to, c;
};
int n, m;
vector<vector<node>> z;
vector<int> used;

void dfs(int i, int c) {
    used[i] = c;
    for (auto to: z[i]) {
        int y = to.to, call = to.c;
        if (call > c) {
            dfs(y, call);
        }
    }
}

void solve() {
    cin >> n >> m;
    z.resize(n);
    used.resize(n, INF);
    for (int i = 0; i < m; i++) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        z[x].push_back({y, c});
        z[y].push_back({x, c});
    }
    dfs(0, 0);
    for (int i = 0; i < n ; i++) {
        if (used[i] == INF) {
            cout << 0;
        } else {
            cout << used[i];
        }
        cout << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int e = 1;
    while (e--) {
        solve();
        cout << "\n";
    }
}

