#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const int INF=1e10;
struct edge {
    int w;
    int v;
    int u;
};
bool comp(edge a, edge b) {
    return (a.w<b.w);
}
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<edge> a(m);
    for(int i=0;i<m;i++) {
        cin >> a[i].v >> a[i].u >> a[i].w;
    }
    sort(a.begin(),a.end(),comp);
    vector<vector<int> > p(n+1);
    for(int i=1;i<=n;i++) {
        p[i].resize(m+1,INF);
    }
    for(int i=0;i<m;i++) {
        if(a[i].v==1) {
            p[a[i].u][1]=a[i].w;
        }
        if(a[i].u==1) {
            p[a[i].v][1]=a[i].w;
        }
    }
    for(int i=0;i<m;i++) {
        int v=a[i].v;
        int u=a[i].u;
        int w=a[i].w;
        for(int j=2;j<=m;j++) {
            if(p[v][j-1]<w) {
                p[u][j]=min(p[u][j],w);
            }
            if(p[u][j-1]<w) {
                    p[v][j]=min(p[v][j],w);
            }
        }
    }
    for(int i=1;i<=n;i++) {
        int ans=0;
        for(int j=1;j<=m;j++) {
            if(p[i][j]<INF) {
                ans=j;
            }
        }
        cout << ans << " ";
    }
}
