#include <bits/stdc++.h>
using ll = long long;
using namespace std;
void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> color(n);
    for (int i = 0; i < n; i++) {
        ll len;
        cin >> len;
        for (int j = 0; j < len; j++) {
            ll f;
            cin >> f;
            f--;
            color[i].push_back(f);
        }
    }
    ll q;
    cin >> q;
    while (q--) {
        ll l, r;
        cin >> l >> r;
        vector<ll> used(1e6);
        l--, r--;
        vector<ll> use(n);
        for (int i = l; i <= r; i++) {
            use[i] = 1;
            for (auto j : color[i]) {
                used[j] = 1;
            }
        }
        vector<vector<ll>> g(1e6);
        vector<ll> st(n);
        bool flag = true;
        vector<ll> us1(1e6), us2(1e6);
        for (int i = l - 1; i >= 0; i--) {
            for (auto j : color[i]) {
                if (used[j] == 0 && us1[j] == 0) {
                    g[j].push_back(i);
                    st[i]++;
                }
                us1[j] = 1;
            }
            if (st[i] == 0) {
                flag = false;
                break;
            }
        }
        for (int i = r + 1; i < n; i++) {
            for (auto j : color[i]) {
                if (used[j] == 0 && us2[j] == 0) {
                    g[j].push_back(i);
                    st[i]++;
                }
                us2[j] = 1;
            }
            if (st[i] == 0) {
                flag = false;
                break;
            }
        }
        ll left = l, right = r;
        while (left != 0 || right != n - 1) {
            if (left != 0) {
                bool f = true;
                for (auto j : color[left - 1]) {
                    for (auto z : g[j]) {
                        if (z != left - 1 && use[z] == 0 && st[z] == 1) {
                            f = false;
                        }
                    }
                }
                if (f) {
                    left--;
                    use[left] = 1;
                    continue;
                }
            }
            bool f = true;
            for (auto j : color[right + 1]) {
                for (auto z : g[j]) {
                    if (z != right + 1 && use[z] == 0 && st[z] == 1) {
                        f = false;
                    }
                }
            }
            if (f) {
                right++;
                use[right] = 1;
                continue;
            }
            flag = false;
            break;
        }
        if (flag) {
            cout << 1 << '\n';
        } else {
            cout << 0 << '\n';
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll q = 1;
    while (q--) {
        solve();
    }
}
