#include <bits/stdc++.h>
using ll = long long;
using namespace std;

vector<vector<pair<ll, ll>>> g;
vector<ll> ans;
void dfs(ll v, ll p, ll last) {
    for (auto [u, w] : g[v]) {
        if (u == p || w <= last) {
            continue;
        }
        ans[u] = ans[v] + 1;
        dfs(u, v, w);
    }
}
void solve() {
    ll n, m;
    cin >> n >> m;
    g.resize(n);
    ans.resize(n);
    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }
    dfs(0, -1, -1);
    for (auto i : ans) {
        cout << i << ' ';
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll q = 1;
    while (q--) {
        solve();
    }
}
