#include <iostream>
#include <cmath>
#include <string>
#include <vector>
#define ll unsigned long long

using namespace std;

vector<int> res;

bool containes(vector<int> v, int a) {
	for (int i = 0; i < v.size(); i++) {
		if (v[i] == a) return true;
	}

	return false;
}

vector<int> uniqueColors(vector<int> usedColors, vector<int> colors) {
	vector<int> res;

	for (int i = 0; i < colors.size(); i++) {
		if (!containes(usedColors, colors[i])) res.push_back(colors[i]);
	}

	return res;
}

void aquarelle(int n, vector<vector<int>> a, int l, int r) {
	vector<int> usedColors;

	for (int i = l - 1; i < r; i++) {
		for (int j : a[i]) {
			if (!containes(usedColors, j)) usedColors.push_back(j);
		}
	}

	int curL = l - 1, curR = r - 1, uniqueColorsInLeftCellSize, uniqueColorsInRightCellSize, minSize;
	vector<int> uniqueColorsInLeftCell, uniqueColorsInRightCell;

	while (curL > 0 || curR < n - 1) {
		uniqueColorsInLeftCell.clear();
		uniqueColorsInRightCell.clear();

		if (curL > 0) {
			uniqueColorsInLeftCell = uniqueColors(usedColors, a[curL - 1]);
		}

		if (curR < n - 1) {
			uniqueColorsInRightCell = uniqueColors(usedColors, a[curR + 1]);
		}

		uniqueColorsInLeftCellSize = uniqueColorsInLeftCell.size();
		uniqueColorsInRightCellSize = uniqueColorsInRightCell.size();

		if (uniqueColorsInLeftCellSize <= uniqueColorsInRightCellSize && uniqueColorsInLeftCellSize > 0) minSize = uniqueColorsInLeftCellSize;
		else minSize = uniqueColorsInRightCellSize;

		if (minSize > 0) {
			if (minSize == uniqueColorsInLeftCellSize) {
				curL--;

				for (int i : uniqueColorsInLeftCell) usedColors.push_back(i);
				//cout << "For Test With L: " << l << " And R: " << r << " Painted Cell: " << curL + 1 << endl;
			}
			else {
				curR++;

				for (int i : uniqueColorsInRightCell) usedColors.push_back(i);
				//cout << "For Test With L: " << l << " And R: " << r << " Painted Cell: " << curR + 1 << endl;
			}

			continue;
		}

		res.push_back(0);
		return;
	}

	res.push_back(1);
}

void aquarelleInput() {
	int n, tempK, temp, q, l, r; cin >> n;
	vector<vector<int>> a;
	vector<int> tempVector;

	for (int i = 0; i < n; i++) {
		if (!tempVector.empty()) tempVector.clear();

		cin >> tempK;
		for (int j = 0; j < tempK; j++) {
			cin >> temp;
			tempVector.push_back(temp);
		}
		a.push_back(tempVector);
	}

	cin >> q;

	for (int i = 0; i < q; i++) {
		cin >> l;
		cin >> r;

		aquarelle(n, a, l, r);
	}

	for (int i : res) cout << i << endl;
}

int main()
{
	aquarelleInput();
}