#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int INF = 1e18;
const int mod = 1e9 + 7;
const int N = 3005;
vector<int> a[N];
multiset<int> st;
bool good[N][N];
int n;

void dfs(int l, int r){
	good[l][r] = 1;
	if(l != 1){
		bool ok = 0;
		for(int i : a[l - 1]){
			if(st.count(i) == 0){
				ok = 1;
				break;
			}
		}
		if(ok){
			for(int i : a[l - 1]){
				st.insert(i);
			}
			dfs(l - 1, r);
			for(int i : a[l - 1]){
				st.erase(st.find(i));
			}
		}
	}
	if(r != n){
		bool ok = 0;
		for(int i : a[r + 1]){
			if(st.count(i) == 0){
				ok = 1;
				break;
			}
		}
		if(ok){
			for(int i : a[r + 1]){
				st.insert(i);
			}
			dfs(l, r + 1);
			for(int i : a[r + 1]){
				st.erase(st.find(i));
			}
		}
	}
}

void solve(){
	cin >> n;
	for(int i = 1; i <= n; i++){
		int k;
		cin >> k;
		while(k--){
			int b;
			cin >> b;
			a[i].pb(b);
		}
	}
	int q;
	cin >> q;
	while(q--){
		int l, r;
		cin >> l >> r;
		for(int i = l; i <= r; i++){
			for(int j : a[i]) st.insert(j);
		}
		dfs(l, r);
		cout << good[1][n] << '\n';
		for(int i = 1; i <= n; i++){
			for(int j = i; j <= n; j++){
				good[i][j] = 0;
			}
		}
		for(int i = l; i <= r; i++){
			for(int j : a[i]) st.erase(st.find(j));
		}
	}
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
}

