#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int INF = 1e18;
const int mod = 1e9 + 7;
const int N = 5e5 + 5;
const int M = 1200001;
vector<int> pos[M];
vector<int> a[N];

void solve(){
	int n;
	cin >> n;
	for(int i = 1; i <= n; i++){
		int k;
		cin >> k;
		for(int j = 1; j <= k; j++){
			int b;
			cin >> b;
			a[i].pb(b);
			pos[b].pb(i);
		}
	}
	vector<int> la(n + 1, INF), ra(n + 1, -INF), cnt(n + 1);
	for(int i = 1; i <= n; i++){
		int cntl = 0, cntr = 0;
		for(int j : a[i]){
			int lb = lower_bound(all(pos[j]), i) - pos[j].begin();
			if(lb != 0) cntl++, la[i] = min(la[i], pos[j][lb	 - 1]);
			if(lb != (int)pos[j].size() - 1) cntr++, ra[i] = max(ra[i], pos[j][lb + 1]);
		}
		if(cntl != (int)a[i].size()) la[i] = -1;
		else cnt[la[i]]++;
		if(cntr != (int)a[i].size()) ra[i] = -1;
		else cnt[ra[i]]++;
	}
	int q;
	cin >> q;
	while(q--){
		int l, r;
		cin >> l >> r;
		auto cnt1 = cnt;
		for(int i = l; i <= r; i++){
			if(la[i] != -1) cnt1[la[i]]--;
			if(ra[i] != -1) cnt1[ra[i]]--;
		}
		bool ok = 1;
		for(int i = l; i <= r; i++){
			if(cnt1[i]) ok = 0;
		}
		if(!ok){
			cout << "0\n";
			continue;
		}
		while(1){
			int res = 0;
			if(r != n){
				if(cnt1[r + 1] == 0){
					res++;
					if(la[r + 1] != -1) cnt1[la[r + 1]]--;
					if(ra[r + 1] != -1) cnt1[ra[r + 1]]--;
					r++;
				}
			}
			if(l != 1){
				if(cnt1[l - 1] == 0){
					res++;
					if(la[l - 1] != -1) cnt1[la[l - 1]]--;
					if(ra[l - 1] != -1) cnt1[ra[l - 1]]--;
					l--;
				}
			}
			if(res == 0) break;
		}
		if(l == 1 and r == n) cout << "1\n";
		else cout << "0\n";
	}
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
}

