#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int INF = 1e18;
const int mod = 1e9 + 7;
const int N = 1e5 + 1;
vector<pair<int,int> > g[N];
vector<int> ans(N);

void dfs(int v, int now, int dis){
	for(auto [to, cost] : g[v]){
		if(now < cost){
			ans[to] = max(ans[to], dis + 1);
			dfs(to, cost, dis + 1);
		}
	}
}

void solve(){
	int n, m;
	cin >> n >> m;
	for(int i = 0; i < m; i++){
		int u, v, cost;
		cin >> u >> v >> cost;
		g[u].pb({v, cost});
		g[v].pb({u, cost});
	}
	dfs(1, 0, 0);
	for(int i = 1; i <= n; i++){
		cout << ans[i] << ' ';
	}
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
}
