#include<iostream>
#include<string>
#include<vector>
#include<cmath>
using namespace std;
const bool DETAILS=true;
int _n,_m,_t,_pos[4];
bool _special[50007];
int _vis[50007],_tim;
string _result;
int _L,_P;

vector<int> _ans;

void prnt(const char message[]){
    cout<<message<<"\n";
    exit(0);
}

string guess(vector< vector<int> >& questions){

    if(DETAILS){
        cout<<"Guess number "<<_P+1<<"\n";
        for(int i=0;i<questions.size();i++){
            cout<<"Question number "<<i+1<<" : ";
            for(int f=0;f<questions[i].size();f++){
                cout<<questions[i][f]<<" ";
            }
            cout<<"\n";
        }
    }

    _m=questions.size();
    _L+=int(questions.size());
    _P++;

    if(_m==0)prnt("Empty question!");

    _result.clear();
    _result.resize(_m);

    for(int i=0;i<_m;i++){
        if(questions[i].size()==0){
            _L--;
        }

        _result[i]='0'; _tim++;
        for(int f=0;f<questions[i].size();f++){
            if(questions[i][f]<1 or questions[i][f]>_n)prnt("Invalid question!");

            if(_vis[questions[i][f]]==_tim)prnt("Invalid question!");
            _vis[questions[i][f]]=_tim;

            if(_special[questions[i][f]])_result[i]='1';
        }
    }

    if(DETAILS){
        cout<<"Results from guess number "<<_P<<" : "<<_result<<"\n";
    }

    return _result;
}
vector<int> play(int N,int T)
{
    int l=0,r=N-1;
    while((r-l)%2==1)
    {
        vector <vector <int> > qls;
        for(int i=l;i<=l-1+(r-l+1)/2;i++)
        {
            qls[0].push_back(i);
        }
        for(int i=l+(r-l+1)/2;i<=r;i++)
        {
            qls[1].push_back(i);
        }
        string s=guess(qls);
        if(s[0]=='1')
        {
            r=l-1+(r-l+1)/2;
        }else
        {
            l=l+(r-l+1)/2;
        }
        
    }
    vector <vector <int> > ryn;
    for(int i=l;i<=r;i++)
    {
        ryn[i-l].push_back(i);
    }
    string k=guess(ryn);
    for(int i=0;i<k.size();i++)
    {
        if(k[i]=='1')
        {
            return {i+l};
        }
    }
}