#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(x) x.begin(), x.end()
#define Sum(x) accumulate(x.begin(), x.end(), 0LL)
#define uniq(x) x.erase(unique(x.begin(), x.end()), x.end())
#define Mod(a, b) ((((a) % (b)) + (b)) % (b))

template<class t> using ordered_set =
        tree<t, null_type, less<t>, rb_tree_tag, tree_order_statistics_node_update>;
template<class t> using ordered_multiset =
        tree<t, null_type, less_equal<t>, rb_tree_tag, tree_order_statistics_node_update>;

template<class t, class u>
bool chmin(t &a, u b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<class t, class u>
bool chmax(t &a, u b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int mod = 1e9 + 7, N = 1e5 + 5, INF = numeric_limits<int>::max();

vector<int> mergesort(vector<int> v) {
    if (v.size() <= 1) return v;
    vector<int> a, b;
    int m = (int)v.size() / 2;
    for (int i = 0; i < m; ++i) a.emplace_back(v[i]);
    for (int i = m; i < v.size(); ++i) b.emplace_back(v[i]);
    a = mergesort(a);
    b = mergesort(b);
    int i = 0, j = 0, pos = 0;
    while (i < a.size() && j < b.size()) {
        if (a[i] < b[j]) v[pos++] = a[i++];
        else v[pos++] = b[j++];
    }
    while (i < a.size()) v[pos++] = a[i++];
    while (j < b.size()) v[pos++] = b[j++];
    return v;
}

int binpow(int n, int e){
    int res = 1;
    while (e) {
        if (e & 1) res = Mod((res * n), mod);
        n = Mod((n * n), mod);
        e >>= 1;
    }
    return res;
}

int divide(int a, int b){
    return Mod(a * binpow(b, mod - 2), mod);
}
int n;
vector<vector<int> > c(501);
bool ans;
void rec(int l, int r, unordered_map<int, bool> used) {
    if (l == 1 && r == n) {
        ans = true;
    }
    if (l < 1 || r > n) return;
    if (l == 1) {
        r++;
        bool ok = false;
        for (int i = 0; i < c[r].size(); ++i) {
            if (!used[c[r][i]]) {
                ok = true;
                used[c[r][i]] = true;
            }
        }
        if (ok) rec(l, r, used);
    } else if (r == n) {
        l--;
        bool ok = false;
        for (int i = 0; i < c[l].size(); ++i) {
            if (!used[c[l][i]]) {
                ok = true;
                used[c[l][i]] = true;
            }
        }
        if (ok) rec(l, r, used);
    } else {
        l--;
        bool ok = false;
        for (int i = 0; i < c[l].size(); ++i) {
            if (!used[c[l][i]]) {
                ok = true;
                used[c[l][i]] = true;
            }
        }
        if (ok) rec(l, r, used);
        l++;
        r++;
        ok = false;
        for (int i = 0; i < c[r].size(); ++i) {
            if (!used[c[r][i]]) {
                ok = true;
                used[c[r][i]] = true;
            }
        }
        if (ok) rec(l, r, used);
    }
}

void solve() {
    cin >> n;

    int k;
    for (int i = 1; i <= n; ++i) {
        int k;
        cin >> k;
        c[i].resize(k);
        for (int j = 0; j < k; ++j) cin >> c[i][j];
    }
    int q;
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        unordered_map<int, bool> used;
        for (int i = l; i <= r; ++i) {
            for (auto x: c[i]) used[x] = true;
        }
        ans = false;
        rec(l, r, used);
        cout << ans << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
//  int tt; cin >> tt; while(tt--) // DON'T FORGET
    solve();
}