//#define RCode
#ifndef RCode
#include "twins.h"
#endif // RCode

using namespace std;

vector<int> Solve1(int st, int dr) {
    if(st == dr) return {st};
    else {
        int mij = st + (dr - st) / 2;

        vector<int> pozSt;
        for(int i = st; i <= mij; i++) pozSt.push_back(i);

        vector<vector<int>> query = {pozSt};
        string pozeQuery = guess(query);

        vector<int> ret;
        if(pozeQuery[0] == '1') ret = Solve1(st, mij);
        else                    ret = Solve1(mij + 1, dr);

        return ret;
    }
}

vector<int> Solve2(int st, int dr) {
    if(st == dr) return {st};
    else {
        int mij = st + (dr - st) / 2;

        vector<int> pozSt, pozDr;
        for(int i = st; i <= mij; i++) pozSt.push_back(i);
        for(int i = mij + 1; i <= dr; i++) pozDr.push_back(i);

        vector<vector<int>> query = {pozSt, pozDr};
        string pozeQuery = guess(query);

        vector<int> q1, q2;
        if(pozeQuery[0] == '1') q1 = Solve2(st, mij); /// numai la stanga
        if(pozeQuery[1] == '1') q2 = Solve2(mij + 1, dr); /// numai la dreapta

        vector<int> ret;
        for(auto it : q1) ret.push_back(it);
        for(auto it : q2) ret.push_back(it);
        return ret;
    }
}

vector<int> play(int n, int t) {
    if(t == 2) return Solve2(1, n);
    else return Solve1(1, n);
}
