#include <bits/stdc++.h>
using namespace std;
using pii = pair<int, int>;
const int NMAX = 5e5+2;
const int VMAX = 1e6+2;
int n,k[NMAX],vf[VMAX];
bool ans,used[NMAX];
vector<int> a[NMAX];
map<pii, vector<pii>> v;
map<pii, bool> visited;

bool can_include(int idx){
    if(idx < 1 || idx > n){
        return true;
    }
    for(int col: a[idx]){
        if(vf[col] == 0){
            return true;
        }
    }
    return false;
}

void include(int idx){
    used[idx] = 1;
    for(int col: a[idx]){
        vf[col]++;
    }
}

void exclude(int idx){
    used[idx] = 0;
    for(int col: a[idx]){
        vf[col]--;
    }
}

void dfs(pii nod){
    if(nod == (pii){1, n}){
        ans = true;
        return ;
    }
    visited[nod] = true;
    for(auto fiu: v[nod]){
        if(!visited.count(fiu) && !ans){
            dfs(fiu);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> k[i];
        a[i].resize(k[i]);
        for(auto &it: a[i]){
            cin >> it;
        }
    }
    for(int len = 1; len <= n; len++){
        for(int i = 1; i <= len; i++){
            include(i);
        }
        if(len != n && can_include(len+1)){
            v[{1, len}].push_back({1, len+1});
        }
        for(int i = 2; i <= n-len+1; i++){
            exclude(i-1);
            include(i+len-1);
            if(i > 1 && can_include(i-1)){
                v[{i, i+len-1}].push_back({i-1, i+len-1});
            }
            if(i+len-1 < n && can_include(i+len)){
                v[{i, i+len-1}].push_back({i, i+len});
            }
        }
        for(int i = n-len+1; i <= n; i++){
            exclude(i);
        }
    }
    int q;
    cin >> q;
    while(q--){
        int l, r;
        cin >> l >> r;
        ans = false;
        visited.clear();
        dfs({l, r});
        cout << ans << "\n";
    }
    return 0;
}
/**
6
2 5 3
1 4
1 1
1 2
2 3 4
1 6

**/
