#include<iostream>
#include "twins.h"
using namespace std;
const int len = 37;

vector<int> idx_range(int l, int r){
    vector<int> ans;
    for(int i = l; i <= r; i++){
        ans.push_back(i);
    }
    return ans;
}

std::vector<int> play(int n,int T){
    int l = 1, r = n;
    while(1){
        int sz = max(1, (r-l+1) / len);
        vector<vector<int>> query;
        for(int i = l; i <= r; i += sz){
            query.push_back( idx_range(i, min(r, i+sz-1)) );
        }
        string ans = guess(query);
        int idx = -1;
        for(int i = 0; i < ans.size(); i++){
            if(ans[i] == '1'){
                idx = i;
                break;
            }
        }
        l = l + idx*sz, r = l+sz-1;
        if(sz == 1){
            return {l};
        }
    }
}
