#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>
#include <cstring>
#warning That's not AS, that's my AS

typedef long long ll;

const int NMAX = 5e5;
const int CMAX = 1e6;

std::vector<int> g[NMAX + 1];
bool blocked[CMAX + 1];
bool vis[NMAX + 1];
int l[NMAX + 1];
int r[CMAX + 1];

bool cuplaj(int u) {
  vis[u] = true;
  for (const auto &v : g[u]) {
    if (blocked[v]) {
      continue;
    }
    if (!l[v]) {
      l[v] = u;
      r[u] = v;
      return true;
    }
  }
  for (const auto &v : g[u]) {
    if (blocked[v]) {
      continue;
    }
    if (l[v] && cuplaj(l[v])) {
      l[v] = u;
      r[u] = v;
      return true;
    }
  }
  return false;
}

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);

  int n;
  std::cin >> n;
  int M = 0;

  for (int i = 1; i <= n; i++) {
    int k;
    std::cin >> k;
    M += k;
    for (int j = 0; j < k; j++) {
      int x;
      std::cin >> x;
      g[i].push_back(x);
    }
  }

  int q;
  std::cin >> q;
  while (q--) {
    int st, dr;
    std::cin >> st >> dr;
    memset(blocked, false, sizeof(blocked));
    for (int i = st; i <= dr; i++) {
      for (const auto &j : g[i]) {
        blocked[j] = true;
      }
    }
    memset(vis, false, sizeof(vis));
    memset(l, 0, sizeof(l));
    memset(r, 0, sizeof(r));
    for (int i = st; i <= dr; i++) {
      vis[i] = true;
    }
    int steps = 0;
    while (true) {
      steps++;
      bool ok = false;
      for (int i = 1; i <= n; i++) {
        if (!vis[i]) {
          ok |= cuplaj(i);
          break;
        }
      }
      if (!ok) {
        break;
      }
      assert(steps <= n + M);
    }
    bool ok = true;
    for (int i = 1; i <= n; i++) {
      if (!(st <= i && i <= dr) && !r[i]) {
        ok = false;
      }
    }
//    std::cout << "! ";
//    for (int i = 1; i <= n; i++) {
//      std::cout << r[i] << ' ';
//    }
//    std::cout << '\n';
    std::cout << ok << '\n';
  }

  return 0;
}
