#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>
#include <cstring>
#include <set>
#warning That's not AS, that's my AS

typedef long long ll;

const int NMAX = 5e5;
const int CMAX = 1e6;

std::vector<int> g[NMAX + 1];
bool blocked[CMAX + 1];

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);

  int n;
  std::cin >> n;
  int M = 0;

  for (int i = 1; i <= n; i++) {
    int k;
    std::cin >> k;
    M += k;
    for (int j = 0; j < k; j++) {
      int x;
      std::cin >> x;
      g[i].push_back(x);
    }
  }

  int q;
  std::cin >> q;
  while (q--) {
    int st, dr;
    std::cin >> st >> dr;
    memset(blocked, false, sizeof(blocked));
    for (int i = st; i <= dr; i++) {
      for (const auto &j : g[i]) {
        blocked[j] = true;
      }
    }
    
    int m = n - (dr - st + 1);
    bool answer = false;
    for (int mask = 0; mask < (1 << m); mask++) {
      int L = st, R = dr;
      bool ok = true;
      std::set<int> to;
      for (int i = 0; i < m; i++) {
        if ((mask >> i) & 1) {
          R++;
          if (R > n) {
            ok = false;
            break;
          }
          for (const auto &v : g[R]) {
            if (!blocked[v]) {
              to.insert(v);
            }
          }
        } else {
          L--;
          if (L < 1) {
            ok = false;
            break;
          }
          for (const auto &v : g[L]) {
            if (!blocked[v]) {
              to.insert(v);
            }
          }
        }
        if ((int) to.size() < i + 1) {
          ok = false;
          break;
        }
      }

      if (ok) {
        answer = true;
        break;
      }
    }
    std::cout << answer << '\n';
  }

  return 0;
}
