#include <bits/stdc++.h>
using namespace std;

using ll = long long;
//#define int ll
using pi = array<int, 2>;
#define pb push_back

#define msc __attribute__((target("avx2"), optimize("O3,unroll-loops")))

const int INF = 1e9;

struct Edge {
  int u, v, c;
};

const int N = 1e5 + 5, M = 6e5 + 5;

vector<Edge> edges;
int dist[M];
bool vis[M];
vector<int> adj[N];

msc void dfs(int idx, int len) {
  dist[idx] = len;
  
  int st = 0, dr = adj[edges[idx].v].size() - 1, ans = -1;
  while (st <= dr) {
    int mid = (st + dr) / 2;
    if (edges[adj[edges[idx].v][mid]].c > edges[idx].c) {
      ans = mid;
      st = mid + 1;
    } else dr = mid - 1;
  }
  for (int j = ans; j >= 0; --j) {
    int other = adj[edges[idx].v][j];
    assert(edges[other].c > edges[idx].c);
    if (len + 1 > dist[other]) dfs(other, len + 1);
    else break;
    //if (!vis[other]) dfs(other, len + 1);
  }
}

msc int32_t main() {
  int n, m;
  cin >> n >> m;
  
  for (int i = 0; i < m; ++i) {
    Edge e;
    cin >> e.u >> e.v >> e.c;

    adj[e.u].pb(edges.size());
    edges.pb(e);

    swap(e.u, e.v);
    
    adj[e.u].pb(edges.size());
    edges.pb(e);
  }
  m = edges.size();
  for (int i = 1; i <= n; ++i) {
    sort(adj[i].begin(), adj[i].end(), [&](int x, int y) {
      return edges[x].c > edges[y].c;
    });
  }
  
  for (int i = 0; i < m; ++i) {
    Edge e = edges[i];
    if (e.u == 1) {
      dfs(i, 1);
    }
  }
  
  vector<int> best(n + 1, 0);
  for (int i = 0; i < m; ++i) {
    Edge e = edges[i];
    best[e.v] = max(best[e.v], dist[i]);
  }
  for (int i = 1; i <= n; ++i) {
    cout << best[i] << " ";
  }
}
