#include <bits/stdc++.h>
using namespace std;

using ll = long long;
//#define int ll
using pi = array<int, 2>;
#define pb push_back

#define msc __attribute__((target("avx2"), optimize("O3,unroll-loops")))

const int INF = 1e9;

struct Edge {
  int u, v, c;
};

const int N = 1e5 + 5, M = 6e5 + 5;

int n, m;
vector<Edge> edges;
int dist[M];
bool vis[M];
vector<int> adj[N];
int prec[M];

msc void dfs(int idx, int len) {
  dist[idx] = len;
  
  /*int dr = adj[edges[idx].v].size() - 1, ans = -1;
  if (prec[idx] == -2) {
    ans = 0;
    for (int pas = 15; pas >= 0; --pas) {
      if (ans + (1 << pas) > dr) continue;
      if (edges[adj[edges[idx].v][ans + (1 << pas)]].c > edges[idx].c) ans += (1 << pas);
    }
    if (edges[adj[edges[idx].v][ans]].c <= edges[idx].c) ans = -1;
  } else ans = prec[idx];*/
  if (prec[idx] == -2) prec[idx] = adj[edges[idx].v].size() - 1;
  //while (prec[idx] >= 0 && edges[adj[edges[idx].v][prec[idx]]].c <= edges[idx].c) --prec[idx];
  for (int j = prec[idx]; j >= 0; --j) {
    int other = adj[edges[idx].v][j];
    if (edges[other].c <= edges[idx].c) continue;
    if (len + 1 > dist[other]) dfs(other, len + 1);
    else break;
    //if (!vis[other]) dfs(other, len + 1);
  }
}

msc int32_t main() {
  cin >> n >> m;
  
  for (int i = 0; i < m; ++i) {
    Edge e;
    cin >> e.u >> e.v >> e.c;

    adj[e.u].pb(edges.size());
    edges.pb(e);

    swap(e.u, e.v);
    
    adj[e.u].pb(edges.size());
    edges.pb(e);
  }
  m = edges.size();
  for (int i = 1; i <= n; ++i) {
    sort(adj[i].begin(), adj[i].end(), [&](int x, int y) {
      return edges[x].c > edges[y].c;
    });
  }
  for (int i = 0; i <= m; ++i) prec[i] = -2;
  
  for (int i = 0; i < m; ++i) {
    Edge e = edges[i];
    if (e.u == 1) {
      dfs(i, 1);
    }
  }
  
  vector<int> best(n + 1, 0);
  for (int i = 0; i < m; ++i) {
    Edge e = edges[i];
    best[e.v] = max(best[e.v], dist[i]);
  }
  for (int i = 1; i <= n; ++i) {
    cout << best[i] << " ";
  }
}
