#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const int MAXN = 100228;

int n, m;
vector<pair<int, int>> g[MAXN];
int dist[MAXN];

void dfs(int u, int t = 0, int d = 0) {
    dist[u] = max(dist[u], d);
    for (auto h: g[u]) {
        if (h.second > t) {
            dfs(h.first, h.second, d + 1);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        g[x].push_back(make_pair(y, z));
        g[y].push_back(make_pair(x, z));
    }
    dfs(1);
    for (int i = 1; i <= n; i++) {
        cout << dist[i] << ' ';
    }
    return 0;
}
