#include <bits/stdc++.h>
//#include "twins.h"
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;

struct edge
{
    int to;
    int time;
};

bool cmp(edge a, edge b)
{
    return a.time>b.time;
}

struct drum
{
    int currnode;
    int lasttime;
    int len;
};

struct idk
{
    int bestcost;
    int besttime;
};

vector<edge> nodes[100001];
queue<drum> q;
idk maxlen[100001];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,m,i,j,u,v,c;
    drum fr;
    cin >> n >> m;
    for (i=1;i<=m;i++)
    {
         cin >> u >> v >> c;
         nodes[u].push_back({v,c});
         nodes[v].push_back({u,c});
    }
    for (i=1;i<=n;i++)
    {
        sort(nodes[i].begin(),nodes[i].end(),cmp);
    }
    q.push({1,0,0});
    while (!q.empty())
    {
        fr=q.front();
        q.pop();
        if (maxlen[fr.currnode].bestcost<fr.len)
        {
            maxlen[fr.currnode]={fr.len,fr.lasttime};
        }
        else if (maxlen[fr.currnode].bestcost==fr.len && maxlen[fr.currnode].besttime>fr.lasttime)
        {
            maxlen[fr.currnode]={fr.len,fr.lasttime};
        }
        for (auto x : nodes[fr.currnode])
        {
             if (x.time>fr.lasttime)
             {
                 if (maxlen[x.to].bestcost<fr.len+1)
                 {
                     q.push({x.to,x.time,fr.len+1});
                 }
                 else if (maxlen[x.to].bestcost==fr.len+1 && maxlen[fr.currnode].besttime>x.time)
                 {
                     q.push({x.to,x.time,fr.len+1});
                 }
             }
             else
             {
                 break;
             }
        }
    }
    for (i=1;i<=n;i++)
    {
         cout << maxlen[i].bestcost << " ";
    }
    return 0;
}
