#include "twins.h"
#include <cmath>
#include <iostream>
using namespace std;

vector<int> play (int n, int t) {
	vector<int> ans;
	int i;
	int j;
	int bucket = sqrt(n);
	vector<vector<int>> buckets, secondguess;

	for (i = 0; i < n; i++) {
		int place = i/bucket;
		if (place == buckets.size()) buckets.push_back({});
		buckets[place].push_back(i + 1);
	}
	string s = guess(buckets);
	for (i = 0; i < s.size() && t; i++) {
		if (s[i] == '1' || s[i] == '2') {
			secondguess.clear();
			for (j = 0; j < buckets[i].size() - 1; j++) {

				secondguess.push_back({j + 1 + i * bucket});
			}
			string s2 = guess(secondguess);
			int cop = t;
			for (j = 0; j < s2.size(); j++)
			{
				if (s2[j] == '1')
				{
					ans.push_back(i * bucket + j + 1);
					t--;
				}
			}
			if (cop == t)
			{
				ans.push_back(i * bucket + s2.size()+1);
				t--;
			}
		}
	}
	return ans;
}

