#include <bits/stdc++.h>
using namespace std;

#define MAXN 100000
#define INF 2000000000

vector<int> adj[MAXN];
vector<int> cost[MAXN];
int rez[MAXN];
int nr[MAXN];

deque<int> noduri;
deque<int> cs;
deque<int> depth;

void dfs(int nod, int depth, int prev) {
  int i;

  if(depth > rez[nod])
    rez[nod] = depth;
  for(i = 0; i < nr[nod]; i++)
    if(cost[nod][i] > prev)
      dfs(adj[nod][i], depth + 1, cost[nod][i]);
}

int main() {
  int n, m, i, a, b, c;

  scanf("%d%d", &n, &m);
  for(i = 0; i < m; i++) {
    scanf("%d%d%d", &a, &b, &c);
    a--;
    b--;

    adj[a].push_back(b);
    cost[a].push_back(c);

    adj[b].push_back(a);
    cost[b].push_back(c);

    nr[a]++;
    nr[b]++;
  }

  noduri.push_back(0);
  depth.push_back(0);
  cs.push_back(0);
  int cnt = 0;
  while(!noduri.empty()) {
    cnt++;
    rez[noduri.front()] = depth.front();
    for(i = 0; i < nr[noduri.front()]; i++) {
      if(cost[noduri.front()][i] > cs.front() && cost[noduri.front()][i] > rez[adj[noduri.front()][i]]) {
        noduri.push_back(adj[noduri.front()][i]);
        depth.push_back(depth.front() + 1);
        cs.push_back(cost[noduri.front()][i]);
      }
    }
    noduri.pop_front();
    depth.pop_front();
    cs.pop_front();
  }

  for(i = 0; i < n; i++) {
    printf("%d ", rez[i]);
  }
  printf("\n");

  return 0;
}
