/*
     _      _       _ 
    | | ___| | __ _| |
 _  | |/ _ \ |/ _` | |
| |_| |  __/ | (_| | |
 \___/ \___|_|\__,_|_|
  
*/
#include <iostream>
#include <queue>

using namespace std;
  
// #define int long long
  
const int N = 5e4 + 10;
const int md = 1e9 + 7;
const int INF = 1e9;

int32_t main(int32_t argc, char *argv[]) {
  ios::sync_with_stdio(false); cin.tie(nullptr);
  
  int T = 1;
  // cin >> T;
  while (T--) {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> adj(n + 1);
    vector<int> vs(n + 1);
    for (int i = 0; i < m; i++) {
      int a, b, c;
      cin >> a >> b >> c;
      adj[a].push_back({b, c});
      adj[b].push_back({a, c});
      vs[a] = max(vs[a], c);
      vs[b] = max(vs[b], c);
    }
    vector<int> ans(n + 1);
    queue<pair<int, int>> q;
    q.push({1, 0});
    queue<int> q2;
    q2.push(1);
    while (!q.empty()) {
      auto &[u, v] = q.front();
      int k = q2.front();
      q.pop(), q2.pop();
      if (v >= vs[u]) continue;
      for (auto &[a, c] : adj[u]) {
        if (v < c) {
          q.push({a, c});
          q2.push(k + 1);
          ans[a] = max(ans[a], k);
        }
      }
    }
    for (int i = 1; i <= n; i++)
      cout << ans[i] << " ";
    cout << '\n';
  }

  return 0;
}