#include<iostream>
#include<vector>
#include "twins.h"
using namespace std;

int solve1(int l, int r) {
    int N = r - l;
    vector<vector<int>> q;
    int cnt = 0, cur = 1;
    for (cur = 1; cur <= N / 2; cur *= 2) {
        q.push_back(vector<int>());
       for (int i = 0; i < N; i++) {
            if ((i / cur) & 1) {
                i += cur;
                if (i >= N) {
                    break;
                }
            }
            q[cnt].push_back(i + 1 + l);
       }
       cnt++;
    }
    q.push_back(vector<int>());
    for (int i = cur; i < N; i++) {
        q[q.size() - 1].push_back(i + 1 + l);
    }
    string res = guess(q);
    int ans = 0;
    for (int i = res.size() - 2; i >= 0; i--) {
        ans *= 2;
        ans += !(res[i] - '0');
    }
    if (res[res.size() - 1] == '1') {
        ans += cur;
    }
    ans += l;
    ans++;
    return ans;
}

std::vector<int> play(int N,int T) {
    if (T == 1) {
        return {solve1(0, N)};
    } else {
        vector<vector<int>> q;
        q.resize(150);
        int cnt = 0, cur = 1;
        for (cur = 1; cur <= N / 2; cur *= 2) {
           for (int i = 0; i < N; i++) {
                if ((i / cur) & 1) {
                    i += cur;
                    if (i >= N) {
                        break;
                    }
                }
                q[2 * cnt].push_back(i + 1);
           }
           cnt++;
        }
        int newCnt = 0;
        for (cur = 1; cur <= N / 2; cur *= 2) {
            for (int i = 0; i < N; i++) {
                if (!((i / cur) & 1)) {
                    i += cur;
                    if (i >= N) {
                        break;
                    }
                }
                q[2 * newCnt + 1].push_back(i + 1);
           }
           newCnt++;
        }
        q.push_back(vector<int>());
        for (int i = cur; i < N; i++) {
            q[cnt * 2].push_back(i + 1);
        }

        q.erase(q.begin() + cnt * 2 + 1, q.end());

        string res = guess(q);
        bool bif = 0;
        int ans = 0;
        int l = 0, r = N;
        int temp = cur;
        cur /= 2;
        for (int i = res.size() - 2; i > 0; i -= 2) {
            if (!bif && res[i] == '1' && res[i - 1] == '1') {
                bif = 1;
                ans *= 2;
                continue;
            }
            if (bif) {
                ans *= 2;
                continue;
            }
            ans *= 2;
            ans += (res[i] - '0');
            cur /= 2;
        }
        int lx = ans;
        int rx = ans + cur;
        int a1 = solve1(lx, rx);
        int a2 = solve1(rx, rx + cur);
        if (res[res.size() - 1] == '1') {
            a1 += temp;
            a2 += temp;
        }
        return {a1, a2};
    }
    return {1};
}
