#include <bits/stdc++.h>
using namespace std;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cout.tie(NULL);
    cin.tie(NULL);
    cerr.tie(NULL);
}

const int N = 1e5+1; // -
vector<pair<int, int>> to[N];
int ans[N];
int n, m;

void dfs(int curr, int fin, int len, int p){
    if(curr == fin){
        if(len > 0){
            ans[fin] = max(ans[fin], len);
        }
    }
    for(auto &it:to[curr]){
        if(p < it.second){
            dfs(it.first, fin, len+1, it.second);
        }
    }
    return;
}

void dfs1(int curr, int p, int len){
    ans[curr] = len;
    for(auto &it:to[curr]){
        if(it.second > p){
            dfs1(it.first, it.second, len+1);
        }
    }
}

int main(){
    fastIO();
    cin>>n>>m;
    for(int i=1; i<=m; i++){
        int a, b, c;
        cin>>a>>b>>c;
        to[a].push_back({b, c});
        to[b].push_back({a, c});
    }
    if(n <= 10){
        for(int i=1; i<=n; i++){
            dfs(1, i, 0, -1);
        }
    }else{
        dfs1(1, -1, 0);
    }
    for(int i=1; i<=n; i++){
        cout<<ans[i]<<" ";
    }
    cout<<endl;
    return 0;
}











