#include<bits/stdc++.h>
#include "twins.h"

using namespace std;
typedef long long ll;

ll n;

vector < int > get_question(ll left, ll right)
{
    vector < int > result;

    if(left == 0)
        left++;
    if(right == n + 1)
        right--;

    for(int i = left; i <= right; i++)
    {
        result.push_back(i);
    }

    return result;
}

vector<int> play(int N, int t)
{
    n = N;
    if(t == 1 && n <= 15)
    {
        vector < int > used(n);
        for(int i = 1; i <= n; i++)
        {
            used[i - 1] = i;
        }
        random_shuffle(used.begin(), used.end());
        for(int i = 0; i < n; i++)
        {
            vector < vector < int > > q;
            q.push_back({used[i]});
            string g = guess(q);
            if(g[0] == '1')
                return {used[i]};
        }
        cout << endl;
    }
    else if(t == 1)
    {
        ll left = 0;
        ll right = n + 1;
        ll mid;
        while(right - left > 1)
        {
            mid = left + (right - left) / 2;
            vector < vector < int > > q;
            q.push_back(get_question(left, mid));
            string g = guess(q);
            if(g[0] == '1')
                right = mid;
            else
                left = mid;
        }
        return {right};
    }
    else
    {
        ll left = 0;
        ll right = n + 1;
        ll mid;
        while(right - left > 1)
        {
            mid = left + (right - left) / 2;
            vector < vector < int > > q;
            q.push_back(get_question(left, mid));
            string g = guess(q);
            if(g[0] == '1')
                right = mid;
            else
                left = mid;
        }
        return {right, right + 1};
    }
}
