#include <bits/stdc++.h>
#include "twins.h"

std::vector <std::vector <int>> query(500);

void build(int depth, int l, int r) {
    if (l >= r) {
        return;
    }

    int m = (l + r) / 2;

    for (int i = l; i <= m; i++) {
        query[depth].push_back(i);
    }

    build(depth + 1, l, m);
    build(depth + 1, m + 1, r);
}

std::vector <int> play(int n, int t) {
        build(0, 1, n);
        while (query.size() && query.back().empty()) query.pop_back();

        std::string ans = guess(query);

        int l = 1, r = n;

        for (int i = 0; i < ans.size(); i++) {
            int m = (l + r) / 2;
            bool is = ans[i] == '1';

            if (is) {
                r = m;
            } else {
                l = m + 1;
            }
        }

    if (t == 1)    return {r};
    else return {t, t + 1};
}
