#include <bits/stdc++.h>
using namespace std;

vector <pair <int, int>> edges[100001];

set <pair <int, int>> moments[100001]; /// {cost, value}
priority_queue <pair <pair <int, int>, int>> pq;

bool check(set <pair <int, int>>& s, pair <int, int> p) {
    auto it = s.upper_bound(p);
    pair <int, int> lower_val, upper_val;

    if (it == s.end()) {
        upper_val = {INT_MAX, INT_MAX};
    } else {
        upper_val = *it;
    }

    if (it == s.begin()) {
        lower_val = {INT_MIN, INT_MIN};
    } else {
        it--;
        lower_val = (*it);
        it++;
    }



    bool ans = lower_val.second < p.second && p.second < upper_val.second;
    ///cout << "CHECK " << p.first << ' ' << p.second << ' ' << ans << endl;
    ///cout << lower_val.first << ' ' << lower_val.second << ' ' << upper_val.first << ' ' << upper_val.second << endl;

    if (lower_val.second >= p.second) return 0;
    else if (lower_val.first == p.first) s.erase(lower_val);

    if (p.second >= upper_val.second) s.erase(upper_val);
    else if (p.first == upper_val.first) return 0;

    return 1;
}

void push(pair <pair <int, int>, int> info, pair <int, int> edge) {
    info.first.first *= -1; /// {cost, value}, vertice
    if (info.first.first >= edge.second) return;
    if (moments[edge.first].size() && !check(moments[edge.first], {edge.second, info.first.second + 1})) return;///(*moments[edge.first].upper_bound({edge.first, INT_MAX})).second > info.first.second + 1) return;///edge.second <= moments[edge.first].back().first) return;

    moments[edge.first].insert({edge.second, info.first.second + 1});
    pq.push({{-edge.second, info.first.second + 1}, edge.first});
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;

        edges[a].push_back({b, c});
        edges[b].push_back({a, c});
    }

    pq.push({{0, 0}, 1});
    moments[1].insert({0, 0});

    while (pq.size()) {
        auto pos = pq.top(); /// {-cost, value}, vertice
        pq.pop();

        ///cout << pos.second << ' ' << -pos.first.first << ' ' << pos.first.second << endl;

        for (auto edge : edges[pos.second]) {
            push(pos, edge);
        }
    }

    for (int i = 1; i <= n; i++) {
        if (moments[i].empty()) cout << 0 << ' ';
        else {
            auto it = moments[i].end();
            it--;
            cout << (*it).second << ' ';
        }
    }

    return 0;

}

