#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5 * 1e5 + 1;
const int MAXC = 1e6 + 1;
const int MAXROOT = MAXN + MAXC + 1;
const int COLORADD = 5 * 1e5;
int N, Q;
int Ans = 0;
vector<int> Graph[MAXROOT];
bool Visited[MAXC];

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;

    for(int i = 1; i <= N; i++)
    {
        int K;
        cin >> K;

        for(int j = 1; j <= K; j++)
        {
            int Color;
            cin >> Color;
            Graph[i].push_back(Color);
        }
    }
}

void Check(int l, int r)
{
    if(l == 1 && r == N)
    {
        Ans = 1;
        return;
    }

    if(l != 1)
    {
        vector<int> V;

        for(auto& Color : Graph[l - 1])
        {
            if(!Visited[Color])
            {
                V.push_back(Color);
            }
        }

        if(!V.empty())
        {
            for(auto& U : V)
            {
                Visited[U] = true;
            }

            Check(l - 1, r);

            for(auto& U : V)
            {
                Visited[U] = false;
            }
        }
    }

    if(r != N)
    {
        vector<int> V;

        for(auto& Color : Graph[r + 1])
        {
            if(!Visited[Color])
            {
                V.push_back(Color);
            }
        }

        if(!V.empty())
        {
            for(auto& U : V)
            {
                Visited[U] = true;
            }

            Check(l, r + 1);

            for(auto& U : V)
            {
                Visited[U] = false;
            }
        }
    }
}


void Solve()
{
    cin >> Q;

    while(Q--)
    {
        int l, r;
        cin >> l >> r;

        for(int i = 1; i < MAXC; i++)
        {
            Visited[i] = false;
        }

        for(int i = l; i <= r; i++)
        {
            for(auto& Color : Graph[i])
            {
                Visited[Color] = true;
            }
        }

        Ans = 0;

        Check(l, r);
        cout << Ans << '\n';
    }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
