#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5 * 1e5 + 1;
const int MAXM = 1e6 + 1;
int N, Q;
set<int> A[MAXM];
int Visited_Left[MAXM];
int Visited_Right[MAXM];
int Mark;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;

    for(int i = 1; i <= N; i++)
    {
        int Size;
        cin >> Size;

        for(int j = 0; j < Size; j++)
        {
            int X;
            cin >> X;
            A[i].insert(X);
        }
    }
}

bool Check(int left, int right)
{
    map<set<int>, int> dp;

    for(int i = left; i <= right; i++)
    {
        for(auto& X : A[i])
        {
            Visited_Left[X] = Mark;
            Visited_Right[X] = Mark;
        }
    }

    left--;

    while(left > 0)
    {
        bool Able = false;

        for(auto& X : A[left])
        {
            if(Visited_Left[X] != Mark)
            {
                Able = true;
            }

            Visited_Left[X] = Mark;
        }

        if(!Able)
        {
            return false;
        }

        dp[A[left]]++;

        left--;
    }

    right++;

    while(right <= N)
    {
        bool Able = false;

        for(auto& X : A[right])
        {
            if(Visited_Right[X] != Mark)
            {
                Able = true;
            }

            Visited_Right[X] = Mark;
        }

        if(!Able)
        {
            return false;
        }

        dp[A[right]]++;

        if(dp[A[right]] > 1)
        {
            return false;
        }

        right++;
    }

    return true;
}

void Solve()
{
    cin >> Q;

    while(Q--)
    {
        int left, right;
        cin >> left >> right;
        Mark++;

        if(Check(left, right))
        {
            cout << 1 << '\n';
        }
        else
        {
            cout << 0 << '\n';
        }
    }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
