#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e4 + 1;
const int MAXM = 1e6 + 1;
int N, M;
int dp[MAXN][MAXN];
vector<pair<int, int>> Graph[MAXN];
vector<tuple<int, int, int>> Edges;
unordered_map<int, int> Decode;
int Code;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < M; i++)
    {
        int U, V, W; cin >> U >> V >> W;
        Edges.push_back({W, U, V});
    }

    sort(Edges.begin(), Edges.end());

    for(int i = 0; i < M; i++)
    {
        int U, V, W;
        tie(W, U, V) = Edges[i];

        if(Decode[W] == 0)
        {
            Code++;
            Decode[W] = Code;
        }

        W = Decode[W];
        Graph[U].push_back({V, W});
        Graph[V].push_back({U, W});
    }
}

void Dfs(int U, int W)
{
    for(auto& V : Graph[U])
    {
        if(W < V.second)
        {
            if(dp[V.first][V.second] < dp[U][W] + 1)
            {
                dp[V.first][V.second] = dp[U][W] + 1;
                Dfs(V.first, V.second);
            }
        }
    }
}

void Solve()
{
    Dfs(1, 0);

    for(int i = 1; i <= N; i++)
    {
        int Ans = 0;

        for(int j = 1; j <= M; j++)
        {
            Ans = max(Ans, dp[i][j]);
        }

        cout << Ans << " ";
    }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}

