#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 1;
const int MAXM = 1e6 + 1;
int N, M;
vector<tuple<int, int, int>> Edges;
long long dp[MAXN][2];

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < M; i++)
    {
        int U, V, W;
        cin >> U >> V >> W;
        Edges.push_back({W, U, V});
    }

    sort(Edges.begin(), Edges.end());
}


void Solve()
{
    dp[1][0] = 1;
    dp[1][1] = 1;

    for(int i = 0; i < M; i++)
    {
        int U, V, W;
        tie(W, U, V) = Edges[i];

        if(i == 0 || get<0>(Edges[i]) != get<0>(Edges[i - 1]))
        {
            dp[U][0] = dp[U][1];
            dp[V][0] = dp[V][1];
        }

        long long A = dp[U][0], B = dp[V][0];

        if(A > 0)
        {
            dp[V][1] = max(dp[V][1], A + 1);
        }

        if(B > 0)
        {
            dp[U][1] = max(dp[U][1], B + 1);
        }
    }

    for(int i = 1; i <= N; i++)
    {
        long long Ans = dp[i][1];

        if(Ans == 0)
        {
            cout << 0 << " ";
        }
        else
        {
            cout << Ans - 1 << " ";
        }
    }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}

