# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;

const int MAXK=5e5+11,MAXN=3e3+11,INF=1e9;
vector<int> a[MAXN];
vector<int> col[MAXK];
vector<int> pos[MAXN];
int le[MAXN];
int ri[MAXN];
int n,q;

void reset()
{
    for(int i=1;i<=n;i++)
    {
        le[i]=INF;
        ri[i]=0;
    }
}

void precomp()
{
    reset();
    for(int i=1;i<=n;i++)
    {
        int id=-1;
        for(int k: a[i])
        {
            id++;
            int p=pos[i][id];

            ///nalqvo
            if(p==0) le[i]=min(le[i],1);
            else le[i]=min(le[i],col[k][p-1]+1);

            ///nadqsno
            if(p==col[k].size()-1) ri[i]=max(ri[i],n);
            else ri[i]=max(ri[i],col[k][p+1]-1);
        }

        //cout<<i<<":"<<le[i]<<" "<<ri[i]<<"\n";
    }
}

bool dp[MAXN][MAXN];

void test_reset()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=i;j<=n;j++)
        {
            dp[i][j]=0;
        }
    }
}

void solve(int l, int r)
{
    dp[l][r]=1;
    if(l!=1 and !dp[l-1][r])
    {
        if(ri[l-1]>=r) solve(l-1,r);
    }

    if(r!=n and !dp[l][r+1])
    {
        if(le[r+1]<=l) solve(l,r+1);
    }
}

void test_solve()
{
    int l,r;
    cin>>l>>r;
    test_reset();

    solve(l,r);
    if(dp[1][n]) cout<<1<<"\n";
    else cout<<0<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++)
    {
        int br;
        cin>>br;

        while(br--)
        {
            int c;
            cin>>c;
            a[i].push_back(c);
            col[c].push_back(i);
            pos[i].push_back(col[c].size()-1);
        }
    }

    precomp();

    cin>>q;
    while(q--)
    {
        test_solve();
    }

    return 0;
}
