# include<iostream>
# include "twins.h"
//# include "Lgrader.cpp"
using namespace std;

const int MAX=5e4+11,INF=1e9;
int n, t;
int used[MAX];
vector<vector<int>> ask;
bool pos[MAX];

void solve(int l, int r, int power)
{
    if(l>r) return ;

    //cout<<l<<" "<<r<<" "<<power<<"\n";

    int mid=(l+r)/2;

    for(int i=l;i<=mid;i++) ask[power].push_back(i);

    if(l==r) return ;
    solve(l,mid,power+1);
    solve(mid+1,r,power+1);
}

vector<int> play(int N,int T)
{
    n=N;
    t=T;
    ask.resize(n+1);

    for(int i=1;i<=n;i++) pos[i]=1;

    solve(1,n,0);

    string s=guess(ask);
    for(int i=0;i<s.size();i++)
    {
        if(ask[i].size()==0) continue;

        if(s[i]=='0')
        {
            for(int x: ask[i]) pos[x]=0;
        }
        else
        {
            for(int x: ask[i]) used[x]=i+1;
            for(int k=1;k<=n;k++) if(used[k]!=i+1) pos[k]=0;
        }

    }

    vector<int> ans;
    for(int i=1;i<=n;i++) if(pos[i]) ans.push_back(i);
    return ans;
}
