#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << "; "
// #define cerr if (false) cerr

const int INF = 1e9 + 10;
const int MAX_N = 5 * 1e5 + 10;
const int MAX_C = 1e6 + 10;


int n;
bool used[MAX_C];
int cnt[MAX_C];
vector <int> colors[MAX_N];

bool solve (int l, int r) {
    if (l == 1 && r == n) {
        return true;
    }

    if (l - 1 >= 1) {
        for (int cI = 0; cI < colors[l - 1].size(); cI ++) {
            int currColor = colors[l - 1][cI];

            if (used[currColor]) continue;

            //cout << "Going to try " << out(l - 1) << out(r) << endl;

            used[currColor] = true;
            bool ans = solve (l - 1, r);
            used[currColor] = false;
            if (ans) {
                //cout << out(l - 1) << out(r) << "worked" << endl;
                return true;
            }
        }
    }
    if (r + 1 <= n) {
        for (int cI = 0; cI < colors[r + 1].size(); cI ++) {
            int currColor = colors[r + 1][cI];

            if (used[currColor]) continue;
            //cout << "Going to try " << out(l) << out(r + 1) << endl;

            used[currColor] = true;
            bool ans = solve (l, r + 1);
            used[currColor] = false;
            if (ans) {
                //cout << out(l) << out(r + 1) << "worked" << endl;
                return true;
            }
        }
    }

    return false;
}


bool cmp (int a, int b) {
    return cnt[a] < cnt[b];
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; i ++) {
        int k;
        cin >> k;

        for (int j = 0; j < k; j ++) {
            int c; cin >> c;

            cnt[c] ++;
            colors[i].push_back (c);
        }
    }

    for (int i = 1; i <= n; i ++) {
        sort(colors[i].begin(), colors[i].end(), cmp);
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; i ++) {
        int l, r;
        cin >> l >> r;

        for (int j = l; j <= r; j ++) {
            for (int cI = 0; cI < colors[j].size(); cI ++) {
                used[colors[j][cI]] = true;
            }
        }

        if (solve (l, r)) {
            cout << 1 << endl;
        } else {
            cout << 0 << endl;
        }
        memset(used, false, sizeof(used));
    }
    return 0;
}
