#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << "; "
// #define cerr if (false) cerr

const int INF = 1e9 + 10;
const int MAX_N = 1e5 + 10;

int n, m;

vector <pair <int, int>> susNa[MAX_N];
priority_queue <pair <int, pair<int, int>> > pq;

int ans[MAX_N];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;

    for (int i = 0; i < m; i ++) {
        int a, b, c;
        cin >> a >> b >> c;

        susNa[b].push_back({a, c});
        susNa[a].push_back({b, c});
    }

    pq.push({0, {0, 1}});

    while (!pq.empty()) {
        int curr = pq.top().second.second;
        int time = -pq.top().first;
        int rebra = -pq.top().second.first;
        pq.pop();
        //cout << "TEST " << curr << " " << out(curr) << out(time) << out(rebra) << out(ans[curr]) << endl;
        if (ans[curr] > rebra) continue;

        //cout << "In for " << out(curr) << out(time) << out(rebra) << endl;

        ans[curr] = rebra;

        for (int i = 0; i < susNa[curr].size(); i ++) {
            //cout << "Trying " << susNa[curr][i].first << " " << susNa[curr][i].second << endl;
            if (susNa[curr][i].second > time) {
                //cout << "Add " << susNa[curr][i].first << endl;
                pq.push({-susNa[curr][i].second, {-(rebra + 1), susNa[curr][i].first}});
            }
        }
    }

    for (int i = 1; i <= n; i ++) {
        cout << ans[i] << " ";
    }

    return 0;
}
