#include<bits/stdc++.h>
using namespace std;

const int MAX=(1e6)+5;

int n;
set<int>s[MAX];
vector<int>v[MAX];

void Init(int l,int r)
{
    for(int i=1; i<l; i++)
    {
        for(int j=0; j<v[i].size(); j++)
        {
            s[i].insert(v[i][j]);
        }
    }
    for(int i=r+1; i<=n; i++)
    {
        for(int j=0; j<v[i].size(); j++)
        {
            s[i].insert(v[i][j]);
        }
    }
    for(int k=1; k<l; k++)
    {
        for(int i=l; i<=r; i++)
        {
            for(int j=0; j<v[i].size(); j++)
            {
                s[k].erase(v[i][j]);
            }
        }
    }
    for(int k=r+1; k<=n; k++)
    {
        for(int i=l; i<=r; i++)
        {
            for(int j=0; j<v[i].size(); j++)
            {
                s[k].erase(v[i][j]);
            }
        }
    }
}

void Process(int x,int y,int z)
{
    for(auto it=s[y].begin();it!=s[y].end();++it)
    {
        if(1<=x&&x<=n)
            s[x].erase(*it);
        if(1<=z&&z<=n)
            s[z].erase(*it);
    }
}

void Solve()
{
    cin>>n;
    int x,z,l,r,q;
    for(int i=1; i<=n; i++)
    {
        cin>>x;
        for(int j=0; j<x; j++)
        {
            cin>>z;
            v[i].push_back(z);
        }
    }
    cin>>q;
    bool b;
    for(int i=0; i<q; i++)
    {
        cin>>l>>r;
        Init(l,r);
        b=1;
        while(l>1&&r<n)
        {
            if(l==1||s[l-1].size()>s[r+1].size())
            {
                r++;
                if(s[r].size()==0)
                {
                    b=0;
                    break;
                }
                Process(l-1,r,r+1);
            }
            else
            {
                l--;
                if(s[l].size()==0)
                {
                    b=0;
                    break;
                }
                Process(l-1,l,r+1);
            }
        }
        cout<<b<<endl;
    }
}

signed main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    Solve();
    return 0;
}
