#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(v) v.begin(), v.end()

const int N = 1e5+10;
vector<pair<int,int>>adj[N];
ll dist[N];
int n, m;

void dfs(int node, int parent)
{
    dist[node] = dist[parent] + 1;
    for(auto i : adj[node])
    {
        if(i.second > adj[parent][node].second)
        {
            dfs(i.first, node);
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> n >> m;
    for(int i = 0; i < m; i++)
    {
        int a, b, c;
        adj[a].push_back({b, c});
        adj[b].push_back({a, c});
    }
    dfs(1, 0);
    for(int i = 1; i <= n; i++)
    {
        cout << dist[i] << ' ';
    }
    cout << '\n';
}