#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 1e5+2;
int x[N][N];
vector<int>adj[N];
vector<int>ans(N);
int vis[N];

void dfs(int src, int last, int len)
{
	cout << src << ' ' << last << ' ' << len << endl;
	ans[src] = max(ans[src], len);
	vis[src] = true;
	for(auto it:adj[src])
	{
		if(vis[it])
		{
			if(x[src][it] > last)
			{
				ans[it] = max(ans[it], len+1);
			}
		}
		else
		{
			if(x[src][it] > last)
			{
				dfs(it, x[src][it], len+1);
				vis[it] = false;
			}
		}
	}
}

signed main()
{
	int n, m;
	cin >> n >> m;
	for(int i = 0; i < m; i++)
	{
		int a, b, c;
		cin >>a >> b >> c;
		adj[a].push_back(b);
		adj[b].push_back(a);
		x[a][b] = c;
	}
	queue<pair<int, int>>q;
	vector<int>dep(n+1);
	q.push({1, 0});
	while(q.size())
	{
		int src = q.front().first, last = q.front().second;
		q.pop();
		for(auto it:adj[src])
		{
			if(!vis[it]) 
			{
				if(x[src][it] > last)
				{
					q.push({it, x[src][it]});
					dep[it] = max(dep[src]+1, dep[it]);
				}
			}
			else
			{
				if(x[src][it] > last)
				{
					dep[it] = max(dep[src]+1, dep[it]);
				}
			}
		}
	}
	//dfs(1, 0, 0);
	for(int j = 1; j <= n; j++)
	{
		cout << dep[j] << endl;
	}
}