#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
using namespace std;
using ll = int;

int main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(0);
	ll n;
	cin >> n;
	vector<vector<ll>> v(n);
	map<ll, ll> nb;
	for (int i = 0; i < n; i++) {
		ll K;
		cin >> K;
		v[i].resize(K);
		for (int j = 0; j < K; j++) {
			cin >> v[i][j];
			nb[v[i][j]] = -1;
		}
	}
	ll m = 0;
	for (auto& [a, b] : nb) {
		b = m;
		m++;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < v[i].size(); j++) {
			v[i][j] = nb[v[i][j]];
		}
	}
	vector<vector<ll>> g(m);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < v[i].size(); j++) {
			g[v[i][j]].push_back(i);
		}
	}
	vector<ll> r(n);
	for (int i = 0; i < n; i++) {
		ll mx = i + 1;
		for (int j = 0; j < v[i].size(); j++) {
			auto x = upper_bound(g[v[i][j]].begin(), g[v[i][j]].end(), i);
			mx = max(mx, (x != g[v[i][j]].end() ? *x : n));
		}
		r[i] = mx;
	}
	vector<ll> l(n);
	for (int i = 0; i < n; i++) {
		ll mn = i - 1;
		for (int j = 0; j < v[i].size(); j++) {
			auto x = lower_bound(g[v[i][j]].begin(), g[v[i][j]].end(), i);
			mn = min(mn, (x != g[v[i][j]].begin() ? *(x - 1) : -1));
		}
		l[i] = mn;
	}
	vector<ll> lb(n, -1), rb(n, n);
	for (ll i = 0; i < n; i++) {
		if (l[i] != -1) lb[l[i]] = max(lb[l[i]], i);
		if (r[i] != n) rb[r[i]] = min(rb[r[i]], i);
	}
	ll Q = 0;
	cin >> Q;
	for (int i = 0; i < Q; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		bool f = 1;
		while (a >= 1 || b < n - 1) {
			if (a >= 1 && lb[a - 1] <= b && b < r[a - 1]) {
				a--;
			} else if (b < n - 1 && a <= rb[b + 1] && l[b + 1] < a) {
				b++;
			} else {
				cout << 0;
				f = 0;
				break;
			}
		}
		if (f && (a != 0 || b != n - 1)) {
			cout << 0; f = 0;
		}
		if (f) cout << 1;
		cout << endl;
	}	
}