#include <bits/stdc++.h>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<tuple<int, int, int>>> grOr(n + 1);
    vector<int> tm(m);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        grOr[a - 1].emplace_back(b - 1, c, i);
        grOr[b - 1].emplace_back(a - 1, c, i);
        tm[i] = c;
    }
    tm.push_back(0);
    sort(tm.begin(), tm.end());
    tm.resize(unique(tm.begin(), tm.end()) - tm.begin());
    for (int u = 0; u < n; ++u) {
        for (int i = 0; i < (int) grOr[u].size(); ++i) {
            auto [v, c, j] = grOr[u][i];
            c = lower_bound(tm.begin(), tm.end(), c) - tm.begin();
            grOr[u][i] = {v, c, j};
        }
    }
    vector<int> ans(n);
    vector<vector<int>> a(n, vector<int>(tm.size(), -1000000000));
    a[0][0] = 0;
    for (int t = 0; t < (int) tm.size(); ++t) {
        for (int u = 0; u < n; ++u) {
            for (auto [v, c, i] : grOr[u]) {
                if (c > t) {
                    a[v][c] = max(a[v][c], a[u][t] + 1);
                    ans[v] = max(ans[v], a[u][t] + 1);
                }
            }
        }
    }
    for (int el : ans) {
        cout << el << " ";
    }
    cout << "\n";
}