#include<iostream>
#include "twins.h"

using namespace std;

int fdp(int l, int r){
    while(l!=r){
        //cout << l << " " << r << "\n";
        int m = (r+l)/2;
        vector<int> quest;
        for(int i = l; i <= m; i++) quest.push_back(i);
        vector<vector<int>> tmp;
        tmp.push_back(quest);
        string res = guess(tmp);
        if(res == "1") r = m;
        else l = m+1;
    }
    return l;
}

pair<int, int> fdp2(int l1, int r1, int l2, int r2){
    while(l1!=r1 || l2 != r2){
        int m1 = (r1+l1)/2;
        int m2 = (r2+l2)/2;
        vector<vector<int>> tmp;
        vector<int> quest;
        for(int i = l1; i <= m1; i++) quest.push_back(i);
        tmp.push_back(quest);
        quest.clear();
        for(int i = l2; i <= m2; i++) quest.push_back(i);
        tmp.push_back(quest);
        quest.clear();
        string res = guess(tmp);
        if(l1 != r1){
            if(res[0] == '1') r1 = m1;
            else l1 = m1+1;
        }
        if(l2 != r2){
            if(res[1] == '1') r2 = m2;
            else l2 = m2+1;
        }
    }
    return {l1, l2};
}

std::vector<int> play(int N,int T){
    vector<int> ans;
    if(N <= 30){
        ans.push_back(fdp(1, N));
        return ans;
    }
    int l = 1, r = N;
    while(1){
        //cout << l << " " << r << " lr\n";
        if(r == l){
            ans.push_back(l);
            break;
        }
        int m = (r+l)/2;
        vector<vector<int>> tmp;
        vector<int> quest;
        for(int i = l; i <= m; i++) quest.push_back(i);
        tmp.push_back(quest);
        quest.clear();
        for(int i = m+1; i <= r; i++) quest.push_back(i);
        tmp.push_back(quest);
        string res = guess(tmp);
        if(res == "01") l = m+1;
        if(res == "10") r = m;
        if(res == "11"){
            auto [x, y] = fdp2(l, m, m+1, r);
            ans.push_back(x);
            ans.push_back(y);
            break;
        }
    }
    //cout << ans.size() << "\n";
    return ans;
}

