#include <bits/stdc++.h>

using namespace std;

#define all(x) X.begin(), x.end();

#define debug(x)
#ifdef LOC
#define debug(x) cout << #x << " = " << x << '\n';
#endif

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;

        for (int j = 0; j < m; ++j) {
            int x;
            cin >> x;
            v[i].push_back(x - 1);
        }
    }

    int q;
    cin >> q;

    vector<vector<bool>> dp(n + 1, vector<bool>(n, 0));
    dp[n][0] = 1;

    for (int len = n - 1; len >= 1; len--) {
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len;

            set<int> clrs;
            for (int i = 0; i < n; ++i)
            {
                clrs.insert(i);
            }

            int lsm = 0;
            if (l == 0)
                lsm = 0;
            else
                for (int c : v[l - 1])
                {
                    lsm += clrs.count(c);
                }
            int rsm = 0;
            if (r == n)
                rsm = 0;
            else
                for (int c : v[r])
                {
                    rsm += clrs.count(c);
                }

            if (lsm > 0)
                dp[len][l] = dp[len][l] || dp[len + 1][l - 1];
            if (rsm > 0)
                dp[len][l] = dp[len][l] || dp[len + 1][l];
        }
    }

    for (int i = 0; i < q; ++i)
    {
        

        int l, r;
        cin >> l >> r;
        l--;

        int len = (r - l);

        cout << dp[len][l] << "\n";
    }
}

int main() {
    int q = 1;
#ifdef LOC
    cin >> q;
#endif

    for (int i = 0; i < q; ++i) solve(); 
}