#include <bits/stdc++.h>

using namespace std;

#define all(x) X.begin(), x.end();

#define debug(x)
#ifdef LOC
#define debug(x) cout << #x << " = " << x << '\n';
#endif

const int INF = 1e9;

vector<vector<int>> v;
vector<vector<bool>> dp;
vector<vector<bool>> used;
int n;

bool get(int len, int l) {
    if (used[len][l])
        return dp[len][l];
    int r = l + len;

    set<int> clrs;
    for (int i = l; i < r; ++i)
    {   
        for (int c : v[i]) clrs.insert(c);
    }

    int lsm = 0;
    if (l == 0)
        lsm = 0;
    else
        for (int c : v[l - 1])
        {
            lsm += 1 - clrs.count(c);
        }
    int rsm = 0;
    if (r == n)
        rsm = 0;
    else
        for (int c : v[r])
        {
            rsm += 1 - clrs.count(c);
        }
    // debug(l << " " << r << " " << lsm << " " << rsm);
    if (lsm > 0)
        dp[len][l] = dp[len][l] || get(len + 1, l - 1);
    if (rsm > 0)
        dp[len][l] = dp[len][l] || get(len + 1, l);
    return dp[len][l];
}

void solve() {
    cin >> n;
    v = vector<vector<int>>(n);
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;

        for (int j = 0; j < m; ++j) {
            int x;
            cin >> x;
            v[i].push_back(x - 1);
        }
    }

    int q;
    cin >> q;

    dp = vector<vector<bool>> (n + 1, vector<bool>(n, 0));
    used = vector<vector<bool>> (n + 1, vector<bool>(n, 0));
    dp[n][0] = 1;
    used[n][0] = 1;
    for (int i = 0; i < q; ++i)
    {       

        int l, r;
        cin >> l >> r;
        l--;

        int len = (r - l);

        cout << get(len, l) << "\n";
    }
}

int main() {
    int q = 1;
#ifdef LOC
    cin >> q;
#endif

    for (int i = 0; i < q; ++i) solve(); 
}