#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(),x.end()

#define debug(x)
#ifdef LOC
#define debug(x) cout << #x << " = " << x << '\n';
#endif

const int INF = 1e9;
const int M = 7;

vector<vector<int>> v, nv;

bool is_cycle(vector<vector<int>>& g, vector<int>& used, int v) {
    debug(v);
    if (used[v] == 1)
        return 1;
    if (used[v] == 2)
        return 0;
    debug(v);

    used[v] = 1;

    for (int u : g[v])
    {
    debug(u);
        if (is_cycle(g, used, u))
            return 1;
    }
    used[v] = 2;
    return 0;
}

void solve() {
    int n;
    cin >> n;
    v = vector<vector<int>>(n);
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;

        for (int j = 0; j < m; ++j) {
            int x;
            cin >> x;
            v[i].push_back(x - 1);            
        }
    }

    int q;
    cin >> q;

    for (int qq = 0; qq < q; ++qq) {
        int l, r;
        cin >> l >> r;
        l--;
        debug(l);
        debug(r);

        vector<bool> st(M, 0);
        vector<int> lv(M, -1), rv(M, -1);
        for (int i = l; i < r; ++i)
        {
            for (int c : v[i]) st[c] = 1;
        }
        nv.assign(n, vector<int>(0));
        for (int i = l; i < n; ++i)
        {
            for (int c: v[i]) {     
                if (st[c]) continue;
                nv[i].push_back(c);
                rv[c] = i;
                st[c] = 1;
            }
        }
        st.assign(M, 0);
        for (int i = r - 1; i >= 0; --i)
        {
            for (int c: v[i]) {     
                if (st[c]) continue;
                nv[i].push_back(c);
                lv[c] = i;
                st[c] = 1;
            }
        }
        st.assign(M, 0);
        for (int i = l; i < r; ++i) {
            for (int c: nv[i]) {
                st[c] = 1;
            }
        }
        bool f = 1;

        for (int i = 0; i < n; ++i) {
            if ((i < l || r <= i) && nv[i].size() == 0) {
                cout << "0\n";
                f = 0;

                break;
            }
        }
        if (!f) continue;
            // for (int i : lv)
            //     cout << i << " ";
            // cout << endl;
            // for (int i : rv)
            //     cout << i << " ";
            // cout << endl;

        vector<vector<int>> g(n);
        for (int i = r; i < n; ++i)
        {
            for (int c : nv[i])
            {
                st[c] = 1;
            }
            for (int c: nv[i]) {
                int j = lv[c];
                if (j == -1) continue;
                bool w = 0;
                for (int lc : nv[j])
                {
                    if (st[lc] == 0) {
                        w = 1;
                    }
                }
                if (!w) {
                    g[j].push_back(i);
                }
            }    

            if (!f)
                break;        
        }

        if (!f) {
            cout << "0\n";
            continue;
        }

        st.assign(M, 0);
        for (int i = l; i < r; ++i) {
            for (int c: nv[i]) {
                st[c] = 1;
            }
        }

        for (int i = l - 1; i >= 0; --i)
        {
            for (int c: nv[i]) {
                st[c] = 1;
            }
            for (int c: nv[i]) {
                int j = rv[c];
                if (j == -1) continue;
                bool w = 0;
                for (int rc : nv[j])
                {
                    if (st[rc] == 0) {
                        w = 1;
                    }
                }
                if (!w) {
                    g[j].push_back(i);
                }
            } 
            if (!f)
                break;
        }

        for (int i = r + 1; i < n; ++i)
            g[i - 1].push_back(i);
        for (int i = 0; i < l - 1; ++i)
            g[i + 1].push_back(i);

        if (!f) {
            cout << "0\n";
            continue;
        }

        vector<int> used(n, 0);
        for (int i = 0; i < n; ++i) {
            if (used[i] == 0) {
                if (is_cycle(g, used, i)) {
                    cout << "0\n";
                    f = 0;
                    break;
                }
            }
        }

        if (!f) continue;
        cout << "1\n";
    }
}

int main() {
    int q = 1;
#ifdef LOC
    cin >> q;
#endif

    for (int i = 0; i < q; ++i) solve(); 
}