#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
const int N = 500000, C = 1000000;
int n;
vector<int> col[C];
int maxl[N], maxr[N];

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        while (k--) {
            int x;
            cin >> x;
            --x;
            col[x].push_back(i);
        }
    }
    fill(maxl, maxl + n, 1e9);
    fill(maxr, maxr + n, -1e9);
    for (int c = 0; c < C; ++c) {
        for (int i = col[c].size() - 1; i >= 0; --i) {
            if (i + 1 == col[c].size()) maxr[col[c][i]] = n;
            else maxr[col[c][i]] = max(maxr[col[c][i]], col[c][i + 1] - 1);
            if (!i)  maxl[col[c][i]] = -1;
            else maxl[col[c][i]] = min(maxl[col[c][i]], col[c][i - 1] + 1);
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        int i = 0, j = n - 1;
        int ans = 1;
        while (1) {
            if (i == l && j == r) {
                break;
            }
            if (i == l) {
                if (maxl[j] > i) {
                    ans = 0;
                    break;
                }
                --j;
            }
            else if (j == r) {
                if (maxr[i] < j) {
                    ans = 0;
                    break;
                }
                ++i;
            }
            else {
                if (maxl[j] <= i) {
                    --j;
                }
                else if (maxr[i] >= j) {
                    ++i;
                }
                else {
                    ans = 0;
                    break;
                }
            }
        }
        cout << ans << '\n';
    }
}



signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("coloring.in", "r", stdin);
    //freopen("coloring.out", "w", stdout);

    //ld time1 = clock();

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
        cout.flush();
    }

    //ld time2 = clock();
    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
    return 0;
}
