#include<iostream>
#include<vector>

using namespace std;

vector<long long> d;
vector<vector<pair<long long, long long>>> g;

void dfs(long long v, long long pred) {
	for (auto &i : g[v]) {
		if (pred < i.second) {
			d[i.first] = d[v] + 1;
			dfs(i.first, i.second);
		}
	}
}

int main() {
	long long n, m;
	cin >> n >> m;
	d.resize(n);
	g.resize(n);
	for (long long i = 0; i < m; i++) {
		long long a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		g[a].push_back({b, c});
		g[b].push_back({a, c});
	}
	if (n == m + 1) {
		dfs(0, -1);
		for (long long i = 0; i < n; i++) {
			cout << d[i] << " ";
		}
		cout << endl;
		return 0;
	}
	throw;
}