#include <iostream>
#include <vector>
#include <string>

#include "twins.h"

using namespace std;

vector<int> play1(int n, int t) {
    int l = 1;
    int r = n;

    while (r - l > 1) {
        int m = l + (r - l) / 2;
        vector<vector<int>> questions = {{}};

        for (int i = l; i <= m; ++i)
			questions[0].push_back(i);

        string answer = guess(questions);

        if (answer[0] == '0')
            l = m + 1;
        else
            r = m;
    }

    if (r - l == 1) {
        vector<vector<int>> questions = {{l}};
        string answer = guess(questions);

        if (answer[0] == '0')
			return {r};
		else
			return {l};
    }

    return {r};
}

vector<int> play2(int n, int t) {
	vector<int> result;

    for (int i = 1; i <= n; ++i) {
        if (result.size() == t)
            break;

        vector<vector<int>> questions = {{i}};
        string answer = guess(questions);

        if (answer[0] == '1')
            result.push_back(i);
    }

    return result;
}

vector<int> play(int n, int t) {
    if (t == 1)
		return play1(n, t);
	else
		return play2(n, t);
}
