#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 228;

using ll = long long;
using ld = long double;

vector<int> pos[(int)1e6 + 1];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> k (n + 1);
    vector<vector<int>> a (n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> k[i];
        a[i].resize(k[i]);
        for (int j = 0; j < k[i]; ++j) cin >> a[i][j], pos[a[i][j]].push_back (i);
    }
    vector<int> r(n + 1);
    vector<int> l(n + 1);
    for (int i = 1; i <= n; ++i) {
        int mx = 0;
        for (auto it : a[i]) {
            int j = upper_bound (begin (pos[it]), end (pos[it]), i) - begin (pos[it]);
            if (j >= (int)pos[it].size()) mx = n + 1;
            else mx = max (mx, pos[it][j]);
        }
        r[i] = mx;
    }
    for (int i = 1; i <= n; ++i) {
        int mn = n + 1;
        for (auto it : a[i]) {
           int j = lower_bound (begin (pos[it]), end (pos[it]), i) - begin (pos[it]) - 1;
           if (j < 0) mn = 0;
           else mn = min (mn, pos[it][j]);
        }
        l[i] = mn;
    }
    vector<int> prefmn(n + 2, n + 1), suffmx (n + 2, 0);
    for (int i = 1; i <= n; ++i) prefmn[i] = min(r[i], prefmn[i - 1]);
    for (int i = n; i >= 1; --i) suffmx[i] = max(l[i], suffmx[i + 1]);
    int q;
    cin >> q;
    while (q--) {
        int L, R;
        cin >> L >> R;
        bool w = 0;
        while (L > 1 || R < n) {
            int mnR = prefmn[L - 1], mxL = suffmx[R + 1];
            if ((mxL >= L && mxL <= R) || (mnR >= L && mnR <= R)) {
                cout << "0\n";
                w = 1;
                break;
            }
            if (L == mxL + 1 && R == mnR - 1) {
                cout << "0\n";
                w = 1;
                break;
            }
            if (mxL + 1 > L || mnR - 1 < R) {
                cout << "0\n";
                w = 1;
                break;
            }
            L = mxL + 1;
            R = mnR - 1;

        }
        if (!w) {
            cout << "1\n";
            continue;
        }
    }
    return 0;
}
