#include <bits/stdc++.h>

using namespace std;

const int N = 110000;
const int M = 4100000;
const int INF = (int)(1e7);

int n, m, val[M], res[N];
vector<int> edge, t[M];
vector<pair<int, int>> g[N];

void add_edge(int a, int b, int c) {
    g[a].push_back({c, (int) edge.size()});
    edge.push_back(b);
    g[b].push_back({c, (int) edge.size()});
    edge.push_back(a);
}

void dfs(int v) {
	if (val[v] != -2 * INF)
		return;
	if (v == (int) edge.size()) {
		val[v] = 0;
		return;
	}
    val[v] = -INF;
    for (int u : t[v]) {
		dfs(u);
		val[v] = max(val[v], val[u]);
    }
    if (v < (int) edge.size())
        val[v]++;
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> m;
    for (int i = 1; i <= m; i++) {
		int a, b, c; cin >> a >> b >> c;
        add_edge(a, b, c);
    }
    if (g[1].empty()) {
		for (int i = 1; i <= n; i++)
            cout << 0 << ' ';
		return 0;
    }
    int last = (int) edge.size();
    for (int i = 1; i <= n; i++) {
		sort(begin(g[i]), end(g[i]));
        for (int j = 0; j < (int) g[i].size(); j++) {
            t[g[i][j].second].push_back(last);
            if (j > 0) {
				t[last].push_back(g[i][j - 1].second ^ 1);
				t[last].push_back(last - 1);
            }
            last++;
        }
    }
    for (int i = 0; i < last; i++)
		val[i] = -2 * INF;
    for (int i = 0; i < last; i++)
		dfs(i);
    for (int i = 0; i < (int) edge.size(); i++)
        res[edge[i]] = max(res[edge[i]], val[i]);
    for (int i = 1; i <= n; i++)
		cout << res[i] << ' ';
}
