#include <bits/stdc++.h>

using namespace std;

const int N = 110000;
const int M = 4100000;
const int INF = (int)(1e7);

int n, m, val[M], res[N], cnt[M];
bool used[M];
vector<int> cc;
vector<int> edge, t[M];
vector<int> g[N];

void add_edge(int a, int b, int c) {
    g[a].push_back((int) edge.size());
    cc.push_back(c);
    edge.push_back(b);
    g[b].push_back((int) edge.size());
    cc.push_back(c);
    edge.push_back(a);
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> m;
    for (int i = 1; i <= m; i++) {
		int a, b, c; cin >> a >> b >> c;
        add_edge(a, b, c);
    }
    if (g[1].empty()) {
		for (int i = 1; i <= n; i++)
            cout << 0 << ' ';
		return 0;
    }
    int last = (int) edge.size();
    for (int i = 1; i <= n; i++) {
		sort(begin(g[i]), end(g[i]), [&](int i, int j){return cc[i] < cc[j];});
		vector<int> cur;
        for (int j = 0; j < (int) g[i].size(); j++) {
            t[last].push_back(g[i][j]);
            if (j > 0 && cc[g[i][j]] != cc[g[i][j - 1]]) {
				for (int x : cur)
					t[x].push_back(last);
				cur.clear();
            }
            if (j > 0) t[last - 1].push_back(last);
            cur.push_back(g[i][j] ^ 1);
            last++;
        }
    }
    for (int i = 0; i < last; i++)
		val[i] = -INF;
	val[(int) edge.size()] = 0;
	queue<int> qq;
	qq.push((int) edge.size());
	used[(int) edge.size()] = true;
	while (!qq.empty()) {
		int v = qq.front(); qq.pop();
        for (int u : t[v]) {
			if (used[u]) continue;
			used[u] = true;
            qq.push(u);
        }
	}
    for (int i = 0; i < last; i++)
        if (used[i])
			for (int u : t[i])
				cnt[u]++;
	qq.push((int) edge.size());
	while (!qq.empty()) {
        int v = qq.front(); qq.pop();
        if (v < (int) edge.size())
            val[v]++;
        for (int u : t[v]) {
			cnt[u]--;
            val[u] = max(val[u], val[v]);
            if (cnt[u] == 0)
				qq.push(u);
        }
	}
    for (int i = 0; i < (int) edge.size(); i++)
        res[edge[i]] = max(res[edge[i]], val[i]);
    for (int i = 1; i <= n; i++)
		cout << res[i] << ' ';
}
