#include <bits/stdc++.h>

using namespace std;

const int N = 110000;
const int INF = (int)(1e7);

vector<pair<int, pair<int, int>>> edge;
int n, m, val[N];

void upd(vector<pair<int, int>> &xx) {
    vector<pair<int, int>> upd;
    for (int i = 0; i < (int) xx.size(); i++) {
        int u = xx[i].first;
		int v = xx[i].second;
        upd.push_back({u, val[v] + 1});
        upd.push_back({v, val[u] + 1});
    }
    for (int i = 0; i < (int) upd.size(); i++) {
		int x = upd[i].first;
		int k = upd[i].second;
        val[x] = max(val[x], k);
    }
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> m;
    for (int i = 1; i <= m; i++) {
		int a, b, c; cin >> a >> b >> c;
        edge.push_back({c, {a, b}});
    }
    sort(begin(edge), end(edge));
    for (int i = 1; i <= n; i++)
		val[i] = -INF;
	val[1] = 0;
	int last = -1;
	vector<pair<int, int>> xx;
	for (auto wuv : edge) {
		int w = wuv.first;
		auto uv = wuv.second;
		if (w != last) {
            upd(xx);
            xx.clear();
		}
		xx.push_back(uv);
	}
	upd(xx);
    for (int i = 1; i <= n; i++)
		cout << max(val[i], 0) << ' ';
}
