#include <bits/stdc++.h>

using namespace std;
int main() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> g[n + 1];
    vector<int> times;
    struct node {
        int u, v, t;
    };
    vector<node> edges;
    edges.push_back({0, 1, -1});
    for (int i = 1; i <= m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        edges.push_back({u, v, t});
    }
    sort(edges.begin(), edges.end(), [&](node a, node b) {
         return a.t < b.t;
    });
    for (int i = 1; i < edges.size(); ++i) {
        auto [u, v, t] = edges[i];
        g[u].push_back({v, t, i});
        g[v].push_back({u, t, i});
    }
    int inf = -1e9;
    vector<int> ans(n + 1);
    vector<vector<int>> dp(m + 5, vector<int> (3, inf));
    dp[0][1] = 0;
    for (int i = 0; i <= m; ++i) {
        for (int type = 0; type < 2; ++type) {
            auto [u, v, t] = edges[i];
            int cur;
            if (type == 0) cur = u;
            else cur = v;
            ans[cur] = max(ans[cur], dp[i][type]);
            for (auto [to, time, idx] : g[cur]) {
                if (time > t) {
                    int flag;
                    auto [uu, vv, tt] = edges[idx];
                    if (to == uu) flag = 0;
                    else flag = 1;
                    dp[idx][flag] = max(dp[idx][flag], dp[i][type] + 1);
                }
            }
        }
    }
    for (int i = 1; i <= n; ++i) cout << ans[i] << ' ';
}
