#include <bits/stdc++.h>
#define int long long
#define pii pair <int, int>
#define pb push_back
#define ins insert
using namespace std;
const int N = 3e3 + 5, N2 = 5e5 + 5, N3 = 5e6 + 5, M = 1e9 + 7;

int k[N];
vector <int> c[N];
bitset <N2> b[N * 2];
int n;
int con[N3];
int vl[N], vr[N];
int mx[N], mn[N];
int l, r;

void solve()
{
    for (int i = 1; i < l; i++) if (vr[i] < r)
    {
        cout << 0 << '\n';
        return;
    }
    for (int i = r + 1; i <= n; i++) if (vl[i] > l)
    {
        cout << "0\n";
        return;
    }

    for (int i = 1; i < l; i++) if (mx[vr[i] + 1] > i)
    {
        cout << 0 << '\n';
        return;
    }
    for (int i = r + 1; i <= n; i++) if (mn[vl[i] - 1] < i)
    {
        cout << "0\n";
        return;
    }
    cout << "1\n";
    return;
}

bitset <N2> tr[N * 4];

void bld(int v, int vl, int vr)
{
    if (vl == vr)
    {
        tr[v] = b[vl];
        return;
    }
    int mid = (vl + vr) / 2;
    bld(v * 2, vl, mid);
    bld(v * 2 + 1, mid + 1, vr);
    tr[v] = (tr[v * 2] | tr[v * 2 + 1]);
}

bool get(int v, int vl, int vr, int l, int r, int i)
{
    if (vl > r || vr < l) return 0;
    if (vl >= l && vr <= r)
    {
//        cerr << v << ' ' << vl << ' ' << vr << ": " << b[i][0] << b[i][1] << b[i][2] << b[i][3] << b[i][4] << b[i][5] << b[i][6] << endl;
//        cerr << v << ' ' << vl << ' ' << vr << ": " << tr[v][0] << tr[v][1] << tr[v][2] << tr[v][3] << tr[v][4] << tr[v][5] << tr[v][6] << endl;
        return (((tr[v] ^ b[i]) & b[i]).any());
    }
    int mid = (vl + vr) / 2;
    int a = get(v * 2, vl, mid, l, r, i);
    if (a) return a;
    a = get(v * 2 + 1, mid + 1, vr, l, r, i);
    return a;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    set <int> st;
    mn[0] = M;
    for (int i = 1; i <= n; i++)
    {
        cin >> k[i];
        for (int j = 0; j < k[i]; j++)
        {
            int x;
            cin >> x;
            st.ins(x);
            c[i].pb(x);
        }
    }
    int s = 1;
    while (s < n) s *= 2;
    int k = 0;
    for (auto to: st)
    {
        con[to] = k;
        k++;
    }
    for (int i = 1; i <= n; i++)
        for (auto to: c[i])
        {
            b[i].set(con[to]);
        }
    bld(1, 1, n);
    for (int i = 1; i <= n; i++)
    {
        vl[i] = i;
        int L = 1, R = i - 1;
//        cerr << i << ": " << b[i][0] << b[i][1] << b[i][2] << b[i][3] << b[i][4] << b[i][5] << b[i][6] << endl;
        while (L <= R)
        {
            int mid = (L + R) / 2;
            if (get(1, 1, s, mid, i - 1, i))
            {
                R = mid - 1;
                vl[i] = mid;
            }
            else L = mid + 1;
        }
        vr[i] = i;
        L = i + 1, R = n;
        while (L <= R)
        {
            int mid = (L + R) / 2;
//            cerr << "!!!!! " << L << ' ' << R << ' ' << mid << ' ' << i << ' ' << get(1, 1, s, i + 1, mid, i) << endl;
            if (get(1, 1, s, i + 1, mid, i))
            {
                L = mid + 1;
                vr[i] = mid;
            }
            else R = mid - 1;
        }
//        cerr << "! " << i << ' ' << vl[i] << ' ' << vr[i] << endl;
    }
    mx[n] = vl[n];
    mn[1] = vr[1];
    for (int i = n - 1; i >= 1; i--) mx[i] = max(mx[i + 1], vl[i]);
    for (int i = 2; i <= n; i++) mn[i] = min(mn[i - 1], vr[i]);
    int q;
    cin >> q;
    while (q--)
    {
        cin >> l >> r;
        solve();
    }
    return 0;
}
