#include <bits/stdc++.h>
#include "twins.h"
#define pii pair <int, int>
#define pb push_back
#define ins insert
using namespace std;
const int N = 5e5 + 5, N2 = 5e6 + 5, M = 1e9 + 7;

const bool DETAILS=true;

int _n,_m,_t,_pos[4];
bool _special[50007];
int _vis[50007],_tim;
string _result;
int _L,_P;

vector<int> _ans;

void prnt(const char message[]){
    cout<<message<<"\n";
    exit(0);
}

string guess(vector< vector<int> >& questions){

    if(DETAILS){
        cout<<"Guess number "<<_P+1<<"\n";
        for(int i=0;i<questions.size();i++){
            cout<<"Question number "<<i+1<<" : ";
            for(int f=0;f<questions[i].size();f++){
                cout<<questions[i][f]<<" ";
            }
            cout<<"\n";
        }
    }

    _m=questions.size();
    _L+=int(questions.size());
    _P++;

    if(_m==0)prnt("Empty question!");

    _result.clear();
    _result.resize(_m);

    for(int i=0;i<_m;i++){
        if(questions[i].size()==0){
            _L--;
        }

        _result[i]='0'; _tim++;
        for(int f=0;f<questions[i].size();f++){
            if(questions[i][f]<1 or questions[i][f]>_n)prnt("Invalid question!");

            if(_vis[questions[i][f]]==_tim)prnt("Invalid question!");
            _vis[questions[i][f]]=_tim;

            if(_special[questions[i][f]])_result[i]='1';
        }
    }

    if(DETAILS){
        cout<<"Results from guess number "<<_P<<" : "<<_result<<"\n";
    }

    return _result;
}


vector <int> ans;
void solve1(int l, int r)
{
    if (l == r)
    {
        ans.pb(l);
        return;
    }
    int n = (r - l + 1);
    int sz = (n + 1) / 2;
    vector <vector <int>> v;
    vector <int> x;
    for (int i = 0; i < sz; i++) x.pb(l + i);
    v.pb(x);
    x.clear();
    for (int i = 0; i < sz; i++) x.pb(l + i + sz / 2);
    v.pb(x);
    string s = guess(v);
    if (s[0] == '1' && s[1] == '1') solve1(l + sz / 2, sz + l - 1);
    else if (s[0] == '1') solve1(l, l + sz / 2 - 1);
    else if (s[1] == '1') solve1(l + sz, sz / 2 + sz + l - 1);
    else solve1(l + sz + sz / 2, r);
}
void solve(int l, int r)
{
    string s;
    vector <vector <int>> v;
    for (int i = l; i <= r; i++)
    {
        vector <int> x;
        x.pb(i);
        v.pb(x);
    }
    s = guess(v);
//    vector <int> ans;
    for (int i = 0; i < r - l + 1; i++) if (s[i] == '1') ans.pb(v[i][0]);
}
vector <int> play(int N, int T)
{
    if (T == 1)
    {
        solve1(1, N);
        return ans;
    }
    string s;
    vector <vector <int>> v;
    int sz = round(sqrt(N));
    vector <int> x;
    for (int i = 1; i <= N; i++)
    {
        x.pb(i);
        if (i % sz == 0)
        {
            v.pb(x);
            x.clear();
        }
    }
    v.pb(x);
    s = guess(v);
    for (int i = 0; i < v.size(); i++) if (s[i] == '1') solve(v[i][0], v[i][v[i].size() - 1]);
    return ans;
}



int main(){

    cout<<"N: ";
    cin>>_n;
    cout<<"T: ";
    cin>>_t;

    cout<<"Pictures of Reni :";
    for(int i=1;i<=_t;i++){
        cin>>_pos[i];
        _special[_pos[i]]=true;
    }

    _ans=play(_n,_t);
    if(DETAILS){
        cout<<"Returned pcitures : "<<_ans[0];
        if(_ans.size()>1)cout<<" "<<_ans[1];
        cout<<"\n";
    }

    if(_t==1 and _ans.size()!=1)prnt("Wrong answer size!");
    if(_t==1 and (_ans[0]<1 or _ans[0]>_n))prnt("Invalid index!");
    if(_t==1 and !_special[_ans[0]])prnt("Wrong answer!");

    if(_t==2 and _ans.size()!=2)prnt("Wrong answer size!");
    if(_t==2 and (_ans[0]<1 or _ans[0]>_n))prnt("Invalid index!");
    if(_t==2 and (_ans[1]<1 or _ans[1]>_n))prnt("Invalid index!");
    if(_t==2 and _ans[0]==_ans[1])prnt("Wrong answer!");
    if(_t==2 and (!_special[_ans[0]] or !_special[_ans[1]]))prnt("Wrong answer!");

    cout<<"Correct with "<<_P<<" guesses and "<<_L<<" questions!\n";

    return 0;
}
