#include <bits/stdc++.h>

using namespace std;

void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m, a, b, x;
    cin >> n >> m;

    vector<vector<pair<int, int>>> vert(n);
    for (int i = 0; i < m; ++i) {
        cin >> a >> b >> x;

        vert[a - 1].emplace_back(b - 1, x);
        vert[b - 1].emplace_back(a - 1, x);
    }

    vector<int> d(n, 0), c(n, 0);
    set<pair<int, int>> s; s.insert({0, 0});

    while (!s.empty()) {
        auto [pr, idx] = *s.begin();
        s.erase(s.begin());

        for (auto [to, w] : vert[idx]) {
            if (w > pr && d[to] < d[idx] + 1) {
                s.erase({c[to], to});
                c[to] = w, d[to] = d[idx] + 1;
                s.insert({c[to], to});
            }
        }
    }

    for (auto el : d) cout << el << ' ';
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}