#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<pair<int, int>>> vert;

int dfs(int idx, int wt) {
    int mx = 0;

    for (auto [to, w] : vert[idx]) {
        if (w < wt) {
            mx = max(mx, dfs(to, w));
        }
    }

    return mx + 1;
}

void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m, a, b, c;
    cin >> n >> m;

    vert.resize(n);
    vector<pair<int, pair<int, int>>> edges(m);

    for (int i = 0; i < m; ++i) {
        cin >> a >> b >> c;
        edges[i] = {c, {a - 1, b - 1}};
    }

    sort(edges.begin(), edges.end());
    for (auto el : edges) {
        vert[el.second.first].emplace_back(el.second.second, el.first);
        vert[el.second.second].emplace_back(el.second.first, el.first);
    }


    for (int i = 0; i < n; ++i) {
        cout << dfs(i, LLONG_MAX) - 1 << ' ';
    }
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}