#include <bits/stdc++.h>

#define int long long
using namespace std;
const int INF = 2e9;
vector<vector<int>> k;
int n;

void solve() {
    int L, R;
    cin >> L >> R;
    L--;
    R--;
    map<int, int> mp;
    for (int i = L; i <= R; i++) {
        for (int j = 0; j < k[i].size(); j++) {
            mp[k[i][j]] = max(i + 1, mp[k[i][j]]);
        }
    }
    int l = L, r = R;
    while (l != 0 || r != n - 1) {
        if (l != 0) {
            for (int i = 0; i < l; i++) {
                int pr = 0;
                for (int j = 0; j < k[i].size(); j++) {
                    if (mp[k[i][j]] == 0) {
                        pr = 1;
                        mp[k[i][j]] = max(i + 1, mp[k[i][j]]);
                    }
                }
                if (pr == 0) {
                    cout << 0;
                    return;
                }
            }
            l = 0;
        } else {
            int pr = 0, mn = INF;
            for (int j = 0; j < k[r + 1].size(); j++) {
                if (mp[k[r + 1][j]] == 0) {
                    pr = 1;
                    mp[k[r + 1][j]] = max(r + 1, mp[k[r + 1][j]]);
                } else {
                    mn = min(mn, mp[k[r + 1][j]]);
                }
            }
            if (pr == 0) {
                if (mn >= L + 1) {
                    cout << 0;
                    return;
                }
                for (int i = 0; i < mn; i++) {
                    for (int j = 0; j < k[i].size(); j++) {
                        if (mp[k[i][j]] == i + 1) {
                            mp[k[i][j]] = 0;
                        }
                    }
                }
                l = mn;
                for (int j = 0; j < k[r + 1].size(); j++) {
                    if (mp[k[r + 1][j]] == 0) {
                        mp[k[r + 1][j]] = max(r + 1, mp[k[r + 1][j]]);
                    }
                }
            }

            r++;
        }
    }
    cout << 1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    k.resize(n);
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        for (int j = 0; j < m; j++) {
            int x;
            cin >> x;
            k[i].push_back(x);
        }
    }
    int e;
    cin >> e;
    while (e--) {
        solve();
        cout << "\n";
    }
}

