#include <bits/stdc++.h>

#define int long long
using namespace std;
const int INF = 2e9;
struct node {
    int to, c;
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<node>> z;
    z.resize(n);
    for (int i = 0; i < m; i++) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        z[x].push_back({y, c});
        z[y].push_back({x, c});
    }
    vector<int> ans(n, 0), r(n, INF);
    r[0] = 0;
    set<pair<int, int>> s;
    s.insert({0, 0});
    while (!s.empty()) {
        int x = s.begin()->second, c = s.begin()->first;
        ans[x] = max(ans[x], c);
        s.erase(s.begin());
        for (auto to: z[x]) {
            int y = to.to, ca = to.c;
            if (ca > r[x]) {
                r[y] = ca;
                s.insert({c + 1, y});
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int e = 1;
    while (e--) {
        solve();
        cout << "\n";
    }
}

