#include <bits/stdc++.h>

using namespace std;
void solve() {
    int n;
    cin >> n;
    vector<vector<int>> color(n);
    for (int i = 0; i < n; i++) {
        int len;
        cin >> len;
        for (int j = 0; j < len; j++) {
            int f;
            cin >> f;
            f--;
            color[i].push_back(f);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        unordered_set<int> used;
        l--, r--;
        vector<int> use(n);
        for (int i = l; i <= r; i++) {
            use[i] = 1;
            for (auto j : color[i]) {
                used.insert(j);
            }
        }
        unordered_map<int, vector<int>> g;
        vector<int> st(n);
        bool flag = true;
        unordered_set<int> us1, us2;
        for (int i = l - 1; i >= 0; i--) {
            for (auto j : color[i]) {
                if (used.find(j) == used.end() && us1.find(j) == us1.end()) {
                    g[j].push_back(i);
                    st[i]++;
                }
                us1.insert(j);
            }
            if (st[i] == 0) {
                flag = false;
                break;
            }
        }
        for (int i = r + 1; i < n; i++) {
            for (auto j : color[i]) {
                if (used.find(j) == used.end() && us2.find(j) == us2.end()) {
                    g[j].push_back(i);
                    st[i]++;
                }
                us2.insert(j);
            }
            if (st[i] == 0) {
                flag = false;
                break;
            }
        }
        int left = l, right = r;
        while (left != 0 || right != n - 1) {
            if (left != 0) {
                bool f = true;
                for (auto j : color[left - 1]) {
                    for (auto z : g[j]) {
                        if (z != left - 1 && use[z] == 0 && st[z] == 1) {
                            f = false;
                        }
                    }
                }
                if (f) {
                    left--;
                    use[left] = 1;
                    continue;
                }
            }
            bool f = true;
            for (auto j : color[right + 1]) {
                for (auto z : g[j]) {
                    if (z != right + 1 && use[z] == 0 && st[z] == 1) {
                        f = false;
                    }
                }
            }
            if (f) {
                right++;
                use[right] = 1;
                continue;
            }
            flag = false;
            break;
        }
        if (flag) {
            cout << 1 << '\n';
        } else {
            cout << 0 << '\n';
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q = 1;
    while (q--) {
        solve();
    }
}
