#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <functional>
#include <string_view>
//#include <bits/stdc++.h>
using namespace std;
const int inf = 1000000007;
void next_street(int curr, vector<vector<pair<int, int>>> nearby, vector<pair<int, int>> &distances) {

    for (pair<int,int> i : nearby[curr])
    {
        if (distances[i.first].first!=0 || distances[i.first].second!=0) {
            if (i.second> distances[i.first].second)
            {
                distances[curr] = { distances[i.first].first + 1,i.second };
            }
            else
            {
                distances[curr] = { 0,inf };
            }
        }
    }
    for (pair<int, int> i : nearby[curr])
    {
        if (distances[i.first].first == 0 && distances[i.first].second == 0) {
            next_street(i.first, nearby, distances);
        }
    }
}
int main() {
    int N, M;
    cin >> N;
    cin >> M;
    //vector<vector<int>> streets(2*M);
    vector<vector<pair<int,int>>> nearby(M);
    int a, b, c;
    for (int i = 0; i < M; i++)
    {
        cin >> a;
        cin >> b;
        cin >> c;
        //streets.push_back({ a,b,c });
        nearby[a-1].push_back({b-1,c-1});
        nearby[b-1].push_back({a-1,c-1});
        //streets.push_back({ b,a,c });
    }
    sort(nearby.begin(), nearby.end());
    vector<pair<int,int>> distances;   //distance and last street
    distances.resize(M, { 0,0 });
    distances[0] = { 1,0 };
    for (pair<int, int> i : nearby[0]) {
        distances[i.first] = { 1,i.second };
        next_street(i.first, nearby, distances);
    }
    cout << 0 << " ";
    for (int i = 1; i < N; i++)
    {
        cout << distances[i].first << " ";
    }


    return 0;
}
