#include <iostream>
#include<vector>
#include<algorithm>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
using vb = vector<bool>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;

vvpll g;
ll n, m;
vb vis;
vll ans;

void dfs(ll start, ll t, ll co) {
	for (auto i : g[start]) {
		if (t < i.second) {
			if (ans[i.first] < co + 1) {
				ans[i.first] = co + 1;
			}
			dfs(i.first, i.second, co + 1);
		}
	}
}

int main() {
	cin >> n >> m;
	g.resize(n + 1);
	ans.resize(n + 1, 0);
	ll a, b, c;
	for (ll i = 0; i < m; i++) {
		cin >> a >> b >> c;
		g[a].push_back({ b,c });
		g[b].push_back({ a,c });
	}
	dfs(1, 0, 0);
	for (ll i = 1; i < ans.size(); i++) {
		cout << ans[i] << " ";
	}
}