#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;


void solve(vll col, vvll c, ll l, ll r, ll n) {
	while (l >= 0 || r < n) {
		bool temp = true;
		//cout << "l = " << l << " r = " << r << endl;
		if (l >= 0) {
			ll cnt = 0;
			ll x = -1;
			for (ll i = 0; i < c[l].size(); i++) {
				//cout << "i = " << i << endl;
				if (col[c[l][i]] == 0) {
					cnt++;
					x = c[l][i];
					if (cnt >= 2) {
						temp = false;
						break;
					}
				}
			}
			if (temp) {
				// We took l;
				//cout << "adgdag" << endl;
				col[x] = 1;
				l--;
			}
		}
		if (r >= n) {
			if (!temp) {
				cout << "0" << endl;
				return;
			}
			continue;
		}
		ll cnt = 0;
		ll x = -1;
		bool temp2 = true;
		for (ll i = 0; i < c[r].size(); i++) {
			//cout << "i = " << i << endl;
			if (col[c[r][i]] == 0) {
				cnt++;
				x = c[r][i];
				if (cnt >= 2) {
					temp = false;
					break;
				}
			}
		}
		if (temp2) {
			// We took r;
			col[x] = 1;
			r++;
		}
		else {
			cout << "0" << endl;
			return;
		}
	}
	cout << "1" << endl;
}

/*
4
2 1 2
1 3
1 4
2 5 6
1
2 3

*/


/*
6
2 5 3
1 4
1 1
1 2
2 3 4
1 6
3
3 4
2 3
5 5
*/

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n;
	cin >> n;
	vll k(n);
	vvll c(n);
	for (ll i = 0; i < n; i++) {
		cin >> k[i];
		c[i].resize(k[i]);
		for (ll j = 0; j < k[i]; j++) {
			cin >> c[i][j];
		}
		sort(c[i].begin(), c[i].end());
	}
	ll q;
	cin >> q;
	while (q--) {
		ll l, r;
		cin >> l >> r;
		l--, r--;
		vll col(1e6 + 1);
		bool temp = false;
		for (ll i = l; i <= r; i++) {
			if (k[i] >= 2) {
				cout << "0" << endl;
				temp = true;
				break;
			}
			col[c[i][0]] = 1;
		}
		l--, r++;
		if (!temp) {
			solve(col, c, l, r, n);
		}
	}
}
