#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;

vvpll g;
vpll res;
vll ans;

void dfs(ll n) {
	//cout << "n = " << n << endl;
	for (auto u : g[n]) {
		if (u.second > res[n].second) {
			// We can go to n from u
			//cout << "u.first = " << u.first << " u.second = " << u.second << endl;
			if (res[u.first].first > res[n].first + 1) {
				continue;
			}
			res[u.first] = { res[n].first + 1, u.second };
			dfs(u.first);
		}
	}
}

/*
void dfs(ll n, ll last) {
	cout << "n = " << n << " last = " << last << endl;
	cout << "ans[n] = " << ans[n].first << " " << ans[n].second << endl;
	for (auto u : g[n]) {
		if (u.second > last) {
			if (ans[u.first].first < ans[n].first + 1 && ans[n].second < u.second) {
				ans[u.first].first = ans[n].first + 1;
				ans[u.first].second = u.second;
				dfs(u.first, u.second);
			}
		}
	}
	cout << "finish" << endl;
}*/

void dfs1(ll n, ll cur, ll last) {
	bool t = true;
	for (auto u : g[n]) {
		if (u.second > last) {
			t = false;
			dfs1(n, cur + 1, u.second);
		}
	}
	if (t) {
		ans[n] = cur;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n, m;
	cin >> n >> m;
	g.resize(n);
	res.resize(n, {0, -1});
	ans.resize(n);
	while (m--) {
		ll a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		g[a].push_back({ b, c });
		g[b].push_back({ a, c });
	}
	dfs1(0, 0, -1);
	dfs(0);
	cout << ans[0] << " ";
	for (ll i = 1; i < n; i++) {
		cout << res[i].first + 1 << " ";
		//cout << res[i].first << " ";
		//cout << " " << res[i].second << endl;
	}
	cout << endl;
}

/*
4 4
1 2 1
2 3 2
3 4 3
4 1 4
*/

/*
vector<bool> vis;
vvpll g;
vll e;
vll res;

void dfs(ll n) {
	for (auto u : g[n]) {
		if ()
	}
}

void dfs(ll n) {
	//cout << "n = " << n << endl;
	vis[n] = true;
	for (auto u : g[n]) {
		if (vis[u.first]) {
			continue;
		}
		if (u.second > e[n] && (e[n] != -1)) {
			//cout << "u.first = " << u.first << " u.second = " << u.second << endl;
			//cout << "res[n] = " << res[n] << endl;
			res[u.first] = res[n] + 1;
			e[u.first] = u.second;
		}
		dfs(u.first);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n, m;
	cin >> n >> m;
	vis.resize(n, false);
	g.resize(n);
	e.resize(n, -1);
	res.resize(n, 0);
	e[0] = 0;
	for (ll i = 0; i < m; i++) {
		ll a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		g[a].push_back({ b, c });
		g[b].push_back({ a, c });
	}
	dfs(0);
	for (ll i = 0; i < n; i++) {
		cout << res[i] << " ";
	}
	cout << endl;
	/*for (ll i = 0; i < n; i++) {
		cout << e[i] << " ";
	}
	cout << endl;
}
*/
/*
10 9
1 2 3
1 3 1
3 5 8
3 4 3
4 6 3
4 7 5
2 8 1
2 9 4
8 10 2

*/