#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ff first
#define ss second
#define rep(i,s,f) for(int i = s;i < f;i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend();
#define pb push_back

const int INF = 1e18;
const int N = 1e6 + 1;
const int MOD = 1e9 + 7;

int exp(int x, int n, int m) {
	x %= m;
	int res = 1;
	while (n > 0) {
		if (n % 2 == 1) { res = (res * x) % m; }
		x = (x * x) % m;
		n /= 2;
	}
	return res;
}
 
int power(int x, int n) {
	int res = 1;
	while (n > 0) {
		if (n % 2 == 1) { res = res * x ; }
		x = x * x ;
		n /= 2;
	}
	return res;
}

int lcm (int a, int b) {
	return a / __gcd(a, b) * b;
}

void solve(){

	int n;
	cin >> n;
	vector<vector<int>> g(n + 1);
	for(int i = 0;i < n;i++){
		int k;
		cin >> k;
		for(int j = 0;j < k;j++){
			int a;
			cin >> a;
			g[i].pb(a);
		}
	}
	int q;
	cin >> q;
	for(int i = 0;i < q;i++){
		int l,r;
		cin >> l >> r;
		l--;
		r--;
		vector<int> vis(1e6 + 1);
		for(int j = l;j <= r;j++){
			for(auto k : g[j]){
				vis[k] = INF;
			}
		}
		l--;
		r++;
		bool check = 0;
		while(true){
			if(l < 0 && r >= n){
				check = 1;
				break;
			}
			if(l >= 0){
				bool proof = 0;
				for(auto j : g[l]){
					if(!vis[j]){
						vis[j] = l;
						proof = 1;
						break;
					}
				}
				if(!proof){
					for(auto j : g[l]){
						if(vis[j] != INF){
							for(auto k : g[vis[j]]){
								if(!vis[k]){
									vis[k] = vis[j];
									vis[j] = l; 
									proof = 1;
									break;
								}
							}
							if(proof){
								break;
							}
						}
					}
					if(!proof){
						break;
					}
				}
			}
			
			if(r < n){
				bool proof = 0;
				for(auto j : g[r]){
					if(!vis[j]){
						vis[j] = r;
						proof = 1;
						break;
					}
				}
				if(!proof){
					for(auto j : g[r]){
						if(vis[j] != INF){
							for(auto k : g[vis[j]]){
								if(!vis[k]){
									vis[k] = vis[j];
									vis[j] = r; 
									proof = 1;
									break;
								}
							}
							if(proof){
								break;
							}
						}
					}
					if(!proof){
						break;
					}
				}
			}
			l--;
			r++;
		}
		cout << check << "\n";
		
	}

}

signed main(){

	ios_base::sync_with_stdio(0);
	cin.tie(0),cout.tie(0);

	int t = 1;
	//~ cin >> t;
	for(int i = 0;i < t;i++){
		solve();
	}

}
