#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ff first
#define ss second
#define rep(i,s,f) for(int i = s;i < f;i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend();
#define pb push_back

const int INF = 1e18;
const int N = 1001;
const int MOD = 1e9 + 7;
const int MXN = 1001;

int exp(int x, int n, int m) {
	x %= m;
	int res = 1;
	while (n > 0) {
		if (n % 2 == 1) { res = (res * x) % m; }
		x = (x * x) % m;
		n /= 2;
	}
	return res;
}
 
int power(int x, int n) {
	int res = 1;
	while (n > 0) {
		if (n % 2 == 1) { res = res * x ; }
		x = x * x ;
		n /= 2;
	}
	return res;
}

int lcm (int a, int b) {
	return a / __gcd(a, b) * b;
}

vector<int> vis(N);
vector<vector<int>> g(MXN);

bool dfs(int n){
	
	int cnt = 0;
	for(auto to : g[n]){
		if(!vis[to]){
			vis[to] = n;
			return 1;
		} else if(vis[to] == INF){
			cnt++;
		}
	}
	if(cnt == g[n].size()){
		return 0;
	} else{
		for(auto to : g[n]){
			if(vis[to] != INF){
				int a = dfs(vis[to]);
				if(a){
					vis[to] = n;
					return 1;
				}
			}
		}
		return 0;
	}

}

void solve(){

	int n;
	cin >> n;
	for(int i = 0;i < n;i++){
		int k;
		cin >> k;
		for(int j = 0;j < k;j++){
			int a;
			cin >> a;
			g[i].pb(a);
		}
	}
	int q;
	cin >> q;
	for(int i = 0;i < q;i++){
		int l,r;
		cin >> l >> r;
		l--;
		r--;
		for(int j = l;j <= r;j++){
			for(auto k : g[j]){
				vis[k] = INF;
			}
		}
		l--;
		r++;
		bool check = 0;
		while(true){
			if(l < 0 && r >= n){
				check = 1;
				break;
			}
			if(l >= 0){
				bool proof = dfs(l);
				if(proof){
					
				} else{
					break;
				}
			}
			
			if(r < n){
				bool proof = dfs(r);
				if(proof){
					
				} else{
					break;
				}
			}
			l--;
			r++;
		}
		cout << check << "\n";
		for(int i = 0;i < N;i++){
			vis[i] = 0;
		}
	}

}

signed main(){

	ios_base::sync_with_stdio(0);
	cin.tie(0),cout.tie(0);

	int t = 1;
	//~ cin >> t;
	for(int i = 0;i < t;i++){
		solve();
	}

}
