#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rep(i,s,f) for(int i = s;i < f;i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend();
#define pb push_back

const int INF = INT_MAX;
const int N = 1e4 + 1;
const int MOD = 1e9 + 7;
const int MXN = 3e3 + 1;

int exp(int x, int n, int m) {
    x %= m;
    int res = 1;
    while (n > 0) {
        if (n % 2 == 1) { res = (res * x) % m; }
        x = (x * x) % m;
        n /= 2;
    }
    return res;
}
 
int power(int x, int n) {
    int res = 1;
    while (n > 0) {
        if (n % 2 == 1) { res = res * x ; }
        x = x * x ;
        n /= 2;
    }
    return res;
}

int lcm (int a, int b) {
    return a / __gcd(a, b) * b;
}

int dp[3001][3001];
vector<int> vis(N);
vector<vector<int>> g(MXN);
int n;

int rec(int l,int r,vector<int> vis){
	if(l == 0 && r == n - 1){
		return 1;
	}
	if(dp[l][r]){
		return dp[l][r] - 1;
	}
	int ans = 0;
	if(l - 1 >= 0){
		bool proof = 0;
		vector<int> a;
		l--;
		for(auto i : g[l]){
			if(vis[i] == 0){
				proof = 1;
				a.pb(i);
			}
			vis[i] = 1;
		}	
		l++;
		if(proof){
			ans = rec(l - 1,r,vis);
		}
		for(auto i : a){
			vis[i] = 0;
		}		
	}
	if(r + 1 < n){
		r++;
		bool proof = 0;
		vector<int> a;
		for(auto i : g[r]){
			if(vis[i] == 0){
				proof = 1;
				a.pb(i);
			}
			vis[i] = 1;
		}	
		r--;
		if(proof){
			ans = max(ans,rec(l,r + 1,vis));
		}
		for(auto i : a){
			vis[i] = 0;
		}
	}
	dp[l][r] = ans + 1;
	return dp[l][r] - 1;
}

void solve(){

    cin >> n;
    for(int i = 0;i < n;i++){
        int k;
        cin >> k;
        for(int j = 0;j < k;j++){
            int a;
            cin >> a;
            g[i].pb(a);
        }
    }
    
    int q;
    cin >> q;
    for(int i = 0;i < q;i++){
        int l,r;
        cin >> l >> r;
        l--;
        r--;
        for(int j = l;j <= r;j++){
            for(auto k : g[j]){
				vis[k] = 1;
			}
        }
        bool check = rec(l,r,vis);
        cout << check << "\n";
        for(int k = 0;k < n;k++){
			for(int h = 0;h < n;h++){
				dp[k][h] = 0;
			}
		}
		for(int k = 0;k < N;k++){
			vis[k] = 0;
		}
		
			
		
    }

}

signed main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0),cout.tie(0);

    int t = 1;
    //~ cin >> t;
    for(int i = 0;i < t;i++){
        solve();
    }

}
