#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rep(i,s,f) for(int i = s;i < f;i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend();
#define pb push_back

const int INF = INT_MAX;
const int N = 1e5 + 1;
const int MOD = 1e9 + 7;
const int MXN = 3e3 + 1;

int exp(int x, int n, int m) {
    x %= m;
    int res = 1;
    while (n > 0) {
        if (n % 2 == 1) { res = (res * x) % m; }
        x = (x * x) % m;
        n /= 2;
    }
    return res;
}
 
int power(int x, int n) {
    int res = 1;
    while (n > 0) {
        if (n % 2 == 1) { res = res * x ; }
        x = x * x ;
        n /= 2;
    }
    return res;
}

int lcm (int a, int b) {
    return a / __gcd(a, b) * b;
}

vector<int> ans(N);

vector<vector<pair<int,int>>> g(N);

void dfs(int v,int p,int ras,int deep){
	
	ans[v] = deep; 
	for(auto i : g[v]){
		if(i.ff != p && i.ss > ras){
			dfs(i.ff,v,i.ss,deep + 1);
		}
	}
	

}

int cnt = 0;

void dfs1(int v,int mask,int ras,int deep,int req){
	
	if(v == req)
		cnt = max(cnt,deep);
	for(auto i : g[v]){
		if(((mask >> (i.ff - 1)) & 1) && i.ss > ras){
			dfs1(i.ff,mask,i.ss,deep + 1,req);
		}
	}

}

void solve(){

    int n,m;
    cin >> n >> m;
    for(int i = 0;i < m;i++){
		int a,b,c;
		cin >> a >> b >> c;
		g[a].pb({b,c});
		g[b].pb({a,c});
	}
	if(m == n - 1){
		dfs(1,-1,0,0);
		for(int i = 1;i <= n;i++){
			cout << ans[i] << " ";
		}
	} else{
		for(int i = 1;i <= n;i++){
			for(int mask = 0;mask < (1 << n);mask++){
				if(!(mask >> 0 & 1)){
					continue;
				}
				if(!(mask >> (i - 1) & 1)){
					continue;
				}
				
				cnt = 0;
				dfs1(1,mask,0,0,i);
				ans[i] = max(ans[i],cnt);
			}
			cout << ans[i] << " ";
		}
	}
	

}

signed main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0),cout.tie(0);

    int t = 1;
    //~ cin >> t;
    for(int i = 0;i < t;i++){
        solve();
    }

}
