#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include "Define.h"
using namespace std;
using namespace __gnu_pbds;
#define int long long
typedef pair<int , int> pii;
using indexed_set = tree<pii , null_type , greater<pii> , rb_tree_tag , tree_order_statistics_node_update>;
#define vec vector
class solve{
public:
    int bfs(int finish , int tme , vec<vec<pii>> g){
        int cnt = 0;
        queue<pii> q;
        q.emplace(0 , 0);
        while(!q.empty()){
            auto [cur , time] = q.front();
            q.pop();
            for (auto [to , nxt_time] : g[cur]){
                if (time < nxt_time){
                    q.emplace(to , nxt_time);
                    cnt++;
                }
            }
        }
        return cnt;
    }
    void print_array_int(vec<int> a , int i){
        solve ans;
        cout.tie(nullptr) -> ios_base::sync_with_stdio(false);
        if (i == a.size())return;
        putchar(a[i] + 48);
        putchar(' ');
        i++;
        ans.print_array_int(a , i);
    }
    void print_array_char(vec<char> a , int i){
        solve ans;
        cout.tie(nullptr) -> ios_base::sync_with_stdio(false);
        if (i == a.size())return;
        putchar(a[i]);
        putchar(' ');
        i++;
        ans.print_array_char(a , i);
    }
    void io(){
        cin.tie(nullptr) -> ios_base::sync_with_stdio(false);
        cout.tie(nullptr) -> ios_base::sync_with_stdio(false);
//        io();
    }
};
signed main()
{
    solve ans;
    ans.io();
    int n , m;
    cin >> n >> m;
    vec<vec<pii>> g(n);
    const int mn = INT_MIN;
    for (int i = 0; i < m; i++){
        int x , y , z;
        cin >> x >> y >> z;
        x -- , y -- ;
        g[x].emplace_back(y , z);
        g[y].emplace_back(x , z);
    }
    multiset<pii , greater<pii>> q;
    vec<int> dist(n , mn);
    dist[0] = 0;
//    q.push({0 , 0});
    q.insert({0 , 0});
    while(!q.empty()){
//        auto [cur , tme] = q.front();
//        q.pop();
        int cur = q.begin() -> first;
        int tme = q.begin() -> second;
        q.erase(q.begin());
        for (auto [to , nxt_tme] : g[cur]){
            if (dist[to] < dist[cur] + 1 and nxt_tme > tme){
                dist[to] = dist[cur] + 1;
//                q.push({to , nxt_tme});
                q.insert({to , nxt_tme});
            }
        }
    }
    ans.print_array_int(dist , 0);
}