#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
const int N = 1e5 + 10,M = 1e6 + 10;
int ver[M][2],Mx[M][2];
vector<pair<int,pair<int,int>>> nei[N];
int Max[N];

#define s second

int main(){
	int n,m;
	cin>>n>>m;

	vector<pair<int,pair<int,pair<int,int>>>> E;

	for (int i=1;i<=m;i++){
		int a,b,c;
		cin>>a>>b>>c;
		ver[i][0] = a;
		ver[i][1] = b;
		nei[a].push_back({c,{b,i}});
		nei[b].push_back({c,{a,i}});
		E.push_back({c,{i,{a,b}}});
	}
	E.push_back({-1,{0,{0,1}}});
	sort(begin(E),end(E));

	for (int i=1;i<=n;i++)
		sort(begin(nei[i]),end(nei[i]));
	
	for (int i=0;i<=m;i++)
		Mx[i][0] = Mx[i][1] = -1e9;
	Mx[0][1] = 0;
	ver[0][1] = 1;
	for (auto [c,p] : E){
		int i = p.first;
		int a = p.second.first,ap = 0;
		int b = p.second.second,bp = 1;
		if (Mx[i][0] < Mx[i][1])
			swap(a,b),swap(ap,bp);
		if (Mx[i][ap] < Max[a])
			continue;
		for (auto [cc,p2] : nei[a]){
			if (cc <= c)
				continue;
			int up = 0,vp = 1;
			if (ver[p2.second][0] != a)
				swap(up,vp);
			Mx[p2.s][vp] = max(Mx[p2.s][vp],Mx[i][ap] + 1);
			Max[ver[p2.s][vp]] = max(Max[ver[p2.s][vp]],Mx[p2.s][vp]);
		}
	}
	for (int i=1;i<=n;i++)
		cout<<Max[i]<<" ";
	cout<<endl;
}