#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
const int N = 1e5 + 10;
int Max[N];
int dp[12][20];

void sub1(int n,int m){
	vector<pair<int,pair<int,int>>> E;
	vector<int> v;
	map<int,int> mp;
	for (int i=1;i<=m;i++){
		int a,b,c;
		cin>>a>>b>>c;
		v.push_back(c);
		E.push_back({c,{a,b}});
	}
	sort(begin(v),end(v));
	int cur = 1;
	for (int i : v)
		mp[i] = cur++;

	for (int i=0;i<=n;i++)
		for (int j=0;j<=m;j++)
			dp[i][j] = -1e9;
	dp[1][0] = 0;
	while (1){
		bool ch = false;
		for (auto [c,p] : E){
			int a = p.first,b = p.second;
			for (int i=0;i<c;i++)
				if (dp[a][i] != -1e9 and dp[a][i] + 1 > dp[b][c])
					dp[b][c] = max(dp[b][c],dp[a][i] + 1),ch = true;
			swap(a,b);
			for (int i=0;i<c;i++)
				if (dp[a][i] != -1e9 and dp[a][i] + 1 > dp[b][c])
					dp[b][c] = max(dp[b][c],dp[a][i] + 1),ch = true;
		}
		if (!ch)
			break;
	}
	for (int i=1;i<=n;i++){
		int mx = 0;
		for (int j=1;j<=m + 5;j++)
			mx = max(mx,dp[i][j]);
		cout<<mx<<" ";
	}
	cout<<endl;

	exit(0);
}

int main(){
	int n,m;
	cin>>n>>m;

	if (n <= 10 and m <= 15){
		sub1(n,m);
	}

	vector<pair<int,pair<int,int>>> E;

	for (int i=1;i<=m;i++){
		int a,b,c;
		cin>>a>>b>>c;
		E.push_back({c,{a,b}});
	}

	sort(begin(E),end(E));

	for (int i=2;i<=n;i++){
		Max[i] = -1e9;
	}

	for (auto [c,p] : E){
		int A = p.first,B = p.second;
		int k = Max[A];
		Max[A] = max(Max[A],Max[B] + 1);
		Max[B] = max(Max[B],k + 1);
	}
	for (int i=1;i<=n;i++)
		cout<<Max[i]<<" ";
	cout<<endl;
}