#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
const int N = 1e5 + 10,M = 1e6 + 10;
int ver[M][2],Mx[M][2];
vector<pair<int,pair<int,int>>> nei[N];
int Max[N];
int dp[12][20];
int temp[N];

void sub1(int n,int m){
	vector<pair<int,pair<int,int>>> E;
	vector<int> v;
	map<int,int> mp;
	for (int i=1;i<=m;i++){
		int a,b,c;
		cin>>a>>b>>c;
		v.push_back(c);
		E.push_back({c,{a,b}});
	}
	sort(begin(v),end(v));
	int cur = 1;
	for (int i : v)
		mp[i] = cur++;

	for (int i=0;i<=n;i++)
		for (int j=0;j<=m;j++)
			dp[i][j] = -1e9;
	dp[1][0] = 0;
	while (1){
		bool ch = false;
		for (auto [c,p] : E){
			int a = p.first,b = p.second;
			for (int i=0;i<c;i++)
				if (dp[a][i] != -1e9 and dp[a][i] + 1 > dp[b][c])
					dp[b][c] = max(dp[b][c],dp[a][i] + 1),ch = true;
			swap(a,b);
			for (int i=0;i<c;i++)
				if (dp[a][i] != -1e9 and dp[a][i] + 1 > dp[b][c])
					dp[b][c] = max(dp[b][c],dp[a][i] + 1),ch = true;
		}
		if (!ch)
			break;
	}
	for (int i=1;i<=n;i++){
		int mx = 0;
		for (int j=1;j<=m + 5;j++)
			mx = max(mx,dp[i][j]);
		cout<<mx<<" ";
	}
	cout<<endl;

	exit(0);
}


void sub2(int n,int m){
	vector<pair<int,pair<int,pair<int,int>>>> E;

	for (int i=1;i<=m;i++){
		int a,b,c;
		cin>>a>>b>>c;
		ver[i][0] = a;
		ver[i][1] = b;
		nei[a].push_back({c,{b,i}});
		nei[b].push_back({c,{a,i}});
		E.push_back({c,{i,{a,b}}});
	}
	E.push_back({-1,{0,{0,1}}});
	sort(begin(E),end(E));

	for (int i=1;i<=n;i++)
		sort(begin(nei[i]),end(nei[i]));
	
	for (int i=0;i<=m;i++)
		Mx[i][0] = Mx[i][1] = -1e9;

	Mx[0][1] = 0;
	ver[0][1] = 1;
	for (auto [c,p] : E){
		int i = p.first;
		int a = p.second.first,ap = 0;
		int b = p.second.second,bp = 1;
		

		if (Mx[i][ap] >= Max[a]){
			for (auto [cc,p2] : nei[a]){
				if (cc <= c)
					continue;
				int up = 0,vp = 1;
				if (ver[p2.second][0] != a)
					swap(up,vp);
				Mx[p2.second][vp] = max(Mx[p2.second][vp],Mx[i][ap] + 1);
				Max[p2.first] = max(Max[p2.first],Mx[p2.second][vp]);
			}
		}

		swap(a,b);
		swap(ap,bp);


		if (Mx[i][ap] >= Max[a]){
			for (auto [cc,p2] : nei[a]){
				if (cc <= c)
					continue;
				int up = 0,vp = 1;
				if (ver[p2.second][0] != a)
					swap(up,vp);
				Mx[p2.second][vp] = max(Mx[p2.second][vp],Mx[i][ap] + 1);
				Max[p2.first] = max(Max[p2.first],Mx[p2.second][vp]);
			}
		}

	}
	for (int i=1;i<=n;i++)
		cout<<max(0,Max[i])<<" ";
	cout<<endl;
	exit(0);
}


void adjust(int n){
	for (int i=1;i<=n;i++)
		Max[i] = max(Max[i],temp[i]),temp[i] = -1e9;
}

void sub3(int n,int m){
	vector<pair<int,pair<int,int>>> E;
	for (int i=1;i<=m;i++){
		int a,b,c;
		cin>>a>>b>>c;
		E.push_back({c,{a,b}});
	}

	sort(begin(E),end(E));

	int lst = 0;

	for (auto [c,p] : E){
		if (c != lst)
			adjust(n);

		int A = p.first,B = p.second;
		temp[A] = max(temp[A],max(Max[A],Max[B] + 1));
		temp[B] = max(temp[B],max(Max[B],Max[A] + 1));
		lst = c;
	}
	adjust(n);
	for (int i=1;i<=n;i++)
		cout<<max(0,Max[i])<<" ";
	cout<<endl;
	exit(0);
}



int main(){
	int n,m;
	cin>>n>>m;

	for (int i=1;i<=n;i++)
		Max[i] = temp[i] = -1e9;
	Max[1] = 0;

	if (n <= 10 and m <= 15){
		sub1(n,m);
	}
	if (m == n-1){
		sub2(n,m);
	}
	if (n <= 1000 and m <= 10000)
		sub3(n,m);

	vector<pair<int,pair<int,int>>> E;

	for (int i=1;i<=m;i++){
		int a,b,c;
		cin>>a>>b>>c;
		E.push_back({c,{a,b}});
	}

	sort(begin(E),end(E));

	for (auto [c,p] : E){
		int A = p.first,B = p.second;
		int k = Max[A];
		Max[A] = max(Max[A],Max[B] + 1);
		Max[B] = max(Max[B],k + 1);
	}

	for (int i=1;i<=n;i++)
		cout<<max(0,Max[i])<<" ";
	cout<<endl;
}





// 8 12
// 1 4 12
// 1 6 12
// 1 5 12
// 3 4  12
// 3 5  12
// 5 6 12
// 6 2 12
// 2 8 12
// 5 8 12
// 7 8 12
// 5 7  12
// 3 7  12
