#include <bits/stdc++.h>

using namespace std;

const int Max = 1e6;
int n, m, q, x, i, j, st, dr;
bitset<Max + 2> a[3002], tot;

static inline bool Verif(int poz) {
    return ((tot & a[poz]) != a[poz]);
}

static inline bool Calc() {
    cin >> st >> dr;

    tot = 0;
    for(i = st; i <= dr; i++) tot |= a[i];

    st--;
    dr++;

    while(1 <= st && dr <= n) {
        /// verific daca ambi merg
        if(!Verif(st) || !Verif(dr)) return false;

        int c1 = a[st].count() - (tot & a[st]).count();
        int c2 = a[dr].count() - (tot & a[dr]).count();

        if(c1 < c2) st--;
        else dr++;
    }

    while(1 <= st) {
        if(!Verif(st)) return false;
        st--;
    }

    while(dr <= n) {
        if(!Verif(dr)) return false;
        dr++;
    }
    return true;
}

int main() {
    cin >> n;
    for(i = 1; i <= n; i++) {
        cin >> m;
        for(j = 1; j <= m; j++) {
            cin >> x;
            a[i][x] = 1;
        }
    }

    cin >> q;
    while(q--) cout << Calc() << "\n";

    return 0;
}
