//#define RCode
#ifndef RCode
#include "twins.h"
#endif // RCode

using namespace std;

static inline vector<int> Solve(int st, int dr) {
    if(st == dr) return {st};
    else {
        int mij = st + (dr - st) / 2;

        vector<int> pozSt, pozDr;
        for(int i = st; i <= mij; i++) pozSt.push_back(i);
        for(int i = mij + 1; i <= dr; i++) pozDr.push_back(i);

        vector<vector<int>> query = {pozSt, pozDr};
        string pozeQuery = guess(query);

        vector<int> q1, q2;
        if(pozeQuery[0] == '1') q1 = Solve(st, mij); /// numai la stanga
        if(pozeQuery[1] == '1') q2 = Solve(mij + 1, dr); /// numai la dreapta

        vector<int> ret;
        for(auto it : q1) ret.push_back(it);
        for(auto it : q2) ret.push_back(it);
        return ret;
    }
}

static inline vector<int> play(int n, int t) {
    return Solve(1, n);
}
