#include <bits/stdc++.h>
#define int long long
using namespace std;
using pii = pair<int, int>;
using edge = tuple<int, int, int>;
const int NMAX = 1e5+2;
int n,m,dist[NMAX];
vector<pii> v[NMAX];

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;
    vector<edge> edges;
    for(int i = 1; i <= m; i++){
        int x, y, z;
        cin >> x >> y >> z;
        v[x].push_back({y, z});
        v[y].push_back({x, z});
        edges.push_back({z, x, y});
    }
    sort(edges.begin(), edges.end());
    for(int i = 1; i <= n; i++){
        dist[i] = -1;
    }
    dist[1] = 0;
    for(auto [cost, x, y]: edges){
        int prevdistx = dist[x], prevdisty = dist[y];
        dist[x] = max(dist[x], 1 + prevdisty);
        dist[y] = max(dist[y], 1 + prevdistx);
    }
    for(int i = 1; i <= n; i++){
        cout << dist[i] << " ";
    }
    return 0;
}
