#include <iostream>
#include <queue>
#include <vector>
#define MASK (1024*128-1)
#define MAXN 100000

using namespace std;

typedef struct Node{
    vector<int> to;
    vector<int> time;
    int maxD;
}Node;
Node v[MAXN];
int dMax[MAXN];
priority_queue<unsigned long long, vector<unsigned long long>, greater<unsigned long long> > q;


int main()
{
    int node,time,n,m,i,a,b,c,d;
    cin>>n>>m;
    for(i=0; i<m; i++){
        cin>>a>>b>>c;
        a--;
        b--;
        v[a].to.push_back(b);
        v[a].time.push_back(c);
        v[b].to.push_back(a);
        v[b].time.push_back(c);
    }
    for(i=0; i<(int)v[0].to.size(); i++){
        q.push(((unsigned long long)v[0].to[i]<<17)+((unsigned long long)v[0].time[i]<<34)+1);
    }
    while(!q.empty()){
        d=(q.top()&MASK);
        node=((q.top()>>17)&MASK);
        if(d>dMax[node])
            dMax[node]=d;
        time=q.top()>>34;
        q.pop();
        for(i=0; i<(int)v[node].to.size(); i++){
            if((int)v[node].time[i]>time&&d+1>dMax[v[node].to[i]])
                q.push(((unsigned long long)v[node].to[i]<<17)+((unsigned long long)v[node].time[i]<<34)+d+1);
        }
    }
    for(i=0; i<n; i++)
        cout<<dMax[i]<<' ';
    return 0;
}
