#include<iostream>
#include <cassert>
#include "twins.h"

std::vector<int> play(int n,int T){
  if (T == 1) {
    int logN = 1;
    while ((1 << logN) < n) {
      logN++;
    }
    logN++;
    std::vector<std::vector<int>> q(logN);
    for (int j = 0; j < logN; j++) {
      for (int i = 1; i <= n; i++) {
        if ((i >> j) & 1) {
          q[j].push_back(i);
        }
      }
    }
    std::string s = guess(q);
    int answer = 0;
    for (int j = 0; j < logN; j++) {
      if (s[j] == '1') {
        answer |= (1 << j);
      }
    }
    assert(1 <= answer && answer <= n);
    return {answer};
  }
}
