#include <iostream>
#include <cassert>
#include "twins.h"

std::vector<int> play(int n,int T){
  if (T == 1) {
    int logN = 1;
    while ((1 << logN) < n) {
      logN++;
    }
    logN++;
    std::vector<std::vector<int>> q(logN);
    for (int j = 0; j < logN; j++) {
      for (int i = 1; i <= n; i++) {
        if ((i >> j) & 1) {
          q[j].push_back(i);
        }
      }
    }
    std::string s = guess(q);
    int answer = 0;
    for (int j = 0; j < logN; j++) {
      if (s[j] == '1') {
        answer |= (1 << j);
      }
    }
    assert(1 <= answer && answer <= n);
    return {answer};
  } else {
    int logN = 1;
    while ((1 << logN) < n) {
      logN++;
    }
    logN++;
    std::vector<std::vector<int>> q(2 * logN);
    for (int j = 0; j < logN; j++) {
      for (int i = 1; i <= n; i++) {
        if ((i >> j) & 1) {
          q[j].push_back(i);
        }
      }
    }
    for (int j = 0; j < logN; j++) {
      for (int i = 1; i <= n; i++) {
        if (!((i >> j) & 1)) {
          q[j + logN].push_back(i);
        }
      }
    }
    std::string s = guess(q);
    int v1 = 0, v2 = 0;
    for (int j = logN - 1; j >= 0; j--) {
      if (s[j] != s[j + logN]) {
        if (s[j] == '1') {
          v1 |= (1 << j);
          v2 |= (1 << j);
        }
      } else {
        v2 |= (1 << j);
        v1 = v2 - 1;
        return {v1, v2};
      }
    }
  }
}
