#include <iostream>
#include <cassert>
#include "twins.h"

std::vector<int> play(int n,int T) {
  auto t1 = [&] (std::vector<int> cand) {
    int n = (int) cand.size();
    int logN = 1;
    while ((1 << logN) < n) {
      logN++;
    }
    logN++;
    std::vector<std::vector<int>> Q(logN);
    for (int j = 0; j < logN; j++) {
      for (int i = 0; i < n; i++) {
        if ((i >> j) & 1) {
          Q[j].push_back(cand[i]);
        }
      }
    }
    std::string str = guess(Q);
    int ret = 0;
    for (int j = 0; j < logN; j++) {
      if (str[j] == '1') {
        ret |= (1 << j);
      }
    }
    return std::vector<int>{cand[ret]};
  };
  if (T == 1) {
    std::vector<int> all;
    for (int i = 1; i <= n; i++) {
      all.push_back(i);
    }
    return t1(all);
  } else {
    std::vector<std::vector<int>> q;
    int l = 1, r = n;
    while (l < r) {
      int mid = (l + r) / 2;
      q.clear();
      q.push_back({});
      for (int i = 1; i <= mid; i++) {
        q.back().push_back(i);
      }
      if (guess(q) == "1") {
        r = mid;
      } else {
        l = mid + 1;
      }
    }

    int logN = 1;
    while ((1 << logN) < n) {
      logN++;
    }
    logN++;

    int p1 = r;
    q.clear();
    std::vector<int> cand;
    for (int i = p1 + 1; i <= n; i++) {
      cand.push_back(i);
    }

    std::vector<int> answer = t1(cand);
    answer.push_back(p1);
    std::swap(answer[0], answer[1]);
    return answer;
  }
}
