#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>
#warning That's not AS, that's my AS

typedef long long ll;

const int NMAX = 1e5;
const int MMAX = 1e6;

struct Edge {
  int u, v, w;
  bool operator < (const Edge &other) const {
    return w < other.w;
  };
};

std::vector<std::pair<int, int>> update[MMAX + 1];

int dp[NMAX + 1];
int newDp[NMAX + 1];

int main() {
  int n, m;
  std::cin >> n >> m;
  std::vector<int> norm;
  std::vector<Edge> e(m);
  for (auto &[u, v, w] : e) {
    std::cin >> u >> v >> w;
    norm.push_back(w);
  }
  std::sort(e.begin(), e.end());
  std::sort(norm.begin(), norm.end());
  norm.erase(std::unique(norm.begin(), norm.end()), norm.end());

  for (auto &[u, v, w] : e) {
    w = std::lower_bound(norm.begin(), norm.end(), w) - norm.begin() + 1;
    update[w].push_back({u, v});
  }

  int k = (int) norm.size();
  for (int i = 1; i <= k; i++) {
    for (const auto &[u, v] : update[i]) {
      newDp[u] = std::max(newDp[u], dp[v] + 1);
      newDp[v] = std::max(newDp[v], dp[u] + 1);
    }
    for (int i = 1; i <= n; i++) {
      dp[i] = newDp[i];
    }
  }

  for (int i = 1; i <= n; i++) {
    std::cout << dp[i] << ' ';
  }

  return 0;
}
