// sol
#include "twins.h"
#include <bits/stdc++.h>

using namespace std;

int n, t;
vector<int> ans;

bool check(int st, int dr)
{
    vector<vector<int>> v;
    v.resize(1);
    for(int i=st; i<=dr; i++)   
        v[0].push_back(i);
    if(guess(v) == "1") 
        return 1;
    return 0;
}

void divide(int st, int dr)
{
    if(st == dr)
    {
        if(check(st, st))
            ans.push_back(st);
        return;
    }
    int mid=(st+dr)/2;
    if(check(st, mid))
        divide(st, mid);
    if(check(mid+1, dr))
        divide(mid+1, dr);
}

vector<int> play(int N, int T)
{
    n=N;
    t=T;
    if(t == 1)
    {
        int st=0, dr=n+1;
        while(st+1 < dr)
        {
            int mid=(st+dr)/2;
            vector<vector<int>> v;
            v.resize(1);
            for(int i=1; i<=mid; i++)
                v[0].push_back(i);
            if(guess(v) == "1")
            {
                dr=mid;
            }
            else
                st=mid;
        }
        return {dr};
    }
    divide(1, n);
    return ans;
}