#include <bits/stdc++.h>

using namespace std;

const int MAXN=1e5+5;

const int INF=1e9;

int n, m;
vector<pair<int, int>> adj[MAXN]; // first cost, second adj
unordered_map<int, int> adp[MAXN]; // poz fiecarei muchii
vector<int> dp[MAXN];
vector<bool> imp[MAXN]; // daca este imposibil din nodul i daca o iei pe muchia j sa ajungi la 1

int dfs(int u, int c) // muchia curenta, costul muchiei de pe care am venit
{
    int p=adp[u][c];
    // cout<<u<<' '<<c<<' '<<dp[u][p]<<'\n';
    if(dp[u][p] >= 0 || imp[u][p])
    {
        return dp[u][p];
    }
    int best=-INF;
    if(u == 1)
        best=-1; // base case
    int p0=p;
    for(int i=0; i<p; i++)
    {
        int v=adj[u][i].second;
        c=adj[u][i].first;
        best=max(best, dfs(v, c));
    }
    dp[u][p0]=best+1;
    if(dp[u][p0] < 0)
        imp[u][p0]=true;
    //cout<<u<<' '<<p0<<' '<<dp[u][p0]<<'\n';
    return dp[u][p0];
}

int32_t main()
{
    cin>>n>>m;
    int u, v, c;
    for(int i=1; i<=m; i++)
    {
        cin>>u>>v>>c;
        adj[u].push_back({c, v});
        adj[v].push_back({c, u});
    }
    // cout<<'\n';
    for(int i=1; i<=n; i++)
    {
        sort(adj[i].begin(), adj[i].end());
        for(int j=0; j<adj[i].size(); j++)
        {
            adp[i][adj[i][j].first]=j;
            dp[i].push_back(-INF);
            imp[i].push_back(false);
        }
    }
    // dfs(6, 6);
    // cout<<dp[6][2];
    // // cout<<dp[1][1];
    // return 0;
    for(int i=1; i<=n; i++)
    {
        for(int j=0; j<adj[i].size(); j++)
        {
            v=adj[i][j].second, c=adj[i][j].first;
            int bruh=adp[v][c];
            // cout<<i<<' '<<j<<' '<<c<<'\n';
            dp[v][bruh]=max(dp[v][bruh], dfs(v, c));
        }
    }
    for(int i=1; i<=n; i++)
    {
        int best=-INF;
        for(int j=0; j<adj[i].size(); j++)
        {
            v=adj[i][j].second, c=adj[i][j].first;
            int bruh=adp[v][c];
            best=max(best, dp[v][bruh]+1);
        }
        if(best <= 0)
            cout<<0<<' ';
        else
            cout<<best<<' '; 
    }
    return 0;
}