#include <bits/stdc++.h>
#define int long long

using namespace std;

const int MAXN=1e5+5;

const int INF=1e9;

int n, m;
vector<pair<int, int>> adj[MAXN]; // first cost, second adj
unordered_map<int, int> adp[MAXN]; // poz fiecarei muchii
unordered_map<int, unordered_map<int, int>> dp;
unordered_map<int, unordered_map<int, bool>> imp;

int dfs(int u, int c) // muchia curenta, costul muchiei de pe care am venit
{
    // cout<<u<<' '<<c<<' '<<dp[u][p]<<'\n';
    if(dp[u][c] >= 0 || imp[u][c])
    {
        return dp[u][c];
    }
    int best=-INF;
    if(u == 1)
        best=-1; // base case
    int c0=c;
    for(int i=0; i<adj[u].size(); i++)
    {
        int v=adj[u][i].second;
        c=adj[u][i].first;
        if(c >= c0)
            continue;
        best=max(best, dfs(v, c));
    }
    dp[u][c0]=best+1;
    if(dp[u][c0] < 0)
        imp[u][c0]=true;
    //cout<<u<<' '<<p0<<' '<<dp[u][p0]<<'\n';
    return dp[u][c0];
}

int32_t main()
{
    cin>>n>>m;
    int u, v, c;
    for(int i=1; i<=m; i++)
    {
        cin>>u>>v>>c;
        adj[u].push_back({c, v});
        adj[v].push_back({c, u});
    }
    // cout<<'\n';
    for(int i=1; i<=n; i++)
    {
        sort(adj[i].begin(), adj[i].end());
        for(int j=0; j<adj[i].size(); j++)
        {
            c=adj[i][j].first;
            dp[i][c]=-INF;
        }
    }
    // dfs(6, 6);
    // cout<<dp[6][2];
    // // cout<<dp[1][1];
    // return 0;
    for(int i=1; i<=n; i++)
    {
        for(int j=0; j<adj[i].size(); j++)
        {
            v=adj[i][j].second, c=adj[i][j].first;
            dp[v][c]=max(dp[v][c], dfs(v, c));
        }
    }
    for(int i=1; i<=n; i++)
    {
        int best=-INF;
        for(int j=0; j<adj[i].size(); j++)
        {
            v=adj[i][j].second, c=adj[i][j].first;
            best=max(best, dp[v][c]+1);
        }
        if(best <= 0)
            cout<<0<<' ';
        else
            cout<<best<<' '; 
    }
    return 0;
}