#include <bits/stdc++.h>
#define int long long

using namespace std;

const int MAXN=1e5+5;

const int INF=1e9;

int n, m;
vector<pair<int, int>> adj[MAXN]; // first cost, second adj
unordered_map<int, int> adp[MAXN]; // poz fiecarei muchii
unordered_map<int, unordered_map<int, int>> dp;
unordered_map<int, unordered_map<int, bool>> imp;

bool visited[MAXN];

int dfs(int u, int c) // muchia curenta, costul muchiei de pe care am venit
{
    // cout<<u<<' '<<c<<' '<<dp[u][p]<<'\n';
    if(dp[u][c] >= 0 || imp[u][c])
    {
        return dp[u][c];
    }
    int best=-INF;
    if(u == 1)
        best=-1; // base case
    int c0=c;
    for(int i=0; i<adj[u].size(); i++)
    {
        int v=adj[u][i].second;
        c=adj[u][i].first;
        if(c >= c0)
            continue;
        best=max(best, dfs(v, c));
    }
    dp[u][c0]=best+1;
    if(dp[u][c0] < 0)
        imp[u][c0]=true;
    //cout<<u<<' '<<p0<<' '<<dp[u][p0]<<'\n';
    return dp[u][c0];
}
int maximm[MAXN];

void solve(int i)
{
    int v, c;
    for(int j=0; j<adj[i].size(); j++)
    {
        v=adj[i][j].second, c=adj[i][j].first;
        dp[v][c]=max(dp[v][c], dfs(v, c));
    }
}

vector<pair<int, pair<int, int>>> much;

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
         cin>>n>>m;
    if(n > 1000)
    {
    cin>>n>>m;
    int u, v, c;
    for(int i=1; i<=m; i++)
    {
        cin>>u>>v>>c;
        much.push_back({c, {u, v}});
        adj[u].push_back({c, v});
        adj[v].push_back({c, u});
    }
    // cout<<'\n';
    for(int i=1; i<=n; i++)
    {
        sort(adj[i].begin(), adj[i].end());
        for(int j=0; j<adj[i].size(); j++)
        {
            c=adj[i][j].first;
            dp[i][c]=-INF;
        }
    }
    for(int i=2; i<=n; i++)
        maximm[i]=-INF;
    // dfs(6, 6);
    // cout<<dp[6][2];
    // // cout<<dp[1][1];
    // return 0;
    sort(much.begin(), much.end());
    cout<<'\n';
    for(pair<int, pair<int, int>> pr:much)
    {
        int c=pr.first;
        int u=pr.second.first;
        int v=pr.second.second;
        dp[u][c]=maximm[u]+1;
        dp[v][c]=maximm[v]+1;
        //cout<<u<<' '<<v<<' '<<c<<' '<<dp[u][c]<<'\n';
        maximm[v]=max(maximm[v], dp[u][c]);
        maximm[u]=max(maximm[u], dp[v][c]);
    }
    for(int i=1; i<=n; i++)
    {
        int best=maximm[i];
        /*for(int j=0; j<adj[i].size(); j++)
        {
            v=adj[i][j].second, c=adj[i][j].first;
            best=max(best, dp[v][c]+1);
        }*/
        if(best <= 0)
            cout<<0<<' ';
        else
            cout<<best<<' ';
    }
    }
    int u, v, c;
    for(int i=1; i<=m; i++)
    {
        cin>>u>>v>>c;
        much.push_back({c, {u, v}});
        adj[u].push_back({c, v});
        adj[v].push_back({c, u});
    }
    // cout<<'\n';
    for(int i=1; i<=n; i++)
    {
        sort(adj[i].begin(), adj[i].end());
        for(int j=0; j<adj[i].size(); j++)
        {
            c=adj[i][j].first;
            dp[i][c]=-INF;
        }
    }
    // dfs(6, 6);
    // cout<<dp[6][2];
    // // cout<<dp[1][1];
    // return 0;
    sort(much.begin(), much.end());
    for(pair<int, pair<int, int>> pr:much)
    {
        int c=pr.first;
        int u=pr.second.first;
        int v=pr.second.second;
        dfs(u, c);
        dfs(v, c);
    }
    for(int i=1; i<=n; i++)
    {
        int best=-INF;
        for(int j=0; j<adj[i].size(); j++)
        {
            v=adj[i][j].second, c=adj[i][j].first;
            best=max(best, dp[v][c]+1);
        }
        if(best <= 0)
            cout<<0<<' ';
        else
            cout<<best<<' ';
    }
    return 0;
}
