#include <iostream>
#include <vector>

using namespace std;

const int nmax = 500005;
vector<int> a[nmax];
int n, q, fr1[1000005], x, y;
char sol[nmax];

bool verif(int k)
{
    for(int j = 1; j <= n; j ++)
        for(int t = 0; t < a[j].size(); t ++)
            fr1[a[j][t]] = 0;

    for(int z = x + 1; z <= y - 1; z ++)
        for(int j = 0; j < a[z].size(); j ++)
            fr1[a[z][j]] = 1;

    bool d = true; int cx = x, cy = y;
    for(int i = 1; i <= k - 1; i ++)
    {
        if(sol[i] == 'x')
        {
            d = false;
            for(int j = 0; j < a[cx].size(); j ++)
                if(!fr1[a[cx][j]])
                    fr1[a[cx][j]] = 1, d = true;

            if(!d)
                return false;

            cx --;
        }

        else
        {
            d = false;
            for(int j = 0; j < a[cy].size(); j ++)
                if(!fr1[a[cy][j]])
                    fr1[a[cy][j]] = 1, d = true;

            if(!d)
                return false;

            cy ++;
        }
    }

    return true;
}

void chance(int p1, int p2, int poz, bool &ok)
{
    if(p1 < 1 && p2 > n)
    {
        if(verif(poz))
            ok = true;
    }

    else if(!ok)
    {
        if(p1 >= 1)
        {
            sol[poz] = 'x';
            chance(p1 - 1, p2, poz + 1, ok);
        }

        if(p2 <= n)
        {
            sol[poz] = 'y';
            chance(p1, p2 + 1, poz + 1, ok);
        }
    }
}

int main()
{
    cin >> n;
    for(int i = 1; i <= n; i ++)
    {
        int k; cin >> k;
        for(int j = 1; j <= k; j ++)
        {
            int x; cin >> x;
            a[i].push_back(x);
        }
    }

    cin >> q;
    for(int i = 1; i <= q; i ++)
    {
        cin >> x >> y;

        x --; y ++; bool ok = false;
        chance(x, y, 1, ok);

        cout << (ok == true ? 1 : 0) << '\n';
    }
    return 0;
}
