#include <bits/stdc++.h>
using namespace std;

#define MAXN 100000

vector<int> adj[MAXN];
vector<int> cost[MAXN];
int rez[MAXN];
char vis[MAXN];
int nr[MAXN];

void dfs(int nod, int depth, int prev) {
  int i;

  vis[nod] = 1;
  rez[nod] = depth;
  for(i = 0; i < nr[nod]; i++)
    if(!vis[adj[nod][i]] && cost[nod][i] > prev)
      dfs(adj[nod][i], depth + 1, cost[nod][i]);
}

int main() {
  int n, m, i, a, b, c;

  scanf("%d%d", &n, &m);
  for(i = 0; i < m; i++) {
    scanf("%d%d%d", &a, &b, &c);
    a--;
    b--;

    adj[a].push_back(b);
    cost[a].push_back(c);

    adj[b].push_back(a);
    cost[b].push_back(c);

    nr[a]++;
    nr[b]++;
  }

  dfs(0, 0, -1);

  for(i = 0; i < n; i++) {
    printf("%d ", rez[i]);
  }
  printf("\n");

  return 0;
}
